--define stuff
	
TARO_BONE_TWEEN_TIME = 2 --how long it takes for a bone to travel across the screen
TARO_BONE_TWEEN_TIME_VARIANCE = 1 --how much variation in the bone timing
TARO_NUM_BONES_PER_STEP = 2 --how many bones per step
t_bs_START_BEAT = 8 --when do we throw bones
TARO_MIN_DELAY_BETWEEN_BONES = 0.2 --(in seconds) prevent there from being too many bones.... can be 0 though
TARO_VERTICAL_BONES = true --do we want the up and down bones as well as the side to side ones?

LoadActor("mods.lua")

local function sans_mod_internal(str, pn)
	taronuke_mods(str,pn)
end

local function sans_mod(str)
	for i=1,2 do
		sans_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

sans_updown = 9-.6;
sans_updown2 = 9+64-.6;
sans_updf = 1;

P1 = nil
P2 = nil
checked = false;

--control when to change the params
--any params can change at any beat

sans_bsmove = 8;
sans_bsmove2 = 8+64;
sans_ass = 1;

sans_rot = 1;

taro_bone_changes = {

	{0,function()
		local s = char_sans;
		s:x(SCREEN_CENTER_X);
		s:y(SCREEN_CENTER_Y+100);
		s:playcommand('Spawn');
	end},
	
	{4,function()
		local s = char_sans;
		Sound('cast.ogg');
		s:playcommand('Cast');
	end},
	
	{8,function() MESSAGEMAN:Broadcast('WhiteFlash'); end},
	{8+64,function() MESSAGEMAN:Broadcast('WhiteFlash'); end},
	{20,function() MESSAGEMAN:Broadcast('Ass'); end},
	{36,function() MESSAGEMAN:Broadcast('Ass'); end},
	{20+64,function() MESSAGEMAN:Broadcast('Ass'); end},
	{36+64,function() MESSAGEMAN:Broadcast('Ass'); end},
	
	{48,function()
		TARO_NUM_BONES_PER_STEP = 1
		TARO_MIN_DELAY_BETWEEN_BONES = 0.6
	end},
	
	{72,function()
		TARO_NUM_BONES_PER_STEP = 2
		TARO_MIN_DELAY_BETWEEN_BONES = 0.4
	end},
	
	{136,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		MESSAGEMAN:Broadcast('BoneZone');
		local s = char_sans;
		s:playcommand('HideQ');
		
		TARO_NUM_BONES_PER_STEP = 3
		TARO_MIN_DELAY_BETWEEN_BONES = 0.4
		
		local d = 1;
		for pn=1,2 do
			if pn == 2 then d = -1 end
			local a = _G['P'..pn]
			if a then
				a:wag();
				a:effectperiod(4);
				a:effectmagnitude(0,0,30*d);
				a:effectclock('bgm');
			end
		end
		
	end},
	
	{172,function()
		--GAMESTATE:ApplyGameCommand('mod,*1.5 150 wave, *1 drunk');
		sans_mod('*1.5 150 wave, *1 drunk')
		
		local d = 1;
		for pn=1,2 do
			if pn == 2 then d = -1 end
			local a = _G['P'..pn]
			if a then
				a:wag();
				a:effectperiod(4);
				a:effectmagnitude(0,0,60*d);
				a:effectclock('bgm');
			end
		end
		
		TARO_NUM_BONES_PER_STEP = 4
		TARO_MIN_DELAY_BETWEEN_BONES = 0.4
		
	end},
	
	{200,function()
		TARO_NUM_BONES_PER_STEP = 6;
		
		MESSAGEMAN:Broadcast('WhiteFlash');
		MESSAGEMAN:Broadcast('HardZone');
		
		local d = 1;
		for pn=1,2 do
			if pn == 2 then d = -1 end
			local a = _G['P'..pn]
			if a then
				a:wag();
				a:effectperiod(4);
				a:effectmagnitude(0,0,90*d);
				a:effectclock('bgm');
			end
		end
		
	end},
	
	{228,function()
		TARO_NUM_BONES_PER_STEP = 0
	end},
	
	{232,function()
		MESSAGEMAN:Broadcast('BonesAway');
		MESSAGEMAN:Broadcast('WhiteFlashQ');
		local p = 0.25;
		for pn=1,2 do
			local a = _G['P'..pn]
			if pn == 2 then p = 0.75 end
			if a then
				a:stopeffect();
				a:finishtweening();
				a:y(SCREEN_HEIGHT/2);
				a:x(SCREEN_WIDTH*p);
				a:accelerate(2);
				a:rotationz(360*10);
				a:zoom(0);
			end
		end
	end},
}

for i=40-.6,67-.6,1 do
	table.insert(taro_bone_changes,{i,'Rot'});
end
for i=40+64-.6,67+64-.6,1 do
	table.insert(taro_bone_changes,{i,'Rot'});
end

for i=199.7,231.5,.5 do
	table.insert(taro_bone_changes,{i,function() GasterSound('gaster_fire') end});
end

s_gasterang = 0;
s_gasterbeat = 196;







function Sound(str)
	local songName = GAMESTATE:GetCurrentSong():GetSongDir();
	SOUND:PlayOnce(songName..'lua/sounds/'..str);
end



function modtable_compare(a,b)
	return a[1] < b[1]
end

if table.getn(taro_bone_changes) > 1 then
	table.sort(taro_bone_changes, modtable_compare)
end




----------------------------------------------------
-------DO NOT TOUCH ANYTHING BELOW THIS POINT-------
----------------------------------------------------

taro_bone_cmd = 1;
taro_bone_delay = 0;
taro_bptr = 1
t_bs = {}

function taro_otherside(dir)
	if dir == 1 then return 4 end
	if dir == 2 then return 3 end
	if dir == 3 then return 2 end
	if dir == 4 then return 1 end
	return 0
end

function taro_between(n,a,b)
	if n >= a and n <= b then
		return true
	end
	return false
end

function taro_spawnbone()

	if GAMESTATE:GetSongBeat() > t_bs_START_BEAT and taro_bone_delay <= 0 and TARO_NUM_BONES_PER_STEP > 0 then
	
		taro_bone_delay = TARO_MIN_DELAY_BETWEEN_BONES
	
		for i=1,TARO_NUM_BONES_PER_STEP do
	
			local a = t_bs[taro_bptr]
			
			if a then
			
				a:visible(true);
				local rs = math.random(90,160)/100
				local rrz = math.random(0,360)
				local rsd = math.random(1,2);
				if rsd == 2 then rsd = -1 end
				a:basezoomx(rs);
				a:basezoomy(rs);
				
				a:rotationz(rrz);
				
				local rdir = math.random(1,100)
				local dir = 1
				
				if TARO_VERTICAL_BONES then
					if taro_between(rdir,1,30) then dir = 1 end
					if taro_between(rdir,31,50) then dir = 2 end
					if taro_between(rdir,51,70) then dir = 3 end
					if taro_between(rdir,71,100) then dir = 4 end
				else
					if taro_between(rdir,1,50) then dir = 1 end
					if taro_between(rdir,51,100) then dir = 4 end
				end
				
				local spos = {-150,-150,SCREEN_HEIGHT+150,SCREEN_WIDTH+150}
				
				if dir == 1 or dir == 4 then
					a:x(spos[dir])
					a:y(math.random(50,SCREEN_HEIGHT-50))
					a:linear(math.max(((SCREEN_WIDTH/SCREEN_HEIGHT)*TARO_BONE_TWEEN_TIME)+((math.random(TARO_BONE_TWEEN_TIME_VARIANCE*-50,TARO_BONE_TWEEN_TIME_VARIANCE*50))/100),0.1))
					a:x(spos[taro_otherside(dir)]);
				else
					a:y(spos[dir])
					a:x(math.random(50,SCREEN_WIDTH-50))
					a:linear(math.max(TARO_BONE_TWEEN_TIME+((math.random(TARO_BONE_TWEEN_TIME_VARIANCE*-100,TARO_BONE_TWEEN_TIME_VARIANCE*100))/100),0.1))
					a:y(spos[taro_otherside(dir)]);
				end
				
				a:rotationz(rrz+(720*rsd))
				a:queuecommand('Hide');
			end
			
			taro_bptr = taro_bptr+1
			if taro_bptr > table.getn(t_bs) then
				taro_bptr=1;
			end
			
		end
	
	end
	
end

return Def.ActorFrame{

	Def.Quad{ OnCommand=cmd(visible,false;sleep,1000;),},
	
	--the majority of our code is contained in this object--
	Def.Quad{
	InitCommand=function(self)
	
	end;
	OnCommand=cmd(visible,false;),},
	
	--send messages on step--
	Def.Quad{
		OnCommand=cmd(visible,false;),
		StepP1MessageCommand=function(self) taro_spawnbone() end;
		StepP2MessageCommand=function(self) taro_spawnbone() end;
	},
	
	--bone delay controller--
	Def.Quad{
		OnCommand=cmd(queuecommand,"Update";),
		UpdateCommand=function(self)
		
			local beat = GAMESTATE:GetSongBeat()
			
			if beat > 0 and not checked then
				P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				checked = true;
			end
			
			if beat > 136 and beat < 232 then
				local d = 1;
				for pn=1,2 do
					if pn == 2 then d = -1 end
					local a = _G['P'..pn]
					if a then
						a:x(SCREEN_CENTER_X+((SCREEN_WIDTH*0.25)*d*math.sin(beat*math.pi*0.25)))
					end
				end
			end
		
			if taro_bone_cmd <= table.getn(taro_bone_changes) and beat > taro_bone_changes[taro_bone_cmd][1] then
				--Trace('Change '..taro_bone_cmd);
				if beat < taro_bone_changes[taro_bone_cmd][1]+5 then
					if type(taro_bone_changes[taro_bone_cmd][2]) == 'function' then
						taro_bone_changes[taro_bone_cmd][2]()
					elseif type(taro_bone_changes[taro_bone_cmd][2]) == 'string' then
						MESSAGEMAN:Broadcast(taro_bone_changes[taro_bone_cmd][2]);
					end
				end
				taro_bone_cmd = taro_bone_cmd+1;
			end
			
			if beat > sans_updown and beat < 35 and sans_updown < 35 then
				if beat < 19 or beat > 24 and beat < 35 then
					char_sans:playcommand('EyeCast');
					if sans_updf == 1 then
						char_sans:playcommand('SlamDown');
					else
						char_sans:playcommand('SlamUp');
					end
					sans_updf = sans_updf*-1;
				end
				sans_updown = sans_updown+1;
			end
			
			if beat > s_gasterbeat and beat < 228.25 then
			
				local a = GetNewGaster();
				a:rotationz(math.deg(s_gasterang));
				a:zoom(1);
				a:x(SCREEN_CENTER_X+(1000*(SCREEN_WIDTH/640)*math.sin(s_gasterang)));
				a:y(SCREEN_CENTER_Y-(1000*math.cos(s_gasterang)));
				a:decelerate(0.5);
				a:x(SCREEN_CENTER_X+(220*(SCREEN_WIDTH/640)*math.sin(s_gasterang)));
				a:y(SCREEN_CENTER_Y-(220*math.cos(s_gasterang)));
				a:rotationz(720+math.deg(s_gasterang));
				a:sleep(0.5);
				a:rotationz(math.deg(s_gasterang));
				a:queuecommand('Fire');
				a:sleep(0.25)
				a:accelerate(0.5)
				a:x(SCREEN_CENTER_X+(1000*(SCREEN_WIDTH/640)*math.sin(s_gasterang)));
				a:y(SCREEN_CENTER_Y-(1000*math.cos(s_gasterang)));
				a:sleep(2); a:queuecommand('Done');
				
				s_gasterang = s_gasterang+(math.pi/8);
				s_gasterbeat = s_gasterbeat+0.5
			end
			
			if beat > sans_bsmove and beat < 36 and sans_bsmove < 36 then
				if sans_bsmove < 20 or sans_bsmove > 24 and sans_bsmove < 36 then
					local d = 1
					local p = 0.25;
					for pn=1,2 do
						if pn == 2 then d = -1; p = 0.75; end
						if sans_ass == -1 then
							if pn == 1 then p = 0.75; end
							if pn == 2 then p = 0.25; end
						end
						local a = _G['P'..pn]
						if a then
							a:linear(0.125);
							a:x(math.random(-50,50)+(SCREEN_WIDTH*p));
							a:y(math.random(150,SCREEN_HEIGHT-150));
						end
					end
				end
				sans_bsmove = sans_bsmove+0.5
			end
			
			
			if beat > sans_updown2 and beat < 35+64 and sans_updown2 < 35+64 then
				if beat < 19+64 or beat > 24+64 and beat < 35+64 then
					char_sans:playcommand('EyeCast');
					if sans_updf == 1 then
						char_sans:playcommand('SlamDown');
					else
						char_sans:playcommand('SlamUp');
					end
					sans_updf = sans_updf*-1;
				end
				sans_updown2 = sans_updown2+1;
			end
			
			if beat > sans_bsmove2 and beat < 36+64 and sans_bsmove2 < 36+64 then
				if sans_bsmove2 < 20+64 or sans_bsmove2 > 24+64 and sans_bsmove2 < 36+64 then
					local d = 1
					local p = 0.25;
					for pn=1,2 do
						if pn == 2 then d = -1; p = 0.75; end
						if sans_ass == -1 then
							if pn == 1 then p = 0.75; end
							if pn == 2 then p = 0.25; end
						end
						local a = _G['P'..pn]
						if a then
							a:linear(0.125);
							a:x(math.random(-100,100)+(SCREEN_WIDTH*p));
							a:y(math.random(100,SCREEN_HEIGHT-100));
						end
					end
				end
				sans_bsmove2 = sans_bsmove2+0.5
			end
			
			if taro_bone_delay > 0 then
				taro_bone_delay = taro_bone_delay-0.02
			else
				taro_bone_delay = 0;
			end
			
			self:sleep(0.02)
			self:queuecommand('Update');
		end;
	},
	
	--bone pool--
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	LoadActor("BONEZONE")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"Set";), SetCommand=function(self) table.insert(t_bs,self) end; HideCommand=cmd(visible,false;), },
	
	LoadActor("chara"),
	
	LoadActor("BONE_ZONE")..{ InitCommand=cmd(visible,false;),
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_BOTTOM;bob;effectmagnitude,0,128,0;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;
	effectperiod,4;effectclock,"bgm";),
	BoneZoneMessageCommand=cmd(visible,true;y,SCREEN_BOTTOM;diffusealpha,1;),
	HardZoneMessageCommand=cmd(visible,false;),
	BonesAwayMessageCommand=cmd(linear,0.5;addy,256;sleep,0;diffusealpha,0;),
	},
	LoadActor("BONE_ZONE")..{ InitCommand=cmd(visible,false;),
	OnCommand=cmd(x,SCREEN_CENTER_X;y,0;bob;effectmagnitude,0,128,0;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;
	effectperiod,4;effectclock,"bgm";),
	BoneZoneMessageCommand=cmd(visible,true;y,0;diffusealpha,1;),
	HardZoneMessageCommand=cmd(visible,false;),
	BonesAwayMessageCommand=cmd(linear,0.5;addy,-256;sleep,0;diffusealpha,0;),
	},
	
	LoadActor("HARD_ZONE")..{ InitCommand=cmd(visible,false;),
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_BOTTOM;bob;effectmagnitude,0,128,0;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;
	effectperiod,4;effectclock,"bgm";),
	HardZoneMessageCommand=cmd(visible,true;y,SCREEN_BOTTOM;diffusealpha,1;),
	BonesAwayMessageCommand=cmd(linear,0.5;addy,256;sleep,0;diffusealpha,0;),
	},
	LoadActor("HARD_ZONE")..{ InitCommand=cmd(visible,false;),
	OnCommand=cmd(x,SCREEN_CENTER_X;y,0;bob;effectmagnitude,0,128,0;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;
	effectperiod,4;effectclock,"bgm";),
	HardZoneMessageCommand=cmd(visible,true;y,0;diffusealpha,1;),
	BonesAwayMessageCommand=cmd(linear,0.5;addy,-256;sleep,0;diffusealpha,0;),
	},	
	
	Def.Quad{
	RotMessageCommand=function(self)
		if sans_rot == 1 then
			char_sans:playcommand('SlamRight');
			sans_rot = sans_rot+1;
			for pn = 1,2 do
				local a = _G['P'..pn]
				if a then
					a:sleep(0.1);
					a:linear(0.1);
					a:rotationz(90);
				end
			end
		elseif sans_rot == 2 then
			char_sans:playcommand('SlamDown');
			sans_rot = sans_rot+1;
			for pn = 1,2 do
				local a = _G['P'..pn]
				if a then
					a:sleep(0.1);
					a:linear(0.1);
					a:rotationz(180);
				end
			end
		elseif sans_rot == 3 then
			char_sans:playcommand('SlamLeft');
			sans_rot = sans_rot+1;
			for pn = 1,2 do
				local a = _G['P'..pn]
				if a then
					a:sleep(0.1);
					a:linear(0.1);
					a:rotationz(270);
				end
			end
		elseif sans_rot == 4 then
			char_sans:playcommand('SlamUp');
			sans_rot = 1;
			for pn = 1,2 do
				local a = _G['P'..pn]
				if a then
					a:sleep(0.1);
					a:linear(0.1);
					a:rotationz(360);
					a:sleep(0);
					a:rotationz(0);
				end
			end
		end
	end;
	AssMessageCommand=function(self)
	
		char_sans:playcommand('Idle');
		char_sans:playcommand('HeadIdle');
		
		local d = 1
		for pn=1,2 do
			if pn==2 then d = -1 end
			local a = _G['P'..pn]
			if a then
				a:finishtweening();
				a:x(SCREEN_WIDTH*0.5+(SCREEN_WIDTH*-0.25*d*sans_ass))
				a:y(SCREEN_HEIGHT/2);
				a:decelerate(90/240);
				a:x(SCREEN_WIDTH*0.5+(SCREEN_WIDTH*-0.25*-d*sans_ass))
				a:y(SCREEN_HEIGHT/2);
				if GAMESTATE:GetSongBeat() > 72 then
					a:rotationz(360);
				else
					a:rotationy(360);
				end
				a:decelerate(90/240);
				a:x(SCREEN_WIDTH*0.5+(SCREEN_WIDTH*-0.25*d*sans_ass))
				a:y(SCREEN_HEIGHT/2);
				if GAMESTATE:GetSongBeat() > 72 then
					a:rotationz(0);
				else
					a:rotationy(0);
				end
				a:decelerate(90/240);
				a:x(SCREEN_WIDTH*0.5+(SCREEN_WIDTH*-0.25*-d*sans_ass))
				a:y(SCREEN_HEIGHT/2);
				if GAMESTATE:GetSongBeat() > 72 then
					a:rotationz(360);
					a:sleep(0);
					a:rotationz(0);
				else
					a:rotationy(360);
					a:sleep(0);
					a:rotationy(0);
				end
			end
		end
	
		MESSAGEMAN:Broadcast('WhiteFlashQ');
		self:sleep(0.375);
		self:queuemessage('WhiteFlashQ');
		self:sleep(0.375);
		self:queuemessage('WhiteFlashQ');
		
		sans_ass = -1*sans_ass
	end;
	},
	
	Def.Quad{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0;),
	WhiteFlashMessageCommand=cmd(diffuse,1,1,1,1;linear,1;diffusealpha,0;),
	WhiteFlashQMessageCommand=cmd(diffuse,1,1,1,0.5;linear,0.5;diffusealpha,0;),
	DarkMessageCommand=cmd(diffuse,0,0,0,1;sleep,0.25;diffusealpha,0;),
	},

}