songName = GAMESTATE:GetCurrentSong():GetSongDir();
	
function Sound(str)
	local songName = GAMESTATE:GetCurrentSong():GetSongDir();
	SOUND:PlayOnce(songName..'lua/sounds/'..str);
end

LoadActor("mods.lua")

local function l_mod_internal(str, pn)
	taronuke_mods(str,pn)
end

local function l_mod(str)
	for i=1,2 do
		l_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

m_bl = 60/146

l_save = {}

l_scoreP1 = 0
l_scoreP2 = 0

l_espd = m_bl*4;
l_scrollspd = 0;

e_aspect = SCREEN_WIDTH/640;
l_endfluct = 1

l_buff_score = 0.3;
l_aimfor = ''


return Def.ActorFrame{
InitCommand=function(self)


	
end,

	Def.Quad{
		InitCommand=cmd(visible,false;),
		OnCommand=cmd(sleep,1000;),
	},
	
	Def.Quad{
		InitCommand=cmd(visible,false;),
		OnCommand=function(self)
			fgcurcommand = 1;
			
			l_spinny = {36,48,24}
			
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			function list_compare(a,b)
				return a < b
			end
			
			checked = false;
			
			--laziness
			
			function perframe( beat, endBeat )
				if not endBeat then endBeat = beat+1 end
				local cur = GAMESTATE:GetSongBeat();
				if cur>=beat and cur<endBeat then return true end
				return false
			end
			
			--how can I make simple m0d?
			--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
			--it's a simple mod
			
			function simple_m0d(beat,strength,mult,mod)
				if not strength then strength = 400 end
				if not mult then mult = 1 end
				if not mod then mod = 'drunk' end
				
				local alive = math.max(2*mult*math.abs(strength)/100,0.25)
				
				table.insert(mods,{beat,0.1,'*100000 '..strength..' '..mod,'len'});
				table.insert(mods,{beat+.1,alive,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,'len'});
			end
			
			function simple_m0d2(beat,strength,mult,mod,pn)
				if not strength then strength = 400 end
				if not mult then mult = 1 end
				if not mod then mod = 'drunk' end
				
				local alive = math.max(2*mult*math.abs(strength)/100,0.25)
				
				table.insert(mods,{beat,0.3,'*'..math.abs(strength/10)..' '..strength..' '..mod,'len',pn});
				table.insert(mods,{beat+.3,alive,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,'len',pn});
			end
			
			function simple_m0d3(beat,strength,duration,bpm,mod)
				if not strength then strength = 400 end
				if not duration then duration = 1 end
				if not bpm then bpm = 120 end
				if not mod then mod = 'drunk' end
				
				local alive = duration * (60/bpm)
				local str = (1/(duration * 60/bpm)) * (math.abs(strength)/100)
				
				table.insert(mods,{beat-duration,duration,'*'..str..' '..strength..' '..mod,'len'});
				table.insert(mods,{beat,duration*1.1,'*'..str..' no '..mod,'len'});
			end
			
			--alternates a mod back and forth before resetting to 0
			--beat,num,div,amt,mod,pn
			function mod_wiggle(beat,num,div,amt,spdmult,mod,pn,first)
				local fluct = 1
				for i=0,(num-1) do
					b = beat+(i/div)
					local m = 1
					if i==0 and not first then m = 0.5 end
					table.insert(mods,{b,1,'*'..math.abs(spdmult*m*amt/10)..' '..(fluct*amt)..' '..mod..'','len',pn});
					fluct = fluct*-1;
				end
				table.insert(mods,{beat+(num/div),1,'*'..math.abs(spdmult*amt/20)..' no '..mod..'','len',pn});
			end
			
			--like wiggle, but springier
			--beat,strength,num,mod,pn
			function mod_spring(beat,strength,num,mod,pn)
				local fluct = 1;
				for i=0,num do
					if i==0 then mult = 0.5 else mult = 1 end
					local amt = (num-i)/num
					local b = beat+(0.05*i)
					
					table.insert(mods,{b,0.3,'*'..math.max(math.abs(1000*strength*mult*amt),1)..' '..(fluct*strength*amt)..' '..mod,'len',pn});
					
					fluct = fluct*-1;
				end
			end
			
			--beat,strength,num,period,mod,pn
			function mod_spring_adjustable(beat,strength,num,period,mod,pn, first)
				local fluct = 1;
				for i=0,num do
					if i==0 then mult = 0.5 else mult = 1 end
					local amt = (num-i)/num
					local b = beat+(period*0.5*i)
					
					local m = 1
					if i==0 and not first then m = 0.5 end
					
					table.insert(mods,{b,0.3,'*'..math.max(m*math.abs((0.2/period)*strength*mult*amt),1)..' '..(strength*amt)..' '..mod,'len',pn});
					
					fluct = fluct*-1;
				end
			end
			
			--turns on beat for the beat specified, at the desired strength	
			
			function mod_beato(b,s)
				if not s then s = 1000 end;
				table.insert(mods,{b-.5,1,'*10000 '..s..' beat','len'});
				table.insert(mods,{b+.5,0.25,'*10000 no beat','len'});
			end
			
			--[[
			switcheroos:
			1 = LDUR
			2 = RUDL
			3 = DLRU
			4 = LUDR
			5 = RDUL
			6 = DRLU
			7 = ULRD
			8 = URLD
			]]
			switcheroo_flip = 0;
			switcheroo_invert = 0;
			switcheroos = {{0,0},{100,0},{0,100},{25,-75},{75,75},{25,125},{75,-125},{100,-100}}
			function switcheroo_add(beat,which,speed,len,pn)

				if not speed then speed = 1000000 end

				if switcheroos[which] then

					local targf = switcheroos[which][1]
					local targi = switcheroos[which][2]
					local sw_modlist = ''
					if switcheroo_flip ~= targf then
						sw_modlist = sw_modlist..'*'..(0.01*speed*math.abs(targf-switcheroo_flip))..' '..(targf)..' flip,'
					end
					if switcheroo_invert ~= targi then
						sw_modlist = sw_modlist..'*'..(0.01*speed*math.abs(targi-switcheroo_invert))..' '..(targi)..' invert'
					end
					table.insert(mods,{beat,len,sw_modlist,'len',pn});
					
					Trace(sw_modlist);
					
					switcheroo_flip = targf;
					switcheroo_invert = targi;
				
				end
				
			end
			
			--clear all active mods turned on using mod_do() (see below)
			
			function mod_clr(pn)
				if pn then
					_G['init_modsp'..pn] = nil
				else
					for pn=1,2 do
						_G['init_modsp'..pn] = nil
					end
				end
			end
			
			--this will replace GAMESTATE:ApplyGameCommand() mods in fgchanges
			--for example
			--mod_do('*1000 150 beat',2) --turn on 150% beat for player 2
			
			function mod_do(str,pn)
				if pn then
					if str == 'clr' or str == 'clearasil' then
						mod_clr(pn);
						return;
					else
						if _G['init_modsp'..pn] == nil then
							_G['init_modsp'..pn] = str
						else
							_G['init_modsp'..pn] = _G['init_modsp'..pn]..','..str
						end
					end
				else
					if str == 'clr' or str == 'clearasil' then
						mod_clr()
						return
					else
						for pn=1,2 do
							--l_mod(''..str,pn);
							if _G['init_modsp'..pn] == nil then
								_G['init_modsp'..pn] = str
							else
								_G['init_modsp'..pn] = _G['init_modsp'..pn]..','..str
							end
						end
					end	
				end
			end
			
			
			init_modsp1 = '2x';
			init_modsp2 = '2x';
			
			mod_plr = {};
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat();
			
---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------


			--chara/background control!
			curcharaction = 1
			char_actions = {
				---------------------
				------SONG 1---------
				---------------------
				{64,function(self)
					char_ayaze:x(SCREEN_CENTER_X);
					char_ayaze:y(SCREEN_CENTER_Y);
					char_ayaze:queuecommand('Spawn');
				end,true},
				{87.6,'spell.ogg'},
				{88,'c_Cast'},
				{96,'c_Hide'},
				{123.6,'hurt.ogg'},
				{124,'c_SpawnQ'},
				{124.1,'c_Hurt'},
				{124,'RedFlashQ'},
				{124.1,function()
					char_ayaze:decelerate(m_bl*2);
					char_ayaze:rotationy(360);
					char_ayaze:sleep(m_bl);
					char_ayaze:rotationy(0);
					char_ayaze:sleep(0);
					char_ayaze:queuecommand('Hide');
				end},
				{155.6,'hurt.ogg'},
				{156,'c_SpawnQ'},
				{156.1,'c_Hurt'},
				{156,'RedFlashQ'},
				{156.1,function()
					char_ayaze:decelerate(m_bl*2);
					char_ayaze:rotationy(360);
					char_ayaze:sleep(m_bl);
					char_ayaze:rotationy(0);
					char_ayaze:sleep(0);
					char_ayaze:queuecommand('Hide');
				end},
				{194.1,'c_Spawn'},
				{194,'c_Idle'},
				{196,'c_Attack'},
				{202,'c_Idle'},
				{204,'c_Attack'},
				{220,'c_Idle'},
				{223.6,'spell.ogg'},
				{224,'c_Cast'},
				{228,'c_Hide'},
				
				{291.6,'hit.ogg'},
				{292,'c_SpawnQ'},
				{292.1,'c_Hurt'},
				{292,'RedFlash'},
				{292.1,function()
					char_ayaze:decelerate(m_bl*8);
					char_ayaze:rotationy(360*8);
					char_ayaze:sleep(m_bl*4);
					char_ayaze:rotationy(0);
					char_ayaze:sleep(0);
					char_ayaze:queuecommand('Hide');
				end},
				
				--[[
				{347.6,'spell.ogg'},
				{348,'c_Spawn'},
				{348.1,'c_Cast'},
				{356,'c_HideQ'},
				]]
				
				{548,'c_Spawn'},
				{548,'c_Idle'},
				
				{595.6,'spell.ogg'},
				{596,'c_Cast'},
				
				{608,function()
					char_ayaze:playcommand('Wat');
					char_ayaze:decelerate(0.3);
					char_ayaze:addx(-80);
					char_other:x(SCREEN_CENTER_X+80);
					char_other:y(SCREEN_CENTER_Y);
					char_other:playcommand('Spawn');
				end},
				{611,'c_Shrug'},
				{612,function()
					char_ayaze:playcommand('Attack');
					char_other:playcommand('Attack');
					char_ayaze:zoom(0.8);
					char_ayaze:addx(20);
					char_other:zoom(0.8);
					char_other:addx(-20);
					space_bg:playcommand('Show');
				end},
				{644,'WhiteFlash'},
				{675,function()
					char_other:playcommand('Hide');
				end},
				{676,function()
					space_bg:playcommand('Hide');
				end},
				
				{675.6,'hit.ogg'},
				{676,'c_Hurt'},
				{676,'RedFlash'},
				{676.1,function()
					char_ayaze:zoom(1);
					char_ayaze:x(SCREEN_CENTER_X);
					char_ayaze:decelerate(m_bl*8);
					char_ayaze:rotationy(360*8);
					char_ayaze:sleep(0);
					char_ayaze:rotationy(0);
					char_ayaze:sleep(0);
					char_ayaze:queuecommand('Hide');
				end},
				{739.6,'hurt.ogg'},
				{740,'c_SpawnQ'},
				{740.1,'c_Hurt'},
				{740,'RedFlashQ'},
				{740.1,function()
					char_ayaze:decelerate(m_bl*2);
					char_ayaze:rotationy(360);
					char_ayaze:sleep(m_bl);
					char_ayaze:rotationy(0);
					char_ayaze:sleep(0);
					char_ayaze:queuecommand('Hide');
				end},
				{771,'c_SpawnQ'},
				{771.1,'c_Attack'},
				{799.6,'hit.ogg'},
			}

			local l = 'len'
			local e = 'end'

			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
				{0,999,'overhead, no mini, no reverse, no centered, failoff','end'},
				{0,999,'*3 2.75x','end'},
				
				{0,8,'-1000 cover','end'},
				{8,999,'-1000 cover','end'},
				
				{612,676,'0 cover','end'},
				
				{0,4,'*10 alternate',e},
				{0.5,4,'*10 no alternate, *10 reverse',e},
				{1.5,4,'*10 -100 split',e},
				{2,4,'*10 no split, *10 no reverse',e},
				
				{4,1,'*10 invert',l},
				{4.5,1,'*10 no invert',l},
				{5.5,1,'*10 invert',l},
				{6,1,'*10 no invert',l},
				
				{8,12,'*10 cross',e},
				{8.5,12,'*10 no cross, *10 reverse',e},
				{9.5,12,'*10 -100 alternate',e},
				{10,12,'*10 no alternate, *10 no reverse',e},
				{12,16,'*10 cross',e},
				{12.5,16,'*10 no cross, *10 reverse',e},
				{13.5,16,'*10 -100 alternate',e},
				{14,16,'*10 no alternate, *10 no reverse',e},
				
				{16,20,'*10 split',e},
				{16.5,20,'*10 no split, *10 reverse',e},
				{17.5,20,'*10 -100 cross',e},
				{18,20,'*10 no cross, *10 no reverse',e},
				
				{20,1,'*10 invert',l},
				{20.5,1,'*10 no invert',l},
				{21.5,1,'*10 invert',l},
				{22,1,'*10 no invert',l},
				
				{23-.05,1,'*40 200 distant',l},
				{23.25-.05,1,'*40 no distant',l},
				
				{24,28,'*10 alternate',e},
				{24.5,28,'*10 no alternate, *10 reverse',e},
				{25.5,28,'*10 -100 split',e},
				{26,28,'*10 no split, *10 no reverse',e},
				
				{55.5,6,'*1000 300 beat','len'},
				{61.5,1,'*1000 no beat','len'},
				
				{64,79,'*10 stealth','end'},
				{64,79,'*100 1000 drunk, *100 0 tipsy, *200 2000 bumpy','end'},
				{65,79,'*10000 stealth','end'},
				
				{65.5,.125,'*10000 70 stealth','len'},
				{65.75,.25,'*10000 70 stealth','len'},
				{66.5,.25,'*10000 70 stealth','len'},
				
				{69.5,.125,'*10000 70 stealth','len'},
				{69.75,.25,'*10000 70 stealth','len'},
				
				{73.5,.125,'*10000 70 stealth','len'},
				{73.75,.25,'*10000 70 stealth','len'},
				{74.5,.25,'*10000 70 stealth','len'},
				
				{77.5,.125,'*10000 70 stealth','len'},
				{77.75,.25,'*10000 70 stealth','len'},
				
				
				
				{80,16,'*0.36 -100 mini, *0.09 25 flip, *0.18 50 stealth','len'},
				{88,8,'*0.8 no mini, *0.2 no flip, *0.4 no stealth','len'},
				
				{92,1,'*2 40 reverse','len'},
				{92.5,1,'*2 no reverse','len'},
				{93,1,'*2 40 reverse','len'},
				{93.5,1,'*2 no reverse','len'},
				
				{95.5,123.5,'*1000 200 beat','end'},
				
				{100-.05,2,'*10 80 hallway',l},
				{101-.05,2,'*10 no hallway',l},
				
				{110-.05,1,'*10 invert',l},
				{110.5-.05,1,'*10 no invert',l},
				{111-.05,1,'*10 invert',l},
				{111.5-.05,1,'*10 no invert',l},
				
				{116-.05,2,'*10 80 distant',l},
				{117-.05,2,'*10 no distant',l},
				
				{123.5,1,'*1000 no beat','len'},
				
				{124-.05,1,'*10 invert','len'},
				{124.5-.05,1,'*10 no invert','len'},
				
				{125.5-.05,1,'*5 50 reverse',l},
				{125.75-.05,1,'*5 no reverse',l},
				{126.25-.05,1,'*5 50 reverse',l},
				{126.5-.05,1,'*5 no reverse',l},
				
				{132-.05,2,'*10 80 hallway',l},
				{133-.05,2,'*10 no hallway',l},
				
				{134-.05,1,'*10 flip','len'},
				{135-.05,1,'*10 no flip','len'},
				
				{148-.05,2,'*10 80 distant',l},
				{149-.05,2,'*10 no distant',l},
				
				{150-.05,1,'*10 flip','len'},
				{151-.05,1,'*10 no flip','len'},
				
				{127.5,155.5,'*1000 200 beat','end'},
				{151.5,4,'*1000 1000 beat','len'},
				{155.5,1,'*1000 no beat','len'},
				
				{159-.05,1,'*10 stealth','len'},
				{159.5-.05,1,'*10 no stealth','len'},
				
				{159.5,184.5,'*1000 100 beat, *0.1 30 expand','end'},
				{184.5,1,'*1000 no beat','len'},
				
				{168,1,'*4 120 wave','len'},
				{169,1,'*8 no wave','len'},
				{716,1,'*4 120 wave','len'},
				{717,1,'*8 no wave','len'},
				
				{722,2,'*4 50 reverse','len'},
				{722.5,2,'*4 no reverse','len'},
				{723,2,'*4 50 reverse','len'},
				{723.5,2,'*4 no reverse','len'},
				
				{733.5-.05,1,'*10 100 stealth',l},
				{734-.05,1,'*10 no stealth',l},
				
				{174,2,'*4 50 reverse, *4.88 invert','len'},
				{174.5,2,'*4 no reverse','len'},
				{175,2,'*4 50 reverse, *4.88 no invert','len'},
				{175.5,2,'*4 no reverse','len'},
				
				{195.5,8,'*1000 200 beat','len'},
				{202.5,2,'*1000 no beat','len'},
				{203.5,8,'*1000 200 beat','len'},
				{211.5,2,'*1000 no beat','len'},
				
				{228,292,'3.5x','end'},
				{260,292,'*0.2 wave, 2.5x','end'},
				
				{252,259,'*60 628 dizzy',e},
				{259,2,'*60 no dizzy','len'},
				{284,292,'*60 628 dizzy',e},
				{292,2,'*60 no dizzy','len'},
				
				{291.5,324,'*1000 100 beat','end'},
				{323.5,2,'*1000 no beat','len'},
				
				{324,356,'*0.08 -100 reverse, *0.16 1.5x, *0.04 50 drunk','end'},
				{348,356,'*0.3 no reverse,*5 no drunk,*5 3x','end'},
				
				{356,1,'*100000 distant',l}, 
				{356,32,'*0.292 distant',l}, 
				{356.1,16-.1,'*0.295 hallway',l}, 
				{356+32,32,'*0.292 distant',l}, 
				{356.1+32,16-.1,'*0.295 hallway',l}, 
				{356+64,32,'*0.292 distant',l}, 
				{356.1+63,16-.1,'*0.295 hallway',l}, 
				{356+96,32,'*0.292 distant',l}, 
				{356.1+96,16-.1,'*0.295 hallway',l}, 
				
				{544-.05,1,'*10 invert',l},
				{544.5-.05,1,'*10 no invert',l},
				{545-.05,1,'*10 invert',l},
				{545.5-.05,1,'*10 no invert',l},
				
				{548,596,'*1.82 300 centered, *0.02 30 dizzy, *5 1.6x, *0.03 30 flip, *0.04 50 stealth',e},
				{548,608,'*0.03 100 distant',e},
				{596,608,'*0.25 150 distant',e},
				{604,608,'*2 200 distant',e},
				{608,4,'*5 no distant',l},
				
				{612,676,'*1000 200 beat, *2 150 wave, *10000 sudden, *10000 -90 suddenoffset',e},
				
				{612,676,'*1000 -350 reverse, *1000 0.3x, *1000 800 bumpy, *10000 300 sudden, *10000 -70 suddenoffset, *10000 80 centered',e,1},
				{612,676,'*1000 -350 reverse, *1000 0.3x, *1000 -800 bumpy, *10000 300 sudden, *10000 -70 suddenoffset, *10000 80 centered',e,2},
				
				{620-1.05,8,'*'..(6.08*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{628-1.05,8,'*'..(6.08*e_aspect)..' no invert','len'},
				{636-1.05,8,'*'..(6.08*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{644-1.05,8,'*'..(6.08*e_aspect)..' no invert','len'},
				{652-1.05,8,'*'..(6.08*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{660-1.05,8,'*'..(6.08*e_aspect)..' no invert','len'},
				{668-1.05,9,'*'..(6.08*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				
				{676,1,'*10000 no invert, *10000 no reverse, *1000 2.75x, *1000 no bumpy, *1000 no sudden, *1000 no centered',l},
				
				{680-.05,2,'*10 150 distant',l},
				{681-.05,2,'*10 no distant',l},
				--[[				
				{682-.05,1,'*10 flip','len'},
				{683-.05,1,'*10 no flip','len'},
				]]			
				{696-.05,2,'*10 150 hallway',l},
				{697-.05,2,'*10 no hallway',l},
								
				{698-.05,1,'*10 flip','len'},
				{699-.05,1,'*10 no flip','len'},
								
				{675.5,703.5,'*1000 200 beat','end'},
				{699.5,4,'*1000 1000 beat','len'},
				{703.5,1,'*1000 no beat','len'},
				
				{712-.05,2,'*10 150 distant',l},
				{713-.05,2,'*10 no distant',l},
				--[[				
				{714-.05,1,'*10 flip','len'},
				{715-.05,1,'*10 no flip','len'},
				]]			
				{728-.05,2,'*10 150 hallway',l},
				{729-.05,2,'*10 no hallway',l},
												
				{707.5,731.5,'*1000 200 beat','end'},
				{708,732,'*0.2 50 tipsy','end'},
				{731.5,1,'*1000 no beat','len'},
				
				{736,4,'*0.7 drunk, *0.7 stealth, *4 400 dizzy',l},
				{739.5,1,'*5 no drunk, *5 no stealth, *20 no dizzy',l},
				{739.5,800,'*1000 200 beat',e},
				
				--{740-.05,800,'*10 centered, *10 2x, *10 split',e},
				
				{741.5-.05,4,'*10 reverse',l},
				{745.5-.05,4,'*10 no reverse',l},
				{757.5-.05,771,'*10 reverse',e},
				{771,4,'*10000 no reverse',l},
				
				{772,792,'*0.1 drunk, *0.1 tipsy, *0.04 50 stealth',e},
				
				{790.5,1,'*10000 stealth',l},
				{790.5,.125,'*10000 50 stealth',l},
				{790.75,.125,'*10000 50 stealth',l},
				{791,.125,'*10000 50 stealth',l},
				{791.25,.125,'*10000 50 stealth',l},
				{791.5,2,'*10000 50 stealth',l},
				{791.625,2,'*2 no stealth',l},
				
				{796,5,'*1.5 no beat, *1.5 0x',l},
				
				{800.5,1,'*1000 no beat',l},
			}
			
			function mod_add(beat,t,str,lenend,pn)
				table.insert(mods,{beat,t,str,lenend,pn})
			end
			
			for i=548,580.1 do
				mod_add(i-.1,.1,'*40 no centered',l);
			end
			
			mod_add(582-.1,.1,'*40 no centered',l);
			mod_add(584-.1,.1,'*40 no centered',l);
			mod_add(586-.1,.1,'*40 no centered',l);
			mod_add(588-.1,.1,'*40 no centered',l);
			mod_add(589-.1,.1,'*40 no centered',l);
			mod_add(590-.1,.1,'*40 no centered',l);
			mod_add(591-.1,.1,'*40 no centered',l);
			mod_add(592-.1,.1,'*40 no centered',l);
			mod_add(592.5-.1,.1,'*40 no centered',l);
			mod_add(593-.1,.1,'*40 no centered',l);
			mod_add(593.5-.1,.1,'*40 no centered',l);
			mod_add(594-.1,.1,'*40 no centered',l);
			mod_add(594.5-.1,.1,'*40 no centered',l);
			mod_add(595-.1,.1,'*40 no centered',l);
			mod_add(596-.1,.1,'*40 no centered, *10 no distant, *3 no flip',l);
			
			for i=548,578,4 do
				switcheroo_add(i+0-.01,1,10,2)
				switcheroo_add(i+1-.01,3,10,2)
				switcheroo_add(i+2-.01,1,10,2)
				switcheroo_add(i+3-.01,3,10,2)
			end
			
			switcheroo_add(580-.01,1,10,2)
			switcheroo_add(582-.01,2,10,2)
			switcheroo_add(584-.01,1,10,2)
			switcheroo_add(586-.01,2,10,2)
			switcheroo_add(588-.01,3,10,2)
			switcheroo_add(589-.01,1,10,2)
			switcheroo_add(590-.01,3,10,2)
			switcheroo_add(591-.01,1,10,2)
			
			-----------------
			--intro section--
			-----------------
			
			function l_big(b,sizmult,speed)
				speed = 2.75
				simple_m0d(b,100,0.6,'stealth');
				mod_beato(b,300);
				table.insert(mods,{b,0.5,'*10000 0.5x','len'});
				table.insert(mods,{b+.1,3,'*'..(speed*5/3)..' '..speed..'x','len'});
			end
			
			function l_big2(beat)
				simple_m0d(beat,-200,0.3,'mini');
				simple_m0d(beat,30,0.3,'flip');
				simple_m0d(beat,300,0.6,'dizzy');
			end
			
			l_big2(23.5);
			
			--mod_wiggle(beat,num,div,amt,spdmult,mod,pn,first)
			l_big(32,1,3)
			mod_wiggle(34,5,4,200,1,'tipsy');
			mod_wiggle(35,5,4,200,1,'drunk');
			l_big(36,1,3)
			
			simple_m0d(38.7,50,0.6,'stealth');
			
			l_big(40,1,3)
			mod_wiggle(42,5,4,200,1,'tipsy');
			mod_wiggle(43,5,4,200,1,'drunk');
			l_big(44,1,3)
			
			--simple_m0d3(beat,strength,duration,bpm,mod)
			simple_m0d3(46.5-.1,-100,0.5,146,'mini');
			simple_m0d3(46.5-.1,20,0.5,146,'flip');
			simple_m0d3(47.5-.1,-100,0.5,146,'mini');
			simple_m0d3(47.5-.1,20,0.5,146,'flip');
			
			simple_m0d3(594.5-.1,-100,0.5,146,'mini');
			simple_m0d3(594.5-.1,20,0.5,146,'flip');
			simple_m0d3(595.5-.1,-100,0.5,146,'mini');
			simple_m0d3(595.5-.1,20,0.5,146,'flip');
			
			l_big(48,1,3)
			mod_wiggle(49,5,4,200,1,'drunk');
			l_big(50,1,3)
			mod_wiggle(51,5,4,200,1,'tipsy');
			l_big(52,1,3)
			mod_wiggle(53,5,4,200,1,'drunk');
			l_big(54,1,3)
			mod_wiggle(55,5,4,200,1,'tipsy');
			
			mod_wiggle(61.5,9,4,200,2,'drunk');
			mod_wiggle(63.5,4,8,200,6,'drunk',1,false);
			mod_wiggle(63.5,4,8,200,6,'drunk',2,false);
			
			mod_add(64,79,'*100 1000 drunk','end');
			mod_add(77,4,'*9 no drunk, *9 no tipsy, *18 no bumpy, *2 no stealth','len');
			
			mod_wiggle(80,17,2,100,1,'drunk');
			for i=80,87.6,0.5 do
				simple_m0d(i,80,0.25,'brake');
			end
			
			simple_m0d2(95,100,0.7,'tornado');
			
			simple_m0d(103,50,0.3,'stealth');
			simple_m0d(111,50,0.3,'stealth');
			simple_m0d(119,50,0.3,'stealth');
			
			simple_m0d(134-.05,50,0.3,'stealth');
			simple_m0d(135-.05,50,0.3,'stealth');
			
			simple_m0d(160-.05,200,0.3,'dizzy');
			simple_m0d(176-.05,200,0.3,'dizzy');
			simple_m0d(184-.05,200,0.3,'dizzy');
			simple_m0d(160-.05,50,0.3,'stealth');
			simple_m0d(176-.05,50,0.3,'stealth');
			simple_m0d(184-.05,50,0.3,'stealth');
			
			simple_m0d(731,50,0.3,'stealth');
			
			simple_m0d(747,300,0.25,'distant');
			simple_m0d(755,300,0.25,'distant');
			
			simple_m0d(767,50,0.3,'stealth');

			l_big2(104)
			l_big2(112)
			l_big2(120)
			l_big2(128)
			l_big2(136)
			l_big2(144)
			
			l_big(127,1,3);
			
			simple_m0d2(143,100,0.4,'tornado');
			simple_m0d2(152,80,0.4,'brake');
			simple_m0d2(153,80,0.4,'brake');
			simple_m0d2(154,80,0.4,'brake');
			simple_m0d2(155,80,0.4,'brake');
			simple_m0d2(691,100,0.4,'tornado');
			simple_m0d2(700,80,0.4,'brake');
			simple_m0d2(701,80,0.4,'brake');
			simple_m0d2(702,80,0.4,'brake');
			simple_m0d2(703,80,0.4,'brake');
			
			mod_spring(157,100,6,'drunk');
			mod_spring(157.5,100,6,'drunk');
			mod_spring(158,100,18,'drunk');
			mod_spring(705,100,6,'drunk');
			mod_spring(705.5,100,6,'drunk');
			mod_spring(706,100,18,'drunk');
			
			--[[
			switcheroos:
			1 = LDUR
			2 = RUDL
			3 = DLRU
			4 = LUDR
			5 = RDUL
			6 = DRLU
			7 = ULRD
			8 = URLD
			]]
			switcheroo_add(188-.05,5,10,8)
			switcheroo_add(188.75-.05,2,10,8)
			switcheroo_add(189.5-.05,4,10,8)
			switcheroo_add(190.25-.05,1,10,8)
			switcheroo_add(191-.05,5,10,8)
			switcheroo_add(191.75-.05,2,10,8)
			switcheroo_add(192.5-.05,3,10,8)
			switcheroo_add(193-.05,1,10,8)
			
			switcheroo_add(194,3,146/120,9)
			switcheroo_add(203-.05,1,10,8)
			switcheroo_add(204-.05,3,10,16)
			switcheroo_add(212,1,146/(60*8),8)
			
			switcheroo_add(224,3,146/90,4);
			switcheroo_add(225.5,1,146/150,4);
			
			mod_wiggle(257,5,4,200,1.5,'tipsy');
			mod_wiggle(258,5,4,200,1.5,'drunk');
			
			simple_m0d(353,100,1,'stealth');
			l_big(353,1,3);

			for i=292,323,2 do
				mod_add(i-.05,.5,'*10 50 cross',l);
				mod_add(i+.2,.5,'*10 no cross',l);
			end
			
			l_big(484,1,3);
			l_big(492,1,3);
			l_big(500,1,3);
			l_big(508,1,3);
			mod_wiggle(488,5,4,200,1.5,'tipsy');
			mod_wiggle(489,5,4,200,1.5,'drunk');
			mod_wiggle(490,5,4,200,1.5,'tipsy');
			mod_wiggle(491,5,4,200,1.5,'drunk');
			mod_wiggle(496,5,4,200,1.5,'tipsy');
			mod_wiggle(497,5,4,200,1.5,'drunk');
			mod_wiggle(498,5,4,200,1.5,'tipsy');
			mod_wiggle(499,5,4,200,1.5,'drunk');
			mod_wiggle(504,5,4,200,1.5,'tipsy');
			mod_wiggle(505,5,4,200,1.5,'drunk');
			mod_wiggle(506,5,4,200,1.5,'tipsy');
			mod_wiggle(507,5,4,200,1.5,'drunk');
			mod_wiggle(512,5,4,200,1.5,'tipsy');
			mod_wiggle(513,5,4,200,1.5,'drunk');
			mod_wiggle(514,5,4,200,1.5,'tipsy');
			mod_wiggle(515,5,4,200,1.5,'drunk');
			
			l_big(516,1,3);
			l_big(520,1,3);
			l_big(524,1,3);
			l_big(528,1,3);
			l_big(532,1,3);
			l_big(534,1,3);
			l_big(536,1,3);
			l_big(538,1,3);
			l_big(540,1,3);
			l_big(542,1,3);
			
			mod_wiggle(518,5,4,200,1.5,'tipsy');
			mod_wiggle(519,5,4,200,1.5,'drunk');
			mod_wiggle(526,5,4,200,1.5,'tipsy');
			mod_wiggle(527,5,4,200,1.5,'drunk');
			
			mod_wiggle(545.5,7,4,200,1,'tipsy');
			mod_wiggle(547,5,4,200,1,'drunk');
			
			for i=531,542.5,4 do
				mod_wiggle(i,5,4,200,1,'tipsy');
				mod_wiggle(i+2,5,4,200,1,'drunk');
			end
			
			l_big2(676)
			l_big2(684)
			l_big2(692)
			l_big2(708)
			--l_big2(716)
			l_big2(732)
			
			simple_m0d2(792.25,300,1,'drunk');
			simple_m0d2(792.25,300,1,'tipsy');
			
			curaction = 1;
			--{beat,message,persists}
			mod_actions = {
				{99,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(30);
						end
					end
				end},
				{107,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(0);
						end
					end
				end},
				{115,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(-30);
						end
					end
				end},
				{123,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(0);
						end
					end
				end},
				{131,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(40);
						end
					end
				end},
				{139,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(0);
						end
					end
				end},
				{147,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationy(-40);
						end
					end
				end},
				{151-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:rotationy(0);
						end
					end
				end},
				{612,'SetUpFUCK'},
				{612,'StartRot'},
				{676,function(self)
					local d = 1
					for pn=1,2 do
						if pn == 2 then d = -1 end
						local a = _G['P'..pn]
						if a then
							a:finishtweening()
							a:decelerate(m_bl)
							a:x(SCREEN_CENTER_X+(SCREEN_WIDTH*0.25*-d));
							a:zoom(1);
							a:rotationz(0);
						end
					end
				end},
				{679-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:rotationz(20);
						end
					end
				end},
				{687,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationz(0);
						end
					end
				end},
				{695,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationz(-20);
						end
					end
				end},
				{711,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationz(30);
						end
					end
				end},
				{719,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationz(0);
						end
					end
				end},
				{727,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationz(-30);
						end
					end
				end},
				{735,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.25*m_bl);
							a:rotationz(0);
						end
					end
				end},
				{38-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:rotationz(-20);
							a:sleep(0.5*m_bl);
							a:rotationz(0);
							a:sleep(0.25*m_bl);
							a:rotationz(30);
							a:decelerate(0.25*m_bl);
							a:rotationz(35);
							a:accelerate(m_bl);
							a:rotationz(0);
						end
					end
				end},
				{63.5,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.5*m_bl);
							a:rotationz(360);
							a:sleep(0);
							a:rotationz(0);
						end
					end
				end},
				{94,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(1*m_bl);
							a:rotationz(360);
							a:sleep(0);
							a:rotationz(0);
						end
					end
				end},
				{100-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{101-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{108-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0)
						end
					end
				end},
				{109-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0.4)
						end
					end
				end},
				{109.5,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:zoom(.6);
							a:sleep(.25*m_bl)
							a:zoom(.8);
							a:sleep(.25*m_bl)
							a:zoom(1);
						end
					end
				end},
				{116-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{117-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{125-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:zoom(1.2);
							a:rotationz(30);
						end
					end
				end},
				{127-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:zoom(1);
							a:rotationz(0);
						end
					end
				end},
				{132-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{133-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{140-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0)
						end
					end
				end},
				{141-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0.4)
						end
					end
				end},
				{141.5,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:zoom(.6);
							a:sleep(.25*m_bl)
							a:zoom(.8);
							a:sleep(.25*m_bl)
							a:zoom(1);
						end
					end
				end},
				{148-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{149-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{152-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:zoom(1.1);
							a:rotationz(10);
							a:sleep(m_bl-0.1);
							a:linear(0.1);
							a:zoom(1.2);
							a:rotationz(20);
							a:sleep(m_bl-0.1);
							a:linear(0.1);
							a:zoom(1.3);
							a:rotationz(30);
							a:sleep(m_bl-0.1);
							a:linear(0.1);
							a:zoom(1.4);
							a:rotationz(40);
							a:sleep(m_bl-0.1);
							a:linear(m_bl*0.25);
							a:zoom(1);
							a:sleep(m_bl*0.25);
							a:linear(m_bl*0.25);
							a:rotationz(0);
						end
					end
				end},
				{160,function(self)
					local d = 1
					for pn=1,2 do
						local a = _G['P'..pn]
						if pn == 2 then d = -1 end
						if a then
							a:bob();
							a:effectclock('bgm');
							a:effectperiod(2);
							a:effectmagnitude(0,20*d,0)
						end
					end
				end},
				{182-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:stopeffect();
							a:linear(0.1);
							a:zoomz(80);
							a:sleep(m_bl-0.1);
							a:spring(m_bl*1);
							a:zoomz(1);
						end
					end
				end},
				{188-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(-5)
				end end end},
				{188.75-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(5)
				end end end},
				{189.5-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(-10)
				end end end},
				{190.25-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(10)
				end end end},
				{191-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(-15)
				end end end},
				{191.75-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(15)
				end end end},
				{192.5-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(-20)
				end end end},
				{193-.05,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(0.1)
					a:rotationz(20)
				end end end},
				{194,function(self) for pn=1,2 do local a = _G['P'..pn] if a then
					a:linear(m_bl*2)
					a:rotationz(0)
				end end end},
				{220,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4);
							a:rotationx(360);
							a:sleep(0);
							a:rotationx(0);
						end
					end
				end},
				{228,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(10);
							a:rotationy(10);
							a:rotationz(10);
							a:zoom(0.9);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{236,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(10);
							a:rotationy(-10);
							a:rotationz(-10);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationx(0);
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{244,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(-10);
							a:rotationy(10);
							a:rotationz(10);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{252,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(-10);
							a:rotationy(-10);
							a:rotationz(-10);
							a:zoomz(4);
						end
					end
				end},
				{259,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:stoptweening();
							a:decelerate(m_bl*1);
							a:rotationx(0);
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(1);
							a:zoomx(2);
							a:zoomy(0.4);
							a:spring(m_bl*1);
							a:zoom(0.9)
						end
					end
				end},
				{261,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:accelerate(m_bl*1.5)
							a:rotationx(5);
							a:rotationy(5);
							a:rotationz(5);
							a:zoomz(2);
							a:decelerate(m_bl*1.5)
							a:rotationx(10);
							a:rotationy(10);
							a:rotationz(10);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationx(15);
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{268,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(20);
							a:rotationy(-10);
							a:rotationz(-10);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationx(0);
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{276,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(-20);
							a:rotationy(10);
							a:rotationz(10);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{284,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(m_bl*4)
							a:rotationx(-20);
							a:rotationy(-10);
							a:rotationz(-10);
							a:zoomz(4);
							a:accelerate(m_bl*4)
							a:rotationx(0);
							a:rotationy(0);
							a:rotationz(0);
							a:zoomz(4);
						end
					end
				end},
				{292,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:stopeffect();
							a:linear(0.5);
							a:zoom(1);
							a:zoomz(1);
						end
					end
				end},
				{348,'DecentAtkWarn'},
				{353,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							l_aimfor = 'TapNoteScore_W4'
							a:decelerate(m_bl*3);
							a:rotationz(360);
							a:sleep(0);
							a:rotationz(0);
						end
					end
				end},
				{356,'DecentAtk'},
				{384,'ExcellentAtkWarn'},
				{388,'ExcellentAtk'},
				{416,'GreatAtkWarn'},
				{420,'GreatAtk'},
				{452,'ExcellentAtk'},
				{452+16,'DecentAtk'},
				{452+24,'GreatAtk'},
				{484,'NormalJudgments'},
				{484-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:stoptweening();
							a:linear(0.1);
							a:rotationz(25);
							a:zoomz(1);
						end
					end
				end},
				{492-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:rotationz(-25);
						end
					end
				end},
				{500-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:rotationz(25);
						end
					end
				end},
				{508-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:rotationz(-25);
						end
					end
				end},
				{548,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(m_bl*46);
							a:zoom(1.5);
							a:linear(m_bl*2);
							a:zoom(1);
						end
					end
				end},
				{596,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:bob()
							a:effectclock('bgm');
							a:effectperiod(1/8);
							a:effectmagnitude(0,0,60);
						end
					end
				end},
				{604,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:stopeffect();
						end
					end
				end},
				{612,'WhiteFlash'},
				{680-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{681-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{688-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0)
						end
					end
				end},
				{689-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0.4)
						end
					end
				end},
				{689.5,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:zoom(.6);
							a:sleep(.25*m_bl)
							a:zoom(.8);
							a:sleep(.25*m_bl)
							a:zoom(1);
						end
					end
				end},
				{696-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{697-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{700-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:zoom(1.1);
							a:rotationz(-20);
							a:sleep(m_bl-0.1);
							a:linear(0.1);
							a:zoom(1.2);
							a:rotationz(0);
							a:sleep(m_bl-0.1);
							a:linear(0.1);
							a:zoom(1.3);
							a:rotationz(20);
							a:sleep(m_bl-0.1);
							a:linear(0.1);
							a:zoom(1.4);
							a:rotationz(40);
							a:sleep(m_bl-0.1);
							a:linear(m_bl*0.25);
							a:zoom(1);
							a:sleep(m_bl*0.25);
							a:linear(m_bl*0.25);
							a:rotationz(0);
						end
					end
				end},
				{712-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{713-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{720-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0)
						end
					end
				end},
				{721-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0.4)
						end
					end
				end},
				{721.5,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:zoom(.6);
							a:sleep(.25*m_bl)
							a:zoom(.8);
							a:sleep(.25*m_bl)
							a:zoom(1);
						end
					end
				end},
				{728-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(3)
						end
					end
				end},
				{729-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:decelerate(0.15);
							a:zoomz(1)
						end
					end
				end},
				{752-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0)
						end
					end
				end},
				{753-.05,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:finishtweening();
							a:zoom(1)
							a:linear(0.15)
							a:zoom(0.4)
						end
					end
				end},
				{753.5,function(self)
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:zoom(.6);
							a:sleep(.25*m_bl)
							a:zoom(.8);
							a:sleep(.25*m_bl)
							a:zoom(1);
						end
					end
				end},
				{768,function(self)
					MESSAGEMAN:Broadcast('FakeFade');
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(m_bl*3)
							a:zoom(0.6);
							a:rotationz(30);
							a:accelerate(m_bl*1);
							a:zoom(1)
							a:rotationz(0);
						end
					end
				end},
				{796,'FinalFade'},
				{804,function()
					if GAMESTATE:IsCourseMode() and THEME:GetCurThemeName() == 'SIMPLY LOVE GOODER' then
						SCREENMAN:SetNewScreen('ScreenCutSceneSRT3Eval')
					end
				end},
			}
			
			function l_add_fluct(beat,fluct)
				table.insert(mod_actions,{beat-.05,function()
					for pn=1,2 do
						local a = _G['P'..pn]
						if a then
							a:linear(0.1);
							a:rotationz(25*fluct);
						end
					end
				end})
			end
			
			l_add_fluct(516,1);
			l_add_fluct(520,-1);
			l_add_fluct(524,1);
			l_add_fluct(528,-1);
			l_add_fluct(532,1);
			l_add_fluct(534,-1);
			l_add_fluct(536,1);
			l_add_fluct(538,-1);
			l_add_fluct(540,1);
			l_add_fluct(542,-1);
			l_add_fluct(544,0);
			
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, modtable_compare)
			end
			if table.getn(char_actions) > 1 then
				table.sort(char_actions, modtable_compare)
			end
			
			self:queuecommand('Update');
			
---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
		
		UpdateCommand=function(self)

			if GAMESTATE:GetSongBeat()>=0 and not checked then
				
				----------------------
				-- grab everything? --
				----------------------
				if SCREENMAN:GetTopScreen():GetChild('Overlay') then Overlay = SCREENMAN:GetTopScreen():GetChild('Overlay') end
				if SCREENMAN:GetTopScreen():GetChild('Underlay') then Underlay = SCREENMAN:GetTopScreen():GetChild('Underlay') end
				
				--------------------------
				-- hide everything? y/n --
				--------------------------
				mod_hideall = true;
				if mod_hideall == true then
					if Overlay then Overlay:visible(false) end
					if Underlay then Underlay:visible(false) end
				end
				
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
				
				P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				--aliases for old times sake
				
				screen = SCREENMAN:GetTopScreen();
				checked = true;
			end
			
---------------------------------------------------------------------------------------
----------------------TOUCH THIS-------------------------------------------------------
---------------------------------------------------------------------------------------

			local beat = GAMESTATE:GetSongBeat()
			
			if beat > 356 and beat < 484 and beat > mod_firstSeenBeat+.5 then
				local pref = ''
				l_p1stext:settext(pref..string.format('%.2f',(l_scoreP1))..'%')
				local pref = ''
				l_p2stext:settext(pref..string.format('%.2f',(l_scoreP2))..'%')
				test_rotval = test_rotval + 0.008;
				test_zval = test_zval + 0.0015;
			end
			
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false;
			if disable ~= true and checked then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i=1,2 do
						l_mod_internal('clearall',i)
						if _G['init_modsp'..i] then 
							--br_mod_internal(_G['init_modsp'..i],i)
						end
					end
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if beat >=v[1] then
								if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
									if table.getn(v) == 5 and v[5] then
										l_mod_internal(''..v[3],v[5]);
									else
										l_mod(''..v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = '';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')');
						end
					end
				end
				
				--------------------
				-- perframe stuff --
				--------------------
				if beat > mod_firstSeenBeat+.1 then
				
					if perframe(28,32) then
						local pos = (beat*1)-0.5
						l_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
						l_mod('*100000 '..(l_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
						l_mod('*100000 '..(l_spinny[2]*math.cos(pos*math.pi))..' split');
						l_mod('*100000 '..(l_spinny[3]*math.cos(pos*math.pi))..' alternate');
					end
					
					if perframe(604,608) then
						local pos = (beat*2)-0.5
						l_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
						l_mod('*100000 '..(l_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
						l_mod('*100000 '..(l_spinny[2]*math.cos(pos*math.pi))..' split');
						l_mod('*100000 '..(l_spinny[3]*math.cos(pos*math.pi))..' alternate');
					end
					
					if perframe(612,676) then
					
						l_mod('*100000 '..(l_bumpier:GetX())..' bumpy',1);
						l_mod('*100000 '..(l_bumpier:GetX()*-1)..' bumpy',2);
						
						if l_scrollspd<3.5 and beat<644 then
							l_scrollspd = l_scrollspd+0.02
						end
						if beat>=644 then
							if l_scrollspd > 0 then
								l_scrollspd = l_scrollspd*-1;
							end
						end
						
						for i=1,4 do
							_G['l_pos'..i]:addx(l_scrollspd*e_aspect);
							
							_G['l_pos'..i]:diffusealpha(0);
							
							if l_scrollspd < 0 and _G['l_pos'..i]:GetX() < -160*e_aspect then
								_G['l_pos'..i]:addx(960*e_aspect);
							end
							if l_scrollspd > 0 and _G['l_pos'..i]:GetX() > (640+160)*e_aspect then
								_G['l_pos'..i]:addx(-960*e_aspect);
							end
							
						end
						
						for pn=1,2 do
							
							--_G['l_rotatorp'..pn..'a']:addx(l_scrollspd/2);
							
							if _G['P'..pn] then
								local targ = 'a'
								--if beat>644 then targ = 'b' end
								--_G['P'..pn]:rotationz(_G['l_rotatorp'..pn..targ]:GetX());
								_G['P'..pn]:zoom(0.75);
							end
						end
						
						if l_endfluct == 1 then
							if P1 then P1:x(l_pos1:GetX()); end
							if P2 then P2:x(l_pos2:GetX()); end
							l_endfluct = 2
						else
							if P1 then P1:x(l_pos3:GetX()); end
							if P2 then P2:x(l_pos4:GetX()); end
							l_endfluct = 1
						end
						
					end
				
				end
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
						if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
							if type(mod_actions[curaction][2]) == 'function' then
								mod_actions[curaction][2]()
							elseif type(mod_actions[curaction][2]) == 'string' then
								Trace(string.sub(mod_actions[curaction][2],-4));
								if string.sub(mod_actions[curaction][2],-4) == '.ogg' then
									Sound(mod_actions[curaction][2])
								else
									MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
								end
							end
						end
						curaction = curaction+1;
					end
				end
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curcharaction<=table.getn(char_actions) and GAMESTATE:GetSongBeat()>=char_actions[curcharaction][1] do
						if char_actions[curcharaction][3] or GAMESTATE:GetSongBeat() < char_actions[curcharaction][1]+2 then
							if type(char_actions[curcharaction][2]) == 'function' then
								char_actions[curcharaction][2]()
							elseif type(char_actions[curcharaction][2]) == 'string' then
								Trace(string.sub(char_actions[curcharaction][2],-4));
								if string.sub(char_actions[curcharaction][2],-4) == '.ogg' then
									Sound(char_actions[curcharaction][2])
								elseif string.sub(char_actions[curcharaction][2],1,2) == 'c_' then
									char_ayaze:playcommand(string.sub(char_actions[curcharaction][2],3));
								else
									MESSAGEMAN:Broadcast(char_actions[curcharaction][2]);
								end
							end
						end
						curcharaction = curcharaction+1;
					end
				end
				
			end
			
			self:sleep(0.02);
			self:queuecommand('Update');

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
		
	},
	
	LoadActor("decentatkfirst.png")..{ OnCommand=cmd(visible,false;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;diffusealpha,0;),
	DecentAtkWarnMessageCommand=cmd(visible,true;zoomx,1.5;accelerate,0.4;zoomx,1;diffusealpha,1;),
	DecentAtkMessageCommand=cmd(visible,false;),
	},
	
	LoadActor("decentatk.png")..{ OnCommand=cmd(visible,false;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,0.8;diffusealpha,1;),
	DecentAtkMessageCommand=cmd(visible,true;),
	ExcellentAtkMessageCommand=cmd(visible,false;),
	GreatAtkMessageCommand=cmd(visible,false;),
	NormalJudgmentsMessageCommand=cmd(visible,false;),
	},
	LoadActor("excelatk.png")..{ OnCommand=cmd(visible,false;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,0.8;diffusealpha,1;),
	DecentAtkMessageCommand=cmd(visible,false;),
	ExcellentAtkMessageCommand=cmd(visible,true;),
	GreatAtkMessageCommand=cmd(visible,false;),
	NormalJudgmentsMessageCommand=cmd(visible,false;),
	},
	LoadActor("greatatk.png")..{ OnCommand=cmd(visible,false;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,0.8;diffusealpha,1;),
	DecentAtkMessageCommand=cmd(visible,false;),
	ExcellentAtkMessageCommand=cmd(visible,false;),
	GreatAtkMessageCommand=cmd(visible,true;),
	NormalJudgmentsMessageCommand=cmd(visible,false;),
	},
	LoadActor("normalatk.png")..{ OnCommand=cmd(visible,false;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,0.6;diffusealpha,1;),
	DecentAtkMessageCommand=cmd(visible,false;),
	ExcellentAtkMessageCommand=cmd(visible,false;),
	GreatAtkMessageCommand=cmd(visible,false;),
	NormalJudgmentsMessageCommand=cmd(visible,true;sleep,5;accelerate,2;diffusealpha,0;queuecommand,"Hide";),
	HideCommand=cmd(visible,false;),
	},
	
	LoadFont("common normal")..{ InitCommand=function(self) l_p1stext = self end, Text="",
	OnCommand=cmd(x,SCREEN_CENTER_X-(SCREEN_WIDTH*0.25);y,SCREEN_CENTER_Y+20;shadowlength,0;zoom,1.3;),
	NormalJudgmentsMessageCommand=cmd(linear,0.4;zoom,1.9;sleep,1;linear,2;addy,-SCREEN_HEIGHT;), },
	LoadFont("common normal")..{ InitCommand=function(self) l_p2stext = self end, Text="",
	OnCommand=cmd(x,SCREEN_CENTER_X+(SCREEN_WIDTH*0.25);y,SCREEN_CENTER_Y+20;shadowlength,0;zoom,1.3;),
	NormalJudgmentsMessageCommand=cmd(linear,0.4;zoom,1.9;sleep,1;linear,2;addy,-SCREEN_HEIGHT;), },
	
	Def.Quad{ OnCommand=cmd(diffusealpha,0;blend,Blend.Add;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;),
	DecentAtkMessageCommand=cmd(diffuse,.4,0,.7,1;linear,0.2;diffuse,.4,0,.7,.2;),
	ExcellentAtkMessageCommand=cmd(diffuse,1,.7,0,1;linear,0.2;diffuse,1,.7,0,.2;),
	GreatAtkMessageCommand=cmd(diffuse,0,1,0,1;linear,0.2;diffuse,0,1,0,.2;),
	NormalJudgmentsMessageCommand=cmd(diffuse,1,1,1,1;linear,0.2;diffuse,1,1,1,0;queuecommand,"Hide";),
	HideCommand=cmd(visible,false;),
	},
	
	Def.Quad{ OnCommand=cmd(diffuse,0,0,0,0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;),
	FakeFadeMessageCommand=cmd(linear,3*m_bl;diffusealpha,1;accelerate,m_bl;diffusealpha,0;queuecommand,"Hide";), HideCommand=cmd(visible,false;),
	FinalFadeMessageCommand=cmd(visible,true;linear,4*m_bl;diffusealpha,1;),
	},
	
	Def.Quad{
	InitCommand=cmd(visible,false;),
	OnCommand=function(self)
		test_rotval = 4;
		test_zval = 1;
		test_p1fluct = 1;
		test_p2fluct = 1;
	end,
	StepP1MessageCommand=function(self)
		if P1 and GAMESTATE:GetSongBeat() > 356 and GAMESTATE:GetSongBeat() < 483.5 then
			P1:stoptweening();
			P1:decelerate(0.15);
			P1:rotationz(test_rotval*test_p1fluct)
			P1:zoomz(test_zval)
			test_p1fluct = test_p1fluct*-1
		end
	end,
	StepP2MessageCommand=function(self)
		if P2 and GAMESTATE:GetSongBeat() > 356 and GAMESTATE:GetSongBeat() < 483.5 then
			P2:stoptweening();
			P2:decelerate(0.15);
			P2:rotationz(test_rotval*test_p2fluct)
			P2:zoomz(test_zval)
			test_p2fluct = test_p2fluct*-1
		end
	end,
	},
	
	Def.Quad{ InitCommand=cmd(visible,false;),
	DecentAtkMessageCommand=function(self)
		
		l_aimfor = 'TapNoteScore_W4'
		
		if P1 then P1:GetChild('Combo'):basezoomx(0) end
		if P2 then P2:GetChild('Combo'):basezoomx(0) end
	end,
	GreatAtkMessageCommand=function(self)
	
		l_aimfor = 'TapNoteScore_W3'
		
	end,
	ExcellentAtkMessageCommand=function(self)
	
		l_aimfor = 'TapNoteScore_W4'
		
	end,
	NormalJudgmentsMessageCommand=function(self)
		l_tampered = false;
		if P1 then P1:GetChild('Combo'):basezoomx(1) end
		if P2 then P2:GetChild('Combo'):basezoomx(1) end
		l_aimfor = ''
	end,
	SetUpFUCKMessageCommand=function(self)
		for i=1,4 do
			_G['l_pos'..i]:visible(true);
			_G['l_pos'..i]:zoom(0.7);
			_G['l_pos'..i]:diffusealpha(0);
			_G['l_pos'..i]:x((-160+(240*i))*e_aspect);
			_G['l_pos'..i]:y(250);
		end
		--
	end,
	},
	
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); l_pos1 = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); l_pos2 = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); l_pos3 = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); l_pos4 = self; end,	},
	
	Def.Quad{
		OnCommand=cmd(visible,false);
		JudgmentMessageCommand=function(self,params)
			for pn=1,2 do
				if params.Player == 'PlayerNumber_P'..pn and l_aimfor ~= '' and params.TapNoteScore == l_aimfor then
					_G['l_scoreP'..pn] = _G['l_scoreP'..pn] + l_buff_score;
				end
			end
		end;
	},
	
	Def.Quad{ OnCommand=cmd(visible,false;x,600;), InitCommand=function(self) l_bumpier = self end,
	StartRotMessageCommand=cmd(accelerate,l_espd*0.5;x,0;decelerate,l_espd*0.5;x,-600;accelerate,l_espd*0.5;x,0;
	decelerate,l_espd*0.5;x,600;queuecommand,"StartRot";),	},
	
	Def.Quad{ OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;diffuse,1,1,1,0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;),
	WhiteFlashMessageCommand=cmd(diffuse,1,1,1,1;linear,0.4;diffusealpha,0;),
	WhiteFlashQMessageCommand=cmd(diffuse,1,1,1,0.8;linear,0.3;diffusealpha,0;),
	RedFlashMessageCommand=cmd(diffuse,1,0,0,1;linear,0.4;diffusealpha,0;),
	RedFlashQMessageCommand=cmd(diffuse,1,0,0,0.8;linear,0.3;diffusealpha,0;),
	},
	
}