local 	songName = GAMESTATE:GetCurrentSong():GetSongDir();

sw = SCREEN_WIDTH
sh = SCREEN_HEIGHT

e_aspect = sw/640

br_spt = 1030;

LoadActor("mods.lua")

function Sound(str)
	local songName = GAMESTATE:GetCurrentSong():GetSongDir();
	SOUND:PlayOnce(songName..'lua/sounds/'..str..'.ogg');
end

local function br_mod_internal(str, pn)
	taronuke_mods(str,pn)
end

local function br_mod(str)
	for i=1,2 do
		br_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

local function br_init()
	
	fgcurcommand = 1;
			br_fg2 = 1;
			br_fg3 = 1;
			
			
			
			br_spinny = {36,48,24}
			
			br_endfluct = 1;
			br_scrollspd = 0.1;
			
			br_xtiltamt = 5;
			br_tiltamt = 5;
			br_tiltmax = 25;
			br_xtiltmax = 45;
			br_xtiltalt = 1;
			br_tiltsmooth = 8;
			function br_updatetiltamt()
				br_tiltamt = br_tiltamt + (br_tiltmax-br_tiltamt)/br_tiltsmooth
				br_xtiltamt = br_xtiltamt + (br_xtiltmax-br_xtiltamt)/br_tiltsmooth
				br_xtiltalt = br_xtiltalt*-1;
			end
			
			function br_putsparkle(x,y)
				
				local a = br_sparkles[br_sptr];
				
				if not a then return end
				
				a:blend('add');
				a:sleep(0);
				a:diffusealpha(0);
				a:sleep(0);
				a:x(x);
				a:y(y);
				local bz = math.random(80,160)/100;
				a:basezoomx(bz);
				a:basezoomy(bz);
				a:diffusealpha(1);
				a:zoom(1);
				a:visible(true);
				a:linear(0.2);
				a:diffusealpha(0);
				a:zoom(0.6);
				a:queuecommand('Hide');
				
				br_sptr = br_sptr+1;
				if br_sptr > table.getn(br_sparkles) then
					br_sptr = 1;
				end
			end
		
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			function list_compare(a,b)
				return a < b
			end
			
			checked = false;
			
			function fg_check( num, push, v )
				if not push then push = 1 end
				--safely round all that jazz
				if v then
					if not _G[v] then _G[v] = num end;
					if math.floor(_G[v] * 100 + 0.5) / 100 == num then
						_G[v] = math.floor((( _G[v] +push) * 100) + 0.5) / 100
						return true
					end
				else
					if math.floor(fgcurcommand * 100 + 0.5) / 100 == num then
						fgcurcommand = math.floor(((fgcurcommand+push) * 100) + 0.5) / 100
						--fgcurcommand = tonumber(tostring(string.sub(fgcurcommand,1,4)));
						--SCREENMAN:SystemMessage(fgcurcommand);
						return true
					end
				end
				return false
			end
			
			--the new fgchange system, it's the same as checking if fgcurcommand = a number
	   
			function fgchange( beat, index, push, var, skipIfBeyondThisPoint )
				local cur = GAMESTATE:GetSongBeat();
				if not skipIfBeyondThisPoint then skipIfBeyondThisPoint = beat+1 end
				if cur>=beat and fg_check(index, push, var) and cur < skipIfBeyondThisPoint then
					local str = 'fgcurcommand'
					if var then str = var end;
					Trace(beat..': Running '..str..' '..index);
					return true
				end
				return false
			end
			
			--laziness
			
			function perframe( beat, endBeat )
				if not endBeat then endBeat = beat+1 end
				local cur = GAMESTATE:GetSongBeat();
				if cur>=beat and cur<endBeat then return true end
				return false
			end
			
			--how can I make simple m0d?
			--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
			--it's a simple mod
			
			function simple_m0d(beat,strength,mult,mod)
				if not strength then strength = 400 end
				if not mult then mult = 1 end
				if not mod then mod = 'drunk' end
				
				local alive = math.max(2*mult*math.abs(strength)/100,0.25)
				
				table.insert(mods,{beat,0.1,'*100000 '..strength..' '..mod,'len'});
				table.insert(mods,{beat+.1,alive,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,'len'});
			end
			
			function simple_m0d2(beat,strength,mult,mod,pn)
				if not strength then strength = 400 end
				if not mult then mult = 1 end
				if not mod then mod = 'drunk' end
				
				local alive = math.max(2*mult*math.abs(strength)/100,0.25)
				
				table.insert(mods,{beat,0.3,'*'..math.abs(strength/10)..' '..strength..' '..mod,'len',pn});
				table.insert(mods,{beat+.3,alive,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,'len',pn});
			end
			
			--alternates a mod back and forth before resetting to 0
			--beat,num,div,amt,mod,pn
			function mod_wiggle(beat,num,div,amt,mod,pn,first)
				local fluct = 1
				for i=0,(num-1) do
					b = beat+(i/div)
					local m = 1
					if i==0 and not first then m = 0.5 end
					table.insert(mods,{b,1,'*'..math.abs(m*amt/10)..' '..(amt*fluct)..' '..mod..'','len',pn});
					fluct = fluct*-1;
				end
				table.insert(mods,{beat+(num/div),1,'*'..math.abs(amt/20)..' no '..mod..'','len',pn});
			end
			
			--turns on beat for the beat specified, at the desired strength	
			
			function mod_ezbeat(beat,strength)
				if not strength then strength = 1000 end;
				table.insert(mods,{beat-.5,1,'*10000 '..strength..' beat','len'});
				table.insert(mods,{beat+.5,0.25,'*10000 no beat','len'});
			end
			
			--clear all active mods turned on using mod_do() (see below)
			
			function mod_clr(pn)
				if pn then
					_G['init_modsp'..pn] = nil
				else
					for pn=1,2 do
						_G['init_modsp'..pn] = nil
					end
				end
			end
			
			--this will replace GAMESTATE:ApplyGameCommand() mods in fgchanges
			--for example
			--mod_do('*1000 150 beat',2) --turn on 150% beat for player 2
			
			function mod_do(str,pn)
				if pn then
					if str == 'clr' or str == 'clearasil' then
						mod_clr(pn);
						return;
					else
						if _G['init_modsp'..pn] == nil then
							_G['init_modsp'..pn] = str
						else
							_G['init_modsp'..pn] = _G['init_modsp'..pn]..','..str
						end
					end
				else
					if str == 'clr' or str == 'clearasil' then
						mod_clr()
						return
					else
						for pn=1,2 do
							--br_mod(''..str,pn);
							if _G['init_modsp'..pn] == nil then
								_G['init_modsp'..pn] = str
							else
								_G['init_modsp'..pn] = _G['init_modsp'..pn]..','..str
							end
						end
					end
				end
			end
			
			
			init_modsp1 = '';
			init_modsp2 = '';
			
			mod_plr = {};
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat();
			
---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------








			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
			
				{0,9999,'*2 1.8x','len'},
				{0,1030,'*10000 -1000 cover','end'},
				{1030,9999,'*10000 no cover','end'},
				
				------------------------------
				--------SONG 1----------------
				------------------------------
				
				{7.5,71.5,'*1000 150 beat','end'},
				{71.5,1,'*1000 no beat','len'},
				
				{24,3,'*5 200 drunk','len'},
				{25.5-.05,3,'*40 -200 drunk','len'},
				{26-.05,3,'*40 200 drunk','len'},
				{27.5-.05,3,'*40 -200 drunk','len'},
				{28-.05,3,'*40 200 drunk','len'},
				{29-.05,3,'*20 0 drunk','len'},
				{29.5-.05,3,'*20 200 tipsy','len'},
				{30.5-.05,3,'*20 no tipsy','len'},
				
				{31-.05,3,'*20 200 drunk','len'},
				{31.5-.05,3,'*40 -200 drunk','len'},
				{32-.05,3,'*40 200 drunk','len'},
				
				{33-.05,3,'*20 -200 tipsy, *20 no drunk','len'},
				{33.5-.05,3,'*40 200 tipsy','len'},
				{34-.05,3,'*40 -200 tipsy','len'},
				
				{35-.05,3,'*20 200 drunk, *20 no tipsy','len'},
				{35.5-.05,3,'*40 -200 drunk','len'},
				{36-.05,3,'*40 200 drunk','len'},
				
				{36.2,6,'*2.2 no drunk','len'},
				
				{36-.05,2,'*10 invert','len'},
				{37-.05,2,'*10 no invert','len'},
				{38-.05,2,'*10 invert','len'},
				{39-.05,2,'*10 no invert','len'},
				
				{40,2,'*4 200 hallway','len'},
				{41.5,2,'*8 -200 hallway','len'},
				{43,4,'*1.5 no hallway','len'},
				
				{52-.05,2,'*10 invert','len'},
				{53-.05,2,'*10 no invert','len'},
				{54-.05,2,'*10 invert','len'},
				{55-.05,2,'*10 no invert','len'},
				
				{56,2,'*4 200 incoming','len'},
				{57.5,2,'*8 -200 incoming','len'},
				{59,4,'*1.5 no incoming','len'},
				
				{68-.05,2,'*10 invert','len'},
				{69-.05,2,'*10 no invert','len'},
				{70-.05,2,'*10 invert','len'},
				{71-.05,2,'*10 no invert','len'},
				
				{76.00,4.00,'*10000 No Flip,*10000 No Invert,*10000 50% Stealth','len'},
				{76.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{76.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{76.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{77.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{77.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{77.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{78.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{78.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{78.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{79.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{79.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{79.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{80,1,'*10000 No Stealth','len'},
				
				{76,0.25,'*100000 200 mini','len'},
				{76.1,1,'*4.2 60 mini','len'},
				{77,0.25,'*100000 180 mini','len'},
				{77.1,1,'*4.2 40 mini','len'},
				{78,0.25,'*100000 160 mini','len'},
				{78.1,1,'*4.2 20 mini','len'},
				{79-.1,0.25,'*100000 140 mini','len'},
				{79,1,'*4.2 no mini','len'},
				
				{80.00,0.75,'*4 flip','len'},
				{80.75,0.75,'*4 no flip','len'},
				{81.50,0.75,'*4 flip','len'},
				{82.25,0.75,'*4 no flip','len'},
				
				{84.00,0.75,'*4 flip','len'},
				{84.75,0.75,'*4 no flip','len'},
				{85.50,0.75,'*4 flip','len'},
				{86.25,0.75,'*4 no flip','len'},
				
				--[[
				{88-.05,2,'*10 cross, *10 reverse','len'},
				{90-.05,2,'*10 cross, *10 no reverse','len'},
				{92-.05,2,'*10 no cross, *10 split, *10 reverse','len'},
				{94-.05,2,'*10 split, *10 no reverse','len'},
				{95.5-.05,2,'*10 no split, *10 no reverse','len'},
				]]
				
				{88-.05,2,'*2 -20 cross, *1 10 reverse','len'},
				{90-.05,2,'*4 20 cross, *2 -10 reverse','len'},
				{92-.05,2,'*2 no cross, *2 -20 split, *2 10 reverse','len'},
				{94-.05,2,'*4 20 split, *2 -10 reverse','len'},
				{95.5-.05,2,'*2 no split, *1 no reverse','len'},
				
				{96.00,0.75,'*4 flip','len'},
				{96.75,0.75,'*4 no flip','len'},
				{97.50,0.75,'*4 flip','len'},
				{98.25,0.75,'*4 no flip','len'},
				
				
								
				{100.00,0.75,'*4 flip','len'},
				{100.75,0.75,'*4 no flip','len'},
				{101.50,0.75,'*4 flip','len'},
				{102.25,0.75,'*4 no flip','len'},
				
				{104-.05,2,'*2 -20 split, *1 10 reverse','len'},
				{106-.05,2,'*4 20 split, *2 -10 reverse','len'},
				{108-.05,2,'*2 no split, *2 -20 alternate, *2 10 reverse','len'},
				{109-.05,2,'*4 20 alternate, *2 -10 reverse','len'},
				{109.75-.05,2,'*2 no alternate, *1 no reverse','len'},
				
				{111.00-.1,1,'*10000 200 mini, *10000 no drunk, *10000 no tipsy, *10000 no dark','len'},
				{111.00,1,'*6 no mini','len'},
				{111.00,1,'*10000 No Flip,*10000 No Invert,*10000 50% Stealth','len'},
				{111.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{111.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{111.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{112.0,1,'*10000 No Stealth','len'},
				
				{112.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{113.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{114.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{115.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{116.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{117.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{118.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len'},
				
				{111.00-.1,1.6,'*10000 stealth, *10000 dark','len',2},
				{112.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{113.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{114.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{115.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{116.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{117.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				
				{119.00-.1,1,'*10000 200 mini, *10000 no drunk, *10000 no tipsy, *10000 no dark','len'},
				{119.00,1,'*6 no mini','len'},
				{119.00,1,'*10000 No Flip,*10000 No Invert,*10000 50% Stealth','len'},
				{119.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{119.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{119.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{120.0,1,'*10000 No Stealth','len'},
				
				{120.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{121.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{122.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{123.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len'},
								
				{119.00-.1,1.6,'*10000 stealth, *10000 dark','len',1},
				{120.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{121.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{122.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				
				{125-.5,2,'*12 600 drunk','len',1},
				{125-.5,2,'*18 900 tipsy','len',2},
				{126-.5,2,'*24 -600 drunk','len',1},
				{126-.5,2,'*36 -900 tipsy','len',2},
				{126.75-.5,2,'*12 no drunk','len',1},
				{126.75-.5,2,'*18 no tipsy','len',2},
				
				{127.00-.1,1,'*10000 200 mini, *10000 no drunk, *10000 no tipsy, *10000 no dark','len'},
				{127.00,1,'*6 no mini','len'},
				{127.00,1,'*10000 No Flip,*10000 No Invert,*10000 50% Stealth','len'},
				{127.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{127.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{127.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{128.0,1,'*10000 No Stealth','len'},
				
				{128.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{129.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{130.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{131.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{132.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{133.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{134.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len'},
												
				{127.00-.1,1.6,'*10000 stealth, *10000 dark','len',1},
				{128.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{129.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{130.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{131.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{132.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{133.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
								
				{135.00-.1,1,'*10000 200 mini, *10000 no drunk, *10000 no tipsy, *10000 no dark','len'},
				{135.00,1,'*6 no mini','len'},
				{135.00,1,'*10000 No Flip,*10000 No Invert,*10000 50% Stealth','len'},
				{135.00,0.25,'*10000 Invert,*10000 85% Stealth','len'},
				{135.25,0.25,'*10000 Flip,*10000 85% Stealth','len'},
				{135.50,0.25,'*10000 Flip,*10000 -100% Invert,*10000 85% Stealth','len'},
				{136.0,1,'*10000 No Stealth','len'},
				
				{136.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{137.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{138.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{139.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len'},
								
				{135.00-.1,1.6,'*10000 stealth, *10000 dark','len',2},
				{136.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{137.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{138.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				
				--[[
				{144,160,'*0.563 75 flip, *0.563 75 invert','end'},
				{148,160,'*0.19 100 flip, *0.563 no invert','end'},
				{152,160,'*0.563 25 flip, *0.563 -75 invert','end'},
				{156,160,'*0.19 no flip, *0.563 no invert','end'},
				
				{160,176,'*0.563 75 flip, *0.563 75 invert','end'},
				{164,176,'*0.19 100 flip, *0.563 no invert','end'},
				{168,176,'*0.563 25 flip, *0.563 -75 invert','end'},
				{172,176,'*0.19 no flip, *0.563 no invert','end'},
				]]
				
				{144,4,'*0.75 invert','len'},
				{148,4,'*0.75 no invert','len'},
				{152,4,'*0.75 flip','len'},
				{156,4,'*0.75 no flip','len'},
				
				{160,176,'*0.563 75 flip, *0.563 75 invert','end'},
				{164,176,'*0.19 100 flip, *0.563 no invert','end'},
				{168,176,'*0.563 25 flip, *0.563 -75 invert','end'},
				{172,176,'*0.19 no flip, *0.563 no invert','end'},
				
				--{168,176,'*0.19 75 flip, *0.5625 75 invert','end'},
				--{172,176,'*0.563 no flip, *0.5625 no invert','end'},
				
				--{152,160,'*0.140625 75 flip, *0.5625 75 invert','end'},
				--{156,160,'*0.5625 no flip, *0.5625 no invert','end'},
				
				{160.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{161.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{162.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{163.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{164.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{165.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{166.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{167.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{168.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{169.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1},
				{170.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1},
				{171.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len'},
								
				{160.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{161.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{162.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{163.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{164.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{165.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{166.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{167.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{168.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				{169.5-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2},
				{170.5-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2},
				
				{172,1.5,'*2 reverse','len'},
				{173.5,1.5,'*2 no reverse','len'},
				
				{172,238,'hidden,sudden, 1.6x','end'},
				{172,238,'*10000 -120 hiddenoffset, *10000 -70 suddenoffset','end'},
				--nvm lol
				--{172,240,'*10000 -120 hiddenoffset, *10000 -100 suddenoffset','end'},
				
				{192,200,'1.4x','end'},
				
				{176,7.5,'*1.4 190 hiddenoffset, *1.4 210 suddenoffset','len'},
				{184,7.5,'*1.4 190 hiddenoffset, *1.4 210 suddenoffset','len'},
				{192,7.5,'*1.4 190 hiddenoffset, *1.4 210 suddenoffset','len'},
				{200,7.5,'*1.4 190 hiddenoffset, *1.4 210 suddenoffset','len'},
				
				{208,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{210,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{212,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{214,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{216,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{218,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{220,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{222,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{224,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{226,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{228,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{230,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{232,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{234,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{236,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *1.5 1.2x','len'},
				{238,2,'*3 -130 hiddenoffset, *3 -100 suddenoffset, *1.5 2.2x','len'},
				{240,2,'*3 180 hiddenoffset, *3 210 suddenoffset, *0.75 1.7x','len'},
				
				{204,2,'*1.5 -100 stealth','len'},
				{206,2,'*1.5 no stealth','len'},
				
				{200-.05,2,'*10 invert','len'},
				{201-.05,2,'*10 no invert','len'},
				{202-.05,2,'*10 invert','len'},
				{203-.05,2,'*10 no invert','len'},
				
				{191.5,200,'*1000 100 beat','end'},
				{207.5,32,'*1000 200 beat','len'},
				
				{238.5,1,'*1000 no beat','len'},
				
				{224,1,'*10000 2512 dizzy','len'},
				{225,1,'*10000 no dizzy','len'},
				{226,1,'*10000 -2512 dizzy','len'},
				{227,1,'*10000 no dizzy','len'},
				{228,1,'*10000 2512 dizzy','len'},
				{229,1,'*10000 no dizzy','len'},
				{230,1,'*10000 -2512 dizzy','len'},
				{231,1,'*10000 no dizzy','len'},
				
				--[[
				{225-.05,3,'*10 reverse','len'},
				{227-.05,3,'*10 no reverse','len'},
				{229-.05,3,'*10 reverse','len'},
				{231-.05,3,'*10 no reverse','len'},
				]]
				
				--{240,268,'*3 70 hiddenoffset, *6 200 hidden, *3 40 suddenoffset, *6 200 sudden','end'},
				--{240,268,'*3 wave, *3 flip, *3 -100 tornado, *6 200 bumpy','end'},
				
				--{238,2,'*1.8 0x','len'},
				
				--{240,268,'*1 -800 reverse, *1 99 centered, *6 3000 bumpy, *5 0.03x, *0.3 150 mini','end'},
				--{240.3,268,'*0.01 0.1x','end'},
				
				--{240,268,'*2 250 invert','end'},
				
				{240,4,'*0.75 reverse','len'},
				{244,4,'*0.75 no reverse','len'},
				{248,4,'*0.75 reverse','len'},
				{252,4,'*0.75 no reverse','len'},
				{256,4,'*2 reverse','len'},
				{257.5,4,'*2 no reverse','len'},
				{259,4,'*3 reverse','len'},
				{260,4,'*2 no reverse','len'},
				{261.5,4,'*2 reverse','len'},
				{263,4,'*3 no reverse','len'},
				{264,4,'*4.5 reverse','len'},
				{264.667,4,'*4.5 no reverse','len'},
				{265.333,4,'*4.5 reverse','len'},
				{266,4,'*4.5 no reverse','len'},
				{266.667,4,'*4.5 reverse','len'},
				{267.333,4,'*4.5 no reverse','len'},
				
				{268,4,'*80 no bumpy, *50 0 reverse, *20 no centered, *2 no flip, *10000 0x, *10000 stealth','len'},
				
				{268.2,4,'*1.3 1.6x, *0.75 no stealth','len'},
				
				{256,1.5,'*0.5 -40 stealth','len'},
				{257.5,1.5,'*0.5 0 stealth','len'},
				{260,1.5,'*0.5 -40 stealth','len'},
				{261.5,1.5,'*0.5 0 stealth','len'},
				
				{268,4,'*6 no hidden, *6 no sudden','len'},
				
				{268,4,'*10000 2512 dizzy','len'},
				{272,1,'*10000 no dizzy','len'},
				
				{271.5,299.5,'*10000 beat','end'},
				{299.5,1,'*10000 no beat','len'},
				
				{272,3.5,'*1.2 -93 mini','len'},
				{275.5-.05,0.55,'*10 40 mini','len'},
				{276,3.5,'*1.2 -93 mini','len'},
				{279.5-.05,0.55,'*10 40 mini','len'},
				{280,3.5,'*1.2 -93 mini','len'},
				{283.5-.05,0.55,'*10 40 mini','len'},
				{284-.05,0.55,'*20 -100 mini','len'},
				{284.1,0.55,'*1.1 40 mini','len'},
				
				{288,3.5,'*1.2 -93 mini','len'},
				{291.5-.05,0.55,'*10 40 mini','len'},
				{292,3.5,'*1.2 -93 mini','len'},
				{295.5-.05,0.55,'*10 40 mini','len'},
				{296,3.5,'*1.2 -93 mini','len'},
				{299.5-.05,0.55,'*10 40 mini','len'},
				
				{300-.05,2,'*30 300 hallway','len'},
				{302-.05,2,'*45 -150 hallway','len'},
				{304-.05,2,'*15 no hallway','len'},
				
				{272.00-.05,1,'*10 100 drunk','len'},
				{272.5-.05,1,'*20 -100 drunk','len'},
				{273.25-.05,1,'*20 100 drunk','len'},
				{274.0-.05,1,'*20 -100 drunk','len'},
				{274.75-.05,1,'*20 100 drunk','len'},
				{275.5-.05,1,'*20 -100 drunk','len'},
				{276.00-.05,1,'*20 100 drunk','len'},
				{276.5-.05,1,'*20 -100 drunk','len'},
				{277.25-.05,1,'*20 100 drunk','len'},
				{278.0-.05,1,'*20 -100 drunk','len'},
				{278.75-.05,1,'*20 100 drunk','len'},
				{279.5-.05,1,'*20 -100 drunk','len'},
				{280.00-.05,1,'*10 100 drunk','len'},
				{280.5-.05,1,'*20 -100 drunk','len'},
				{281.25-.05,1,'*20 100 drunk','len'},
				{282.0-.05,1,'*20 -100 drunk','len'},
				{282.75-.05,1,'*20 100 drunk','len'},
				{283.5-.05,1,'*20 -100 drunk','len'},
				{284.00-.05,1,'*20 100 drunk','len'},
				{284.75-.05,1,'*20 -100 drunk','len'},
				{285.50-.05,1,'*20 100 drunk','len'},
				{286.0-.05,1,'*20 -100 drunk','len'},
				{286.75-.05,1,'*20 100 drunk','len'},
				{287.5-.05,1,'*20 -100 drunk','len'},
				
				{288.00-.05,1,'*10 100 drunk','len'},
				{288.75-.05,1,'*20 -100 drunk','len'},
				{289.50-.05,1,'*20 100 drunk','len'},
				{290.25-.05,1,'*20 -100 drunk','len'},
				{291.00-.05,1,'*20 100 drunk','len'},
				{291.50-.05,1,'*20 -100 drunk','len'},
				{292.00-.05,1,'*10 100 drunk','len'},
				{292.75-.05,1,'*20 -100 drunk','len'},
				{293.50-.05,1,'*20 100 drunk','len'},
				{294.25-.05,1,'*20 -100 drunk','len'},
				{295.00-.05,1,'*20 100 drunk','len'},
				{295.50-.05,1,'*20 -100 drunk','len'},
				{296.00-.05,1,'*10 100 drunk','len'},
				{296.75-.05,1,'*20 -100 drunk','len'},
				{297.50-.05,1,'*20 100 drunk','len'},
				{298.25-.05,1,'*20 -100 drunk','len'},
				{299.00-.05,1,'*20 100 drunk','len'},
				{299.50-.05,1,'*20 -100 drunk','len'},
				{300.00-.05,1,'*10 no drunk','len'},
				
				{309-.05,4,'*25 250 invert','len',1},
				{310-.05,4,'*25 250 invert','len',2},
				{311.5-.05,4,'*25 no invert','len',1},
				{312-.05,4,'*25 no invert','len',2},
				
				{342,4,'*0.75 25 mini','len',1},
				{342,4,'*0.75 -25 mini','len',2},
				
				{344,380,'*0.054 75 mini','end',1},
				{344,380,'*0.054 -75 mini','end',2},
				
				{377,8,'*0.8 no mini','len'},
				
				{311.5,335.5,'*10000 400 beat','end'},
				{335.5,4,'*10000 no beat','len'},
				{343.5,367.5,'*10000 400 beat','end'},
				{367.5,4,'*10000 no beat','len'},
				
				------------------------------
				--------SONG 2----------------
				------------------------------
				
				{394,432,'*1.5 dark','end'},
				{396,424,'80 tipsy, 80 drunk','end'},
				
				{411.5,423.5,'*10000 200 beat','end'},
				{423.4,1,'*10000 0 beat','len'},
				
				{432,1,'*5 no dark','len'},
				
				--{432-.05,2,'*60 628 dizzy, *5 50 stealth','len'},
				--{434-.05,1,'*60 0 dizzy, *5 80 stealth','len'},
				
				{434-.05,457,'*5 90 stealth, beat','end'},
				{457-.05,1,'*10 no stealth','len'},
				
				{434,6,'*3 no stealth','len'},
				{446,6,'*3 no stealth','len'},
				
				--the simplest of simple m0d
				{434,457,'expand, bumpy, distant, drunk','end'},
				{434,5,'20 dizzy','len'},
				{440,5,'-20 dizzy','len'},
				{446,5,'20 dizzy','len'},
				{452,5,'-20 dizzy','len'},
				
				{458,0.3,'*20 150 brake, *15 150 drunk','len'},
				{458.3,2,'*5 no brake, *5 no drunk','len'},
				{460,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{460.3,2,'*5 no brake, *5 no drunk','len'},
				{462,0.3,'*20 150 brake, *15 150 drunk','len'},
				{462.3,2,'*5 no brake, *5 no drunk','len'},
				{464,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{464.3,2,'*5 no brake, *5 no drunk','len'},
				{466,0.3,'*20 150 brake, *15 150 drunk','len'},
				{466.3,2,'*5 no brake, *5 no drunk','len'},
				{468,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{468.3,2,'*5 no brake, *5 no drunk','len'},
				{470,0.3,'*20 150 brake, *15 150 drunk','len'},
				{470.3,2,'*5 no brake, *5 no drunk','len'},
				{472,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{472.3,2,'*5 no brake, *5 no drunk','len'},
				
				{474,0.3,'*20 150 brake, *15 150 drunk','len'},
				{474.3,2,'*5 no brake, *5 no drunk','len'},
				{476,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{476.3,2,'*5 no brake, *5 no drunk','len'},
				{478,0.3,'*20 150 brake, *15 150 drunk','len'},
				{478.3,2,'*5 no brake, *5 no drunk','len'},
				{480,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{480.3,2,'*5 no brake, *5 no drunk','len'},
				{482,0.3,'*20 150 brake, *15 150 drunk','len'},
				{482.3,2,'*5 no brake, *5 no drunk','len'},
				{484,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{484.3,2,'*5 no brake, *5 no drunk','len'},
				{486,0.3,'*20 150 brake, *15 150 drunk','len'},
				{486.3,2,'*5 no brake, *5 no drunk','len'},
				{488,0.3,'*20 150 brake, *15 -150 drunk','len'},
				{488.3,2,'*5 no brake, *5 no drunk','len'},
				
				{490,494,'*2.66 200 centered','end'},
				{494,498,'*3.4 200 centered','end'},
				{494-.05,4,'*20 reverse, *10 -50 mini','len'},
				{498-.05,4,'*20 no reverse, *10 no mini','len'},
				{491-.05,0.2,'*50 no centered','len'},
				{492-.05,0.2,'*50 no centered','len'},
				{493-.05,0.2,'*50 no centered','len'},
				{494-.05,0.2,'*50 no centered','len'},
				{495-.05,0.2,'*50 no centered','len'},
				{496-.05,0.2,'*50 no centered','len'},
				{497-.05,0.2,'*50 no centered','len'},
				{498-.05,0.2,'*50 no centered','len'},
				
				{494.000-.05,2,'*10 100 drunk','len'},
				{495.000-.05,2,'*20 -100 drunk','len'},
				{496.000-.05,2,'*20 100 drunk','len'},
				{497.000-.05,2,'*20 -100 drunk','len'},
				{498.000-.05,2,'*10 no drunk','len'},
				
				{497.5,5,'*1000 300 beat','len'},
				{502.5,5,'*1000 no beat','len'},
				
				{505.5,561.5,'*1000 150 beat','end'},
				{561.5,1,'*1000 no beat','len'},
				
				{506-.1,8,'*10 hallway','len'},
				{510-.1,8,'*20 distant','len'},
				{514-.1,8,'*20 hallway','len'},
				{518-.1,8,'*20 distant','len'},
				{522-.1,8,'*20 space','len'},
				{526-.1,8,'*20 incoming','len'},
				{530-.1,8,'*10 no incoming','len'},
				
				{538-.1,8,'*15 150 hallway','len'},
				{542-.1,8,'*30 150 distant','len'},
				{546-.1,8,'*30 150 hallway','len'},
				{550-.1,8,'*30 150 distant','len'},
				{554-.1,8,'*30 150 space','len'},
				{558-.1,8,'*30 150 incoming','len'},
				{562-.1,8,'*15 no incoming','len'},
				
				{569,596,'*100 -800 reverse, *100 99 centered, *10 100 dark, *1000 0x','end'},
				{569.1,596,'*0.1 0.05x, *5 200 sudden, *2 -98 suddenoffset','end'},
				{569.1,596,'*100 no drunk, *100 no tipsy, *100 -6000 bumpy, *100 80 stealth, *30 1256 dizzy, -50 hallway, *1 1000 beat','end'},
				{569.2,596,'*0.1 -100 flip,*0.5 300 tornado','end'},
				
				{595.5,4,'*1000 no beat','len'},
				{596,4,'*80 no bumpy, *2 no stealth, *5 no tornado, *20 no dizzy, no dark, *15 35 reverse, *5 no centered, *2 no flip, *1000 0x','len'},
				{596.1,4,'*1 2x, *10 no sudden','len'},
				
				{599-.05,4,'*3 no reverse','len'},
				
				--{596,},
				
				--[[
					MODS:TIME=32.727:LEN=3:MODS=*15 Invert;
					MODS:TIME=33.000:LEN=3:MODS=*15 -100% invert,*9 Flip;
					MODS:TIME=33.273:LEN=3:MODS=*10 No invert,*15 Flip;
					MODS:TIME=33.545:LEN=3:MODS=*15 -100% invert,*15 Flip;
					MODS:TIME=33.818:LEN=3:MODS=*15 invert,*15 No Flip;
					MODS:TIME=34.091:LEN=3:MODS=*15 No invert,*15 No Flip;
				]]
				
				{628.0-.05,1,'*10 no flip, *10 invert','len'},
				{628.5-.05,1,'*10 flip, *20 -100 invert','len'},
				{629.0-.05,1,'*10 flip, *10 no invert','len'},
				{629.5-.05,1,'*10 flip, *10 -100 invert','len'},
				{630.0-.05,1,'*10 no flip, *20 100 invert','len'},
				{630.5-.05,1,'*10 no flip, *10 no invert','len'},
				
				{631-.05,1,'*5 50 stealth, *251 2512 dizzy','len'},
				{632-.05,1,'*5 no stealth, *251 no dizzy','len'},
				
				{664,494+174,'*2.66 200 centered','end'},
				{668,498+174,'*3.4 200 centered','end'},
				{668-.05,4,'*20 reverse, *10 -50 mini','len'},
				{672-.05,4,'*20 no reverse, *10 no mini','len'},
				{665-.05,0.2,'*50 no centered','len'},
				{666-.05,0.2,'*50 no centered','len'},
				{667-.05,0.2,'*50 no centered','len'},
				{668-.05,0.2,'*50 no centered','len'},
				{669-.05,0.2,'*50 no centered','len'},
				{670-.05,0.2,'*50 no centered','len'},
				{671-.05,0.2,'*50 no centered','len'},
				{672-.05,0.2,'*50 no centered','len'},
				
				{668-.05,2,'*10 100 drunk','len'},
				{669-.05,2,'*20 -100 drunk','len'},
				{670-.05,2,'*20 100 drunk','len'},
				{671-.05,2,'*20 -100 drunk','len'},
				{672-.05,2,'*10 no drunk','len'},
				
				{692-.1,8,'*10 hallway','len'},
				{696-.1,8,'*20 distant','len'},
				{700-.1,8,'*20 space','len'},
				{704-.1,8,'*20 incoming','len'},
				{708-.1,8,'*10 no incoming','len'},
								
				{716-.1,8,'*15 150 hallway','len'},
				{720-.1,8,'*30 150 distant','len'},
				{724-.1,8,'*30 150 hallway','len'},
				{728-.1,8,'*30 150 distant','len'},
				{732-.1,8,'*30 150 space','len'},
				{736-.1,8,'*30 150 incoming','len'},
				{740-.1,8,'*15 no incoming','len'},
				
				{506,534,'*0.2 100 bumpy','end'},
				{534-.05,1,'*10 no bumpy','len'},
				
				{538,566,'*0.2 100 bumpy','end'},
				{566-.05,1,'*10 no bumpy','len'},
				
				{692,534+178,'*0.2 100 bumpy','end'},
				{534-.05+178,1,'*10 no bumpy','len'},
				
				{538+178,566+178,'*0.2 100 bumpy','end'},
				{566-.05+178,1,'*10 no bumpy','len'},
				
				{716,740,'*0.2 50 drunk','end'},
				{740,1,'*2 no drunk','len'},
				
				{508,1,'*10000 flip','len'},
				{512,1,'*10000 invert','len'},
				{516,1,'*10000 75 flip, *10000 75 invert','len'},
				
				{518-.05,1,'*10 invert','len'},
				{518.75-.05,1,'*10 no invert','len'},
				{519.50-.05,1,'*10 invert','len'},
				{520-.05,1,'*10 no invert','len'},
				
				{520,1,'*1.5833 50 reverse','len'},
				{521,1,'*1.5833 no reverse','len'},
				
				{550-.05,1,'*10 invert','len'},
				{550.75-.05,1,'*10 no invert','len'},
				{551.50-.05,1,'*10 invert','len'},
				{552-.05,1,'*10 no invert','len'},
				
				{540,1,'*10000 100 flip, *10000 -100 invert','len'},
				{544,1,'*10000 75 flip, *10000 -125 invert','len'},
				{548,1,'*10000 25 flip, *10000 125 invert','len'},
				
				{552,1,'*1.5833 50 reverse','len'},
				{553,1,'*1.5833 no reverse','len'},
				
				{562,1,'*3.166 tornado','len'},
				{563,1,'*3.166 no tornado','len'},
				{564,1,'*3.166 tornado','len'},
				{565,1,'*3.166 no tornado','len'},
				{566.0,1,'*6.333 tornado','len'},
				{566.5,1,'*6.333 no tornado','len'},
				{567.0,1,'*6.333 tornado','len'},
				{567.5,1,'*6.333 no tornado','len'},
				
				{568,1,'*100 50 dark','len'},
				
				{612-.05,4,'*6 1.25x','len'},
				{616-.05,1,'*6 2x','len'},
								
				{680-.05,0.5,'*10 0 flip, *10 100 invert','len'},
				{680.5-.05,0.5,'*10 100 flip, *20 -100 invert','len'},
				{681-.05,0.5,'*10 100 flip, *10 no invert','len'},
				{681.5-.05,0.5,'*10 0 flip, *10 no invert','len'},
				
				{676,692,'1x','end'},
				{691.5-.05,9999,'*5 2x','end'},
				
				{694,1,'*10000 75 flip, *10000 75 invert','len'},
				
				{696-.05,1,'*10 invert','len'},
				{696.75-.05,1,'*10 no invert','len'},
				{697.50-.05,1,'*10 invert','len'},
				{698-.05,1,'*10 no invert','len'},
								
				{698,1,'*1.5833 50 reverse','len'},
				{699,1,'*1.5833 no reverse','len'},
								
				{728-.05,1,'*10 invert','len'},
				{728.75-.05,1,'*10 no invert','len'},
				{729.50-.05,1,'*10 invert','len'},
				{730-.05,1,'*10 no invert','len'},
								
				{718,1,'*10000 100 flip, *10000 -100 invert','len'},
				{722,1,'*10000 75 flip, *10000 -125 invert','len'},
				{726,1,'*10000 25 flip, *10000 125 invert','len'},
				
				{683,690,'*3.16 100 flip, *3.16 -100 invert','end'},
				
				{690-.05,0.5,'*2.5 75 flip, *2.5 -125 invert','len'},
				{690.5-.05,0.5,'*7.5 0 flip, *22.5 100 invert','len'},
				{691-.03,1,'*30 66 invert','len'},
				{691.25-.03,1,'*30 33 invert','len'},
				{691.5-.03,1,'*30 0 invert','len'},
				
				{708,4,'*10 mini','len'},
				
				{708.00,1,'*10000 flip, *10000 no invert','len'},
				{708.50,1,'*10000 invert, *10000 no flip','len'},
				{708.75,1,'*10000 -100 invert, *10000 flip','len'},
				{709.00,1,'*10000 invert, *10000 no flip','len'},
				{709.50,1,'*10000 no invert, *10000 no flip','len'},
				
				{710,1,'*10000 30 mini, *10000 -100 hallway','len'},
				{710,1,'*10000 60 mini, *10000 hallway','len'},
				{712,1,'*10000 mini, *10000 no hallway','len'},
				
				{711.5,4,'*10000 1000 beat','len'},
				{712,1,'*5 60 mini','len'},
				{711.5,4,'*10000 800 beat','len'},
				{713,1,'*5 20 mini','len'},
				{711.5,4,'*10000 600 beat','len'},
				{714,1,'*5 -20 mini','len'},
				{711.5,4,'*10000 400 beat','len'},
				{715,1,'*5 -60 mini','len'},
				{715.5,739.5,'*10000 200 beat','end'},
				{716,748.5,'*5 -100 mini, *2 1.5x','end'},
				
				--[[
				{740.00-.05,0.75,'*10 invert','len'},
				{740.75-.05,0.75,'*10 no invert','len'},
				{741.50-.05,0.75,'*10 invert','len'},
				{742.25-.05,0.75,'*10 no invert','len'},
				{743.00-.05,1,'*10 invert','len'},
				
				{744.00-.05,0.75,'*10 no invert','len'},
				{744.75-.05,0.75,'*10 invert','len'},
				{745.50-.05,0.5,'*10 no invert','len'},
				]]
				
				{747.667,3,'*80 50x','len'},
				{753,1,'*100 2x','len'},
				
				------------------------------
				--------SONG 3----------------
				------------------------------
				
				{762,786,'1x','end'},
				
				{761,1,'*10000 50 dark','len'},
				{753,786,'*2 stealth, *1 dark','end'},
				
				{758,4,'*10000 stealth, *10000 dark','len',2},
				
				{754,8,'*5 50 stealth','len',1},
				
				{763.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',1},
				{765.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',2},
				{767.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',1},
				{770.0-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',2},
				{771.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',1},
				{773.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',2},
				{775.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',1},
				{777.0-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',2},
				{778.0-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',1},
				{779.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',2},
				{781.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',1},
				{783.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len',2},
				
				{762,786,'*100000 reverse','end',2},
				{786,1,'*100000 no reverse','len'},
				
				{758,786,'blind','end'},
				
				{868,993.5,'*10.291 650 invert','end'},
				
				{930,34,'*2 0.95x','len'},
				
				{934,16,'*1.425 90 centered','len'},
				{937,16,'*1.425 180 centered','len'},
				--{940,16,'*2.85 no centered, *1.425 reverse','len'},
				{940-.05,16,'*20 no centered, *10 reverse','len'},
				
				{942,16,'*1.425 90 centered','len'},
				{945,16,'*1.425 180 centered','len'},
				--{948,16,'*2.85 no centered, *1.425 no reverse','len'},
				{948-.05,16,'*20 no centered, *10 no reverse','len'},
				
				{950,16,'*1.425 90 centered','len'},
				{953,16,'*1.425 180 centered','len'},
				--{956,16,'*2.85 no centered, *1.425 reverse','len'},
				{956-.05,16,'*20 no centered, *10 reverse','len'},
								
				{958,16,'*1.425 90 centered','len'},
				{961,16,'*1.425 180 centered','len'},
				--{964,16,'*2.85 no centered, *1.425 no reverse','len'},
				{964-.05,16,'*20 no centered, *10 no reverse','len'},
				
				{966,990,'1x','end'},
				
				{965,1,'*10000 50 dark','len'},
				{966,990,'*2 stealth, *1 dark','end'},
				
				{967.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{969.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{971.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{974.0-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{975.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{977.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{979.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{981.0-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{982.0-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{983.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{985.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				{987.5-.00,0.13,'*100000 50 stealth, *100000 75 dark','len'},
				
				{997.5,28,'*1000 150 beat','len'},
				
				{993.5,3,'*13.6 no invert','len'},
				
				--ending lol fuck you
				{966,999,'blind','len'},
				
				{1013.5,4,'*10000 reverse','len'},
				{1017.5,4,'*10000 no reverse','len'},
				{1021.5,4,'*10000 reverse','len'},
				{1025.5,4,'*10000 no reverse','len'},
				
				--lol ruuude
				{1038,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1046,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1054,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1062,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1070,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1078,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1086,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1094,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1102,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1110,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1118,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1126,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1134,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				{1142,8,'*'..(3.9583*e_aspect)..' no invert','len'},
				{1150,8,'*'..(3.9583*e_aspect)..' '..(250*e_aspect)..' invert','len'},
				
				{1157.55,8,'*100000 no invert','len'},
				
				{1025.5,1200,'1.66x','end'},
				
				{1030,1,'*10000 no invert','len'},
				
				{1030,1200,'*4 1.66x, *2 no stealth, *2 no tornado','end'},
				
				{1058,4,'*0.9 0.6x','len'},
				{1062,0.2,'*50 50 stealth','len'},
				{1090,4,'*0.9 0.6x','len'},
				{1094,0.2,'*50 50 stealth','len'},
				{1122,4,'*0.9 0.6x','len'},
				{1126,0.2,'*50 50 stealth','len'},
				{1154,4,'*0.9 0.6x','len'},
				{1158,0.2,'*50 50 stealth','len'},
				
				{1126,32,'*1.5833 centered','len'},
				{1126,32,'*1.5833 reverse','len',2},
				
				{1157.5,32,'*100000 no reverse, *100000 no centered, *100000 1.66x','len'},
				
				--{1157.6,32,'*0.3 400 centered','len'},
				
				{1173.5,999,'*5 2000 drunk, *5 2000 tipsy, stealth, dark, -150 mini','len'},

			}
			
			------------------------------
			--------SONG 1----------------
			------------------------------
			
			simple_m0d2(72-.05,200,1.3,'tornado'); --FIREEEE
			
			simple_m0d(88,200,0.2,'drunk');
			simple_m0d(88.75,200,0.2,'drunk');
			simple_m0d(89.5,200,0.2,'drunk');
			simple_m0d(90,200,0.2,'tipsy');
			simple_m0d(90.75,200,0.2,'tipsy');
			simple_m0d(91.5,200,0.2,'tipsy');
			simple_m0d(92,200,0.2,'drunk');
			simple_m0d(92.75,200,0.2,'drunk');
			simple_m0d(93.5,200,0.2,'drunk');
			simple_m0d(94,200,0.2,'tipsy');
			simple_m0d(94.75,200,0.2,'tipsy');
			simple_m0d(95.5,200,0.2,'tipsy');
			
			simple_m0d(104,200,0.2,'drunk');
			simple_m0d(104.75,200,0.2,'drunk');
			simple_m0d(105.5,200,0.2,'drunk');
			simple_m0d(106,200,0.2,'tipsy');
			simple_m0d(106.75,200,0.2,'tipsy');
			simple_m0d(107.5,200,0.2,'tipsy');
			simple_m0d(108,200,0.133,'drunk');
			simple_m0d(108.5,200,0.133,'drunk');
			simple_m0d(109,200,0.133,'tipsy');
			simple_m0d(109.5,200,0.133,'tipsy');
			simple_m0d2(109.75-.05,100,1.3,'tornado');
			
			local fluct = 1;
			local amt = 400;
			for i=0,15 do
				local beat = (140+i/4)-.05
				local m = 1
				if i==0 then m = 0.5 end
				table.insert(mods,{beat,0.25,'*'..(m*amt/10)..' '..(amt*fluct)..' tipsy','len',1});
				table.insert(mods,{beat,0.25,'*'..(m*amt/10)..' '..(amt*fluct*-1)..' tipsy','len',2});
				fluct = fluct*-1;
			end
			table.insert(mods,{144-.05,1,'*'..(amt/20)..' no tipsy','len'});
			
			mod_ezbeat(175,1000);
			mod_ezbeat(200,400);
			mod_ezbeat(202,400);
			
			mod_ezbeat(225,1000);
			mod_ezbeat(227,1000);
			mod_ezbeat(229,1000);
			mod_ezbeat(231,1000);
			
			for i=0,5 do
				simple_m0d(240+(i*4),-300,0.4,'drunk');
				simple_m0d(241.5+(i*4),300,0.4,'drunk');
				simple_m0d(243+(i*4),300,0.4,'tipsy');
			end
			
			--mod_wiggle(beat,num,div,amt,mod)
			mod_wiggle(264-.1,6,1.5,120,'drunk');
			
			simple_m0d2(268-.05,100,1.3,'tornado');
			
			simple_m0d2(304-.05,200,1.3,'tornado'); --THUNDEEERRRRR
			
			local b = 312
			while b<336 do
				table.insert(mods,{b-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1});
				table.insert(mods,{b+1-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1});
				table.insert(mods,{b-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2});
				table.insert(mods,{b+1-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2});
				b = b+2;
			end
			table.insert(mods,{336-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len'});
			
			local b = 344
			while b<368 do
				table.insert(mods,{b-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1});
				table.insert(mods,{b+1-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1});
				table.insert(mods,{b-.05,1,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2});
				table.insert(mods,{b+1-.05,1,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2});
				b = b+2;
			end
			
			table.insert(mods,{368-.1,2,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1});
			table.insert(mods,{368-.1,2,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2});
			
			table.insert(mods,{369.75-.1,2,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2});
			table.insert(mods,{369.75-.1,2,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1});
			
			table.insert(mods,{372-.1,2,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',1});
			table.insert(mods,{372-.1,2,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',2});
			
			table.insert(mods,{373.75-.1,2,'*10 stealth,*20 200 drunk,*10 dark,*20 200 tipsy','len',2});
			table.insert(mods,{373.75-.1,2,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len',1});
			
			table.insert(mods,{376-.05,1.5,'*10 no stealth,*20 no drunk,*10 no dark,*20 no tipsy','len'});
			
			simple_m0d2(380-.05,200,3.9,'tornado'); --ending
			
			------------------------------
			--------SONG 2----------------
			------------------------------
			
			function br_invVib14(beat)
				local amt = 25;
				local fluct = 1;
				for i=1,16 do
					local b = beat+((i-1)/4)-.03;
					table.insert(mods,{b,0.25,'*'..math.abs(amt*2)..' '..(amt*fluct)..' invert','len'});
					if fluct == 0 then
						if i<8 then
							amt = amt+25;
						else
							amt = amt-25;
						end
					end
					if fluct == 1 then fluct = 0 else fluct = 1 end
				end
			end
			
			function br_invVib16(beat)
				local amt = 20;
				local fluct = 1;
				for i=1,16 do
					local b = beat+((i-1)/4)-.03;
					table.insert(mods,{b,0.25,'*'..math.abs(amt*2)..' '..(amt*fluct)..' invert','len'});
					if fluct == 0 then
						if i<9 then
							amt = amt+20;
						else
							amt = amt-20;
						end
					end
					if fluct == 1 then fluct = 0 else fluct = 1 end
				end
			end
			
			local def = 0;
			local amt = 0;
			for i=0,22 do
				table.insert(mods,{434.25+i,0.25,'*'..(math.abs(amt-def)*0.25)..' '..amt..' bumpy','len'});
				table.insert(mods,{434.5+i,0.25,'*'..(math.abs(amt-def)*0.25)..' '..def..' bumpy','len'});
				amt = amt+30;
			end
			
			simple_m0d2(672-.05,100,1.3,'tornado'); --lol
			simple_m0d2(676-.05,2000,1.3,'drunk'); --lol
			
			function LAZY1(beat)
				simple_m0d(beat,100,0.3,'tornado');
				simple_m0d(beat,-200,0.3,'mini');
			end
			
			--mod_wiggle(beat,num,div,amt,mod)
			mod_wiggle(488-.1,6,3,300,'tipsy');
			
			mod_wiggle(459-.05,3,3,200,'tipsy');
			mod_wiggle(461-.05,15,3,200,'tipsy');
			mod_wiggle(467-.05,3,3,200,'tipsy');
			mod_wiggle(469-.05,15,3,200,'tipsy');
			
			mod_ezbeat(490,800);
			mod_ezbeat(494,800);
			
			simple_m0d(432,-200,0.6,'mini');
			simple_m0d(746,-200,0.6,'mini');
			
			simple_m0d2(502-.05,100,1,'tornado');
			
			LAZY1(632);
			LAZY1(635.667);
			LAZY1(640);
			LAZY1(643.667);
			
			for i=0,5 do
				--mod_ezbeat(648+(2*i),100)
				mod_ezbeat(649+(2*i),200)
			end
			
			mod_ezbeat(663,1000)
			mod_ezbeat(664,800)
			mod_ezbeat(668,800)
			mod_ezbeat(672,800)
			
			--{'*0.6 no reverse, *0.4 16 split, *0.2 8 alternate'}
			--{'*0.6 24 reverse, *0.4 -16 split, *0.2 -8 alternate'}
			
			simple_m0d2(534-.1,200,0.6,'tornado');
			
			br_invVib16(522);
			br_invVib16(526);
			br_invVib16(554);
			br_invVib16(558);
			
			simple_m0d2(568-.1,200,0.6,'tipsy');
			
			--table.insert(mods,{569,1,'*20 2000 drunk, *20 2000 tipsy, dark','len'});
			--fuck
			
			mod_ezbeat(599,800);
			
			br_invVib16(700);
			br_invVib16(704);
			br_invVib16(732);
			br_invVib16(736);
			
			------------------------------
			--------SONG 3----------------
			------------------------------
			
			simple_m0d2(786-.05,50,2,'stealth');
			
			simple_m0d2(786-.05,200,1.4,'drunk');
			simple_m0d2(787.5-.05,200,1.4,'tipsy');
			simple_m0d2(789.5-.05,-200,1.4,'drunk');
			
			function mod_bwow(beat)
				table.insert(mods,{beat-.1,1,'*20 300 bumpy','len'});
				table.insert(mods,{beat+.9,4,'*5 no bumpy','len'});
			end
			
			for i=0,6 do
				mod_bwow(870+(i*8));
			end
			
			local br_cleoIntro = {805.5,806.5,807.5,808.5,809.5,817.5,819,819.5,821,821.5,822.5,823.5,824.5,
			837.5,838.5,839.5,840.5,841.5,851,851.5,852.5}
			
			for i=794,805 do
				table.insert(br_cleoIntro,i);
			end
			for i=810,817 do
				table.insert(br_cleoIntro,i);
			end
			for i=826,837 do
				table.insert(br_cleoIntro,i);
			end
			for i=842,850 do
				table.insert(br_cleoIntro,i);
			end
			
			--end at 853
			
			table.sort(br_cleoIntro, list_compare)
			
			local dfluct = 1
			local damt = 90;
			local bamt = 60;
			for i=1,table.getn(br_cleoIntro) do
				local b = br_cleoIntro[i]
				local m = 1;
				local dur = 1;
				if i < table.getn(br_cleoIntro)-1 then dur = br_cleoIntro[i+1]-br_cleoIntro[i] end
				if i==0 and not first then m = 0.5 end
				
				table.insert(mods,{b,dur,'*'..math.abs(m*damt/10)..' '..(damt*dfluct)..' drunk','len'});
				simple_m0d(b,bamt,0.3,'brake');
				
				dfluct = dfluct*-1;
				damt = damt+1.3;
				bamt = bamt+0.5;
			end
			
			simple_m0d(854,-300,0.2,'drunk');
			simple_m0d(855,300,0.2,'drunk');
			simple_m0d(856,300,0.2,'tipsy');
			
			simple_m0d(857,100,0.2,'invert');
			simple_m0d(858,100,0.2,'invert');
			simple_m0d(859,300,0.2,'drunk');
			simple_m0d(860,300,0.2,'tipsy');
			
			--mod_wiggle(beat,num,div,amt,mod)
			mod_wiggle(862,12,2,150,'drunk');
			local amt = 80
			for i=862,867.5,0.5 do
				simple_m0d(i,amt,0.3,'brake');
				amt = amt+1;
			end
			
			mod_wiggle(851,8,4,200,'tipsy');
			
			--simple_m0d(beat,strength,mult,mod)
			for i=0,2 do
				simple_m0d2(876-.05+(8*i),-100,1,'tornado');
			end
			simple_m0d2(916-.05,-100,1,'tornado');
			simple_m0d2(924-.05,-100,1,'tornado');
			simple_m0d2(930-.05,200,0.6,'tornado');
			
			local fluct = 1;
			for i=0,3 do
				mod_ezbeat(936+(8*i),300*fluct)
				mod_ezbeat(939+(8*i),-300*fluct)
				mod_ezbeat(940+(8*i),800*fluct)
				fluct=fluct*-1;
			end
			
			for j=0,2 do
				local b = 939.5+(j*8);
				local fluct = 1
				for i=0,13 do
					local f = math.max(fluct,0.5);
					table.insert(mods,{b+(i*0.125),0.25,'*100000 '..(100*f)..' stealth','len'});
					fluct = fluct*-1;
				end
			end
			
			local b = 951-.1
			for i=0,1 do
				simple_m0d2(b+(i*1.5),-200,0.3,'brake');
			end
			local b = 959-.1
			for i=0,1 do
				simple_m0d2(b+(i*1.5),-200,0.3,'brake');
			end
			
			for j=0,3 do
				local amt = 200
				local fluct = 1
				for i=0,3 do
					local beat = (934+(i/2)-.05)+(j*8)
					local m = 1
					if i==0 then m = 0.5 end
					table.insert(mods,{beat,1,'*'..(m*amt/10)..' '..(amt*fluct)..' drunk','len',1});
					fluct = fluct*-1;
				end
				table.insert(mods,{936-.05+(j*8),1,'*'..(amt/20)..' no drunk','len'});
				
				local amt = 200
				local fluct = 1
				for i=0,3 do
					local beat = (937+(i/2)-.05)+(j*8)
					local m = 1
					if i==0 then m = 0.5 end
					table.insert(mods,{beat,1,'*'..(m*amt/10)..' '..(amt*fluct)..' drunk','len',2});
					fluct = fluct*-1;
				end
				table.insert(mods,{939-.05+(j*8),1,'*'..(amt/20)..' no drunk','len'});
			end
			
			--alternates a mod back and forth before resetting to 0
			--beat,num,div,amt,mod,pn
			for j=0,3 do
				for i=0,2 do
					mod_wiggle(1038-.05+(i*8)+(j*32),3,2,50,'brake',1);
					mod_wiggle(1038-.05+(i*8)+(j*32),3,2,-50,'brake',2);
				end
			end
			
			mod_wiggle(1158,31,2,80,'drunk');
			
			simple_m0d2(1025.5-.05,200,1.3,'tornado');
			simple_m0d2(1025.5-.05,200,1.3,'hallway',1);
			simple_m0d2(1025.5-.05,-200,1.3,'hallway',2);
			
			simple_m0d2(1062-.05,100,0.6,'tornado');
			simple_m0d2(1094-.05,100,0.6,'tornado');
			simple_m0d2(1126-.05,100,0.6,'tornado');
			
			simple_m0d2(1050-.05,800,1,'bumpy');
			simple_m0d2(1082-.05,400,1,'bumpy');
			simple_m0d2(1114-.05,800,1,'bumpy');
			simple_m0d2(1146-.05,600,1,'bumpy');
			
			for i=1030,1061 do
				simple_m0d2(i,50,0.08,'stealth',1);
				simple_m0d2(i+0.5,50,0.08,'stealth',2);
			end
			
			for i=1064,1093 do
				simple_m0d2(i,50,0.08,'stealth',1);
				simple_m0d2(i+0.5,50,0.08,'stealth',2);
			end
			
			for i=1096,1125 do
				simple_m0d2(i,50,0.08,'stealth',1);
				simple_m0d2(i+0.5,50,0.08,'stealth',2);
			end
			
			for i=1128,1157 do
				simple_m0d2(i,50,0.08,'stealth',1);
				simple_m0d2(i+0.5,50,0.08,'stealth',2);
			end
			
			--time based mods
			mod_time = 0;
			--{time_start, time_end, mods, len_or_end, player_number}
			mods2 = {
			--{0,200,'3x','end',1},
			}

			--SCREAMING GUMBALL / timed message broadcaster
			--they no longer have to be in order, because they're sorted now
			curmessage = 1;
			--{beat,message,persists}
			messages = {
			
			------------------------------
			--------SONG 1----------------
			------------------------------
			
			{5-.1,'Sphinx'},
			
			{48,'Oao'},
			{64,'Oao'},
			
			{83,'br_spinnyL'},
			{87,'br_spinnyR'},
			{99,'br_spinnyL'},
			{103,'br_spinnyR'},
			
			{109.75,'CenterBoth'},
			
			{200,'RedrawLots'},
			
			{272-.1,'Diddlydid1'},
			{276-.1,'Diddlydid1'},
			{280-.1,'Diddlydid1'},
			
			{284-.1,'Diddlydid3'},
			
			{288-.1,'Diddlydid2'},
			{292-.1,'Diddlydid2'},
			{296-.1,'Diddlydid2'},
			
			{300-.05,'StraightenZ'},
			{304-.05,'StraightenX'},
			
			{311.5-.05,'Sphinx2'},
			{377-.1,'Sphinx3'},
			
			------------------------------
			--------SONG 2----------------
			------------------------------
			
			--[[
			{458-.05,'Squash'},
			{460-.05,'Squash'},
			{462-.05,'Squash'},
			{464-.05,'Squash'},
			{466-.05,'Squash'},
			{468-.05,'Squash'},
			{470-.05,'Squash'},
			{472-.05,'Squash'},
			]]
			
			{475-.05,'Squash'},
			{477-.05,'Squash'},
			{479-.05,'Squash'},
			{481-.05,'Squash'},
			{483-.05,'Squash'},
			{485-.05,'Squash'},
			
			{498,'GetSmaller'},
			
			--[[
			{522,'ZoomVibR16'},
			{526,'ZoomVibL16'},
			{554,'ZoomVibR16'},
			{558,'ZoomVibL16'},
			{700,'ZoomVibR16'},
			{704,'ZoomVibL16'},
			{732,'ZoomVibR16'},
			{736,'ZoomVibL16'},
			]]
			
			{596-.02,'CenterScreen'},
			{596,'CenterPlayersTemp'},
			{596.03,'RotateScreen'},
			{600-.05,'MoveScreen1'},
			{608-.05,'MoveScreen2'},
			{616-.05,'MoveScreen3'},
			{624,'Kaka'},
			{628,'RevertScreen'},
			
			{682,'br_spinnyZR'},
			
			{712-.05,'SquishyX'},
			{740-.05,'Tilts'},
			{746,'UnSquishyX'},
			
			------------------------------
			--------SONG 3----------------
			------------------------------
			
			{758,'CenterBothQNF'},
			
			{762,'Rotate1L'},
			{762,'Rotate2L'},
			
			{763.5,'Rotate1R'},
			{765.5,'Rotate2R'},
			{767.5,'Rotate1L'},
			{770.0,'Rotate2L'},
			{771.5,'Rotate1R'},
			{773.5,'Rotate2R'},
			{775.5,'Rotate1L'},
			{777.0,'Rotate2L'},
			{778.0,'Rotate1R'},
			{779.5,'Rotate2R'},
			{781.5,'Rotate1L'},
			{783.5,'Rotate2L'},
			
			{785.75,'UnCenterBothQNF'},
			
			--[[
			{805.5,'BootyShake'},
			{821.5,'BootyShake2'},
			{837.5,'BootyShake'},
			]]
			
			{850,'CenterBoth3Beats'},
			{856,'Flight'},
			
			{868,'CenterJoin',true},
			{870,'BWEAOW1'},
			{878,'BWEAOW2'},
			{886,'BWEAOW1'},
			{894,'BWEAOW3'},
			
			{902,'BWEAOW1'},
			{908,'DerDouDa'},
			{910,'BWEAOW2'},
			{918,'BWEAOW1'},
			{926,'BWEAOW4'},
			
			{934,'SkewIt'},
			{942,'UnSkewIt'},
			{950,'SkewIt2'},
			{958,'UnSkewIt'},
			
			{964.5,'DerDouDa2'},
			
			{966.0,'ChangeTiltMode'},
			
			{974.0,'Rotate2L'},
			{975.5,'Rotate1R'},
			{977.5,'Rotate2R'},
			{979.5,'Rotate1L'},
			{981.0,'Rotate2L'},
			{982.0,'Rotate1R'},
			{983.5,'Rotate2R'},
			{985.5,'Rotate1L'},
			{987.5,'Rotate2L'},
			
			{990.0,'Rotate1R'},
			{991.5,'Rotate2R'},
			
			--{993.5,'BeginSpinny'},
			--{998,'MainSpinny'},
			--{1026,'StopSpinny'},
			
			{993.5,'BeginTanFuck'},
			{998,'CenterBothQ',true},
			
			{998,'Snack',true},
			
			{1029.98,'WhiteFlash'},
			{1029.99,'SetupEnding',true},
			
			{1038,'Wawawawa'},
			{1046,'Wawawawa'},
			{1054,'Wawawawa'},
			{1062,'BeginSection2'},
			{1064,'Section2Wag'},
			{1070,'Wawawawa'},
			{1078,'Wawawawa'},
			{1086,'Wawawawa'},
			{1094,'BeginSection3'},
			{1102,'Wawawawa'},
			{1110,'Wawawawa'},
			{1118,'Wawawawa'},
			{1126,'BeginSection4'},
			{1134,'Wawawawa'},
			{1142,'Wawawawa'},
			{1150,'Wawawawa'},
			{1157.5,'WhiteFlash'},
			{1157.5,'FinalEnding'},
			
			}
			
			
			
			--chara/background control!
			curaction = 1
			mod_actions = {
				---------------------
				------SONG 1---------
				---------------------
				{8,function(self)
					char_imho:x(SCREEN_CENTER_X);
					char_imho:y(SCREEN_CENTER_Y);
					char_imho:queuecommand('Spawn');
				end,true},
				{72,function(self)
					char_imho:playcommand('Cast');
					MESSAGEMAN:Broadcast('TagFire');
				end},
				{80,function(self)
					br_bg:linear(0.5);
					br_bg:diffuse(0.4,0.8,0.2,0.7);
				end},
				{110,function(self)
					br_bg:linear(0.5);
					br_bg:diffusealpha(0);
					char_imho:queuecommand('Hide');
				end},
				{144,function(self)
					char_imho:playcommand('Idle');
					char_imho:queuecommand('Spawn');
				end,true},
				{160,function(self)
					char_imho:playcommand('Attack');
				end},
				{175,function(self)
					char_imho:queuecommand('Hide');
				end},
				{304,function(self)
					char_imho:playcommand('Cast');
					char_imho:queuecommand('Spawn');
				end},
				{311,function(self)
					char_imho:decelerate(60/150);
					char_imho:x(SCREEN_CENTER_X-240);
				end},
				{312,function(self)
					br_bg:linear(0.5);
					br_bg:diffusealpha(0.7);
					char_imho:playcommand('Attack');
					MESSAGEMAN:Broadcast('TagThunder');
				end},
				{334,'TagThunderOff'},
				{344,'TagThunder'},
				{366,'TagThunderOff'},
				{375,function(self)
					br_bg:linear(0.5);
					br_bg:diffusealpha(0);
					char_imho:queuecommand('Hide');
				end,true},
				
				---------------------
				------SONG 2---------
				---------------------
				
				{434,function(self)
					char_imho:x(SCREEN_CENTER_X);
					char_imho:y(SCREEN_CENTER_Y);
					char_imho:playcommand('Idle');
					char_imho:queuecommand('Spawn');
				end,true},
				{502,function(self)
					char_imho:playcommand('Cast');
					br_bg:linear(0.5);
					br_bg:diffuse(0.8,0.3,0.2,0.7);
				end},
				{568,function(self)
					char_imho:playcommand('Hide');
					br_bg:linear(0.5);
					br_bg:diffusealpha(0);
				end},
				
				{632,function(self)
					char_imho:playcommand('Attack');
					char_imho:queuecommand('Spawn');
				end,true},
				
				{663,function(self)
					char_imho:playcommand('Hide');
				end},
				
				{690,function(self)
					char_imho:playcommand('Idle');
					char_imho:queuecommand('Spawn');
				end,true},
				{692,function(self)
					char_imho:playcommand('Attack');
				end,true},
				{692,function(self)
					br_bg:linear(0.5);
					br_bg:diffusealpha(0.7);
				end},
				
				{747.5,function(self)
					br_bg:linear(0.5);
					br_bg:diffusealpha(0);
					char_imho:playcommand('Hide');
				end},
				
				---------------------
				------SONG 3---------
				---------------------
				
				{794,function(self)
					char_imho:x(SCREEN_CENTER_X);
					char_imho:y(SCREEN_CENTER_Y);
					char_imho:playcommand('Idle');
					char_imho:queuecommand('Spawn');
				end,true},
				
				{862,function(self)
					char_imho:playcommand('Cast');
				end},
				
				{868,function(self)
					char_imho:queuecommand('Hide');
				end,true},
				{868,function(self)
					br_bg:linear(0.5);
					br_bg:diffuse(0.3,0.0,0.7,1);
				end},
				{966,function(self)
					br_bg:linear(0.5);
					br_bg:diffusealpha(0);
				end},
				
				{994,function(self)
					char_imho:x(SCREEN_CENTER_X);
					char_imho:y(SCREEN_CENTER_Y);
					char_imho:playcommand('Cast');
					char_imho:queuecommand('Spawn');
				end,true},
				
				{1025.5,function(self)
					char_imho:playcommand('Cast');
				end},
				
				{1030,function(self)
					br_bg:diffusealpha(0.7);
					char_imho:zoom(0.8)
					char_imho:playcommand('Attack');
				end},
				
				{1062,function(self) char_imho:playcommand('Attack'); end},
				{1094,function(self) char_imho:playcommand('Attack'); end},
				{1126,function(self) char_imho:playcommand('Attack'); end},
				
				{1157.5,function(self)
					br_bg:diffusealpha(0);
					char_imho:visible(false)
				end},
				
			}
			
			
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			function message_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(messages) > 1 then
				--table.sort(messages, message_compare)
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, message_compare)
			end
			
---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------

end

local function br_update(self, delta)

	if GAMESTATE:GetSongBeat()>=0 and not checked then
				
				----------------------
				-- grab everything? --
				----------------------
				if SCREENMAN:GetTopScreen():GetChild('LifeP1') then LifeP1 = SCREENMAN:GetTopScreen():GetChild('LifeP1') end
				if SCREENMAN:GetTopScreen():GetChild('LifeP2') then LifeP2 = SCREENMAN:GetTopScreen():GetChild('LifeP2') end
				if SCREENMAN:GetTopScreen():GetChild('ScoreP1') then ScoreP1 = SCREENMAN:GetTopScreen():GetChild('ScoreP1') end
				if SCREENMAN:GetTopScreen():GetChild('ScoreP2') then ScoreP2 = SCREENMAN:GetTopScreen():GetChild('ScoreP2') end
				if SCREENMAN:GetTopScreen():GetChild('BPMDisplay') then BPMDisplay = SCREENMAN:GetTopScreen():GetChild('BPMDisplay') end
				if SCREENMAN:GetTopScreen():GetChild('LifeFrame') then LifeFrame = SCREENMAN:GetTopScreen():GetChild('LifeFrame') end
				if SCREENMAN:GetTopScreen():GetChild('ScoreFrame') then ScoreFrame = SCREENMAN:GetTopScreen():GetChild('ScoreFrame') end
				if SCREENMAN:GetTopScreen():GetChild('Lyrics') then Lyrics = SCREENMAN:GetTopScreen():GetChild('Lyrics') end
				if SCREENMAN:GetTopScreen():GetChild('SongForeground') then SongForeground = SCREENMAN:GetTopScreen():GetChild('SongForeground') end
				if SCREENMAN:GetTopScreen():GetChild('SongBackground') then SongBackground = SCREENMAN:GetTopScreen():GetChild('SongBackground') end
				if SCREENMAN:GetTopScreen():GetChild('Overlay') then Overlay = SCREENMAN:GetTopScreen():GetChild('Overlay') end
				if SCREENMAN:GetTopScreen():GetChild('Underlay') then Underlay = SCREENMAN:GetTopScreen():GetChild('Underlay') end
				
				--------------------------
				-- hide everything? y/n --
				--------------------------
				mod_hideall = true;
				if mod_hideall == true then
					if Overlay then Overlay:visible(false) end
					if Underlay then Underlay:visible(false) end
				end
				
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
				
				P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				if P1 then
				Pjud1 = P1:GetChild('Judgment');
				Pcom1 = P1:GetChild('Combo');
				end
				if P2 then
				Pjud2 = P2:GetChild('Judgment');
				Pcom2 = P2:GetChild('Combo');
				end
				--aliases for old times sake
				
				for pn=1,2 do
					if _G['P'..pn] then
						_G['Pjud'..pn]:bob()
						_G['Pjud'..pn]:effectperiod(1000000)
						_G['Pjud'..pn]:effectoffset(250000)
						_G['Pcom'..pn]:bob()
						_G['Pcom'..pn]:effectperiod(1000000)
						_G['Pcom'..pn]:effectoffset(250000)
					end
				end
				
				screen = SCREENMAN:GetTopScreen();
				checked = true;
			end
			
---------------------------------------------------------------------------------------
----------------------TOUCH THIS-------------------------------------------------------
---------------------------------------------------------------------------------------
			
			local beat = GAMESTATE:GetSongBeat();
			
			for pn=1,2 do
				if _G['P'..pn] then
					_G['Pjud'..pn]:effectmagnitude(_G['jud'..pn]:GetX(),0,0)
					_G['Pcom'..pn]:effectmagnitude(_G['com'..pn]:GetX(),0,0)
				end
			end
			
			-----------------------------------
			----------SONG 1-------------------
			-----------------------------------
			
			if fgchange(112.5,1) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:wag();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(2);
						_G['P'..pn]:effectmagnitude(0,0,20*m);
						_G['P'..pn]:effectoffset(0.5);
					end
				end
			end
			
			if fgchange(118.5,2) then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,0);
					end
				end
			end
			
			if fgchange(120.5,3) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,20*m);
					end
				end
			end
			
			if fgchange(123.5,4) then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,0);
					end
				end
			end
			
			if fgchange(128.5,5) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,20*m);
					end
				end
			end
			
			if fgchange(134.5,6) then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,0);
					end
				end
			end
			
			if fgchange(136.5,7) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,20*m);
					end
				end
			end
			
			if fgchange(139.5,8) then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:stopeffect();
					end
				end
			end
			
			if fgchange(140,9) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:linear(240/180);
						_G['P'..pn]:x(SCREEN_CENTER_X-160*m);
						_G['jud'..pn]:linear(4/3);
						_G['jud'..pn]:x(0);
						_G['com'..pn]:linear(4/3);
						_G['com'..pn]:x(0);
					end
				end
			end
			
			--fgcurcommand stuff goes here
			--fgchange( beat, whichNumberFGChangeIsThis, howFarToJumpAhead, variableToCheckAndIncrement, skipEffectIfBeyondThisBeat )
			if fgchange(200,10) then
				if P1 then
					P1:bounceend(0.1);
					P1:rotationz(10*-1);
					P1:sleep(0.233);
					P1:bounceend(0.1);
					P1:rotationz(0);
					P1:sleep(0.233);
					P1:bounceend(0.1);
					P1:rotationz(10*1);
					P1:sleep(0.233);
					P1:bounceend(0.1);
					P1:rotationz(0);
					P1:sleep(0.233);
				end
				if P2 then
					P2:bounceend(0.1);
					P2:rotationz(10*1);
					P2:sleep(0.233);
					P2:bounceend(0.1);
					P2:rotationz(0);
					P2:sleep(0.233);
					P2:bounceend(0.1);
					P2:rotationz(10*-1);
					P2:sleep(0.233);
					P2:bounceend(0.1);
					P2:rotationz(0);
					P2:sleep(0.233);
				end
			end
			
			if fgchange(312,11) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:bob();
						_G['P'..pn]:effectmagnitude(0,64*m,0);
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(2);
						_G['P'..pn]:effectoffset(0);
					end
				end
			end
			
			if fgchange(336,12) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,0);
					end
				end
			end
			
			if fgchange(344,13) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,-64*m,0);
					end
				end
			end
			
			if fgchange(368,14) then
				local m = 1;
				for pn=1,2 do
					if pn == 2 then m = -1 end
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,0);
					end
				end
			end
			
			-----------------------------------
			----------SONG 2-------------------
			-----------------------------------
			
			if fgchange(522,1,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:bob();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(0.25);
						
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(-20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
					end
				end
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
			end
			
			if beat>522 and beat<534 then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(br_wagger:GetX(),0,0);
					end
				end
			end
			
			if fgchange(554,2,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:bob();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(0.25);
						
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(-20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
					end
				end
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
			end
			
			if beat>554 and beat<566 then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(br_wagger:GetX(),0,0);
					end
				end
			end
			
			if fgchange(568-.1,3,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:accelerate(.1);
						_G['P'..pn]:rotationz(-20);
						_G['P'..pn]:decelerate((60/190)-.1);
						_G['P'..pn]:rotationz(-30);
						_G['P'..pn]:accelerate(.1);
						_G['P'..pn]:rotationz(-10);
						_G['P'..pn]:decelerate((60/190)-.1);
						_G['P'..pn]:rotationz(0);
					end
				end
			end
			
			if fgchange(648,4,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:wag();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(2);
						_G['P'..pn]:effectmagnitude(0,0,20);
						_G['P'..pn]:effectoffset(0);
						
						_G['P'..pn]:linear(12*(60/190));
						_G['P'..pn]:rotationz(30);
						_G['P'..pn]:zoom(1.5);
						_G['P'..pn]:addy(100);
						
						_G['P'..pn]:sleep(0);
						_G['P'..pn]:rotationz(-30);
						_G['P'..pn]:zoom(2);
						_G['P'..pn]:addy(60);
						
						_G['P'..pn]:decelerate(4*(60/190));
						_G['P'..pn]:rotationz(0);
						_G['P'..pn]:zoom(1);
						_G['P'..pn]:addy(-160);
						
					end
				end
				
				br_wagger:sleep(0);
				br_wagger:x(0);
				br_wagger:linear(12*(60/190));
				br_wagger:x(10);
				
				br_wagger:sleep(0);
				br_wagger:x(30);
				br_wagger:decelerate(4*(60/190));
				br_wagger:x(0);
			end
			
			if fgchange(660,5,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectperiod(0.125);
					end
				end
			end
			
			if fgchange(700,6,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:bob();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(0.25);
						
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(-20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
					end
				end
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
			end
			
			if beat>700 and beat<708 then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(br_wagger:GetX(),0,0);
					end
				end
			end
			
			if fgchange(710,7,0.5,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:wag();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectmagnitude(0,0,40);
						_G['P'..pn]:rotationz(30);
						_G['P'..pn]:sleep(60/190);
						_G['P'..pn]:rotationz(-30);
						_G['P'..pn]:sleep(60/190);
						_G['P'..pn]:rotationz(0);
					end
				end
				
				br_wagger2:x(0.25);
				br_wagger2:sleep(60/190);
				br_wagger2:x(0.125);
				br_wagger2:sleep(60/190);
				br_wagger2:x(10000);
			end
			
			if fgchange(712,7.5,0.5,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:wag();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectmagnitude(0,0,0);
					end
				end
			end
			
			if fgchange(732,8,1,'br_fg2') then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:bob();
						_G['P'..pn]:effectclock('bgm');
						_G['P'..pn]:effectperiod(0.25);
						
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(-20);
						_G['P'..pn]:linear(120/190);
						_G['P'..pn]:rotationz(0);
					end
				end
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
				br_wagger:linear(120/190);
				br_wagger:x(32);
				br_wagger:linear(120/190);
				br_wagger:x(0);
			end
			
			if beat>732 and beat<744 then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(br_wagger:GetX(),0,0);
					end
				end
			end
			
			if beat>648 and beat<664 then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectmagnitude(0,0,br_wagger:GetX());
					end
				end
			end
			
			if beat>710 and beat<713 then
				for pn=1,2 do
					if _G['P'..pn] then
						_G['P'..pn]:effectperiod(br_wagger2:GetX());
					end
				end
			end
			
			-----------------------------------
			----------SONG 3-------------------
			-----------------------------------
			
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false;
			if disable ~= true then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i=1,2 do
						br_mod_internal('clearall',i)
						if _G['init_modsp'..i] then 
							--br_mod_internal(_G['init_modsp'..i],i)
						end
					end
				end
				
				---------------
				-- PER FRAME --
				---------------
				
				--Trace(table.getn(mods));
				
				------------------------------
				--------SONG 1----------------
				------------------------------
				
				if perframe(336,337.5) then
					local pos = (beat*(2/3)) - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				if perframe(337.5,339) then
					local pos = (beat*(-2/3)) - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				if perframe(339,340.5) then
					local pos = (beat*(2/3)) - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				if perframe(340.5,342) then
					local pos = (beat*(-2/3)) - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(342,344) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				------------------------------
				--------SONG 2----------------
				------------------------------
				
				if perframe(432,434) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(507,508) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{508,1,'*10000 flip','len'},
				
				if perframe(509,510) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(511,512) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{512,1,'*10000 invert','len'},
				
				if perframe(513,514) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(515,516) then
					local pos = beat + 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{516,1,'*10000 75 flip, *10000 75 invert','len'},
				
				if perframe(517,518) then
					local pos = beat - 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(536,538) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(539,540) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(-50*math.sin(pos*math.pi)-50)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{540,1,'*10000 100 flip, *10000 -100 invert','len'},
				
				if perframe(541,542) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(-50*math.sin(pos*math.pi)-50)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(543,544) then
					local pos = beat + 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(-62.5*math.sin(pos*math.pi)-62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{544,1,'*10000 75 flip, *10000 -125 invert','len'},
				
				if perframe(545,546) then
					local pos = beat - 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(-62.5*math.sin(pos*math.pi)-62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(547,548) then
					local pos = beat + 0.5
					br_mod('*100000 '..(12.5*math.sin(pos*math.pi)+12.5)..' flip');
					br_mod('*100000 '..(62.5*math.sin(pos*math.pi)+62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{548,1,'*10000 25 flip, *10000 125 invert','len'},
				
				if perframe(549,550) then
					local pos = beat - 0.5
					br_mod('*100000 '..(12.5*math.sin(pos*math.pi)+12.5)..' flip');
					br_mod('*100000 '..(62.5*math.sin(pos*math.pi)+62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(633,635) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(637,639) then
					local pos = beat*-1 + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(641,643) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(645,647) then
					local pos = beat*-1 + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(648,660) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(693,694) then
					local pos = beat + 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{694,1,'*10000 75 flip, *10000 75 invert','len'},
				
				if perframe(695,696) then
					local pos = beat - 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(717,718) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(-50*math.sin(pos*math.pi)-50)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{718,1,'*10000 100 flip, *10000 -100 invert','len'},
				
				if perframe(719,720) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(-50*math.sin(pos*math.pi)-50)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(721,722) then
					local pos = beat + 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(-62.5*math.sin(pos*math.pi)-62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{722,1,'*10000 75 flip, *10000 -125 invert','len'},
				
				if perframe(723,724) then
					local pos = beat - 0.5
					br_mod('*100000 '..(37.5*math.sin(pos*math.pi)+37.5)..' flip');
					br_mod('*100000 '..(-62.5*math.sin(pos*math.pi)-62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(725,726) then
					local pos = beat + 0.5
					br_mod('*100000 '..(12.5*math.sin(pos*math.pi)+12.5)..' flip');
					br_mod('*100000 '..(62.5*math.sin(pos*math.pi)+62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				--{726,1,'*10000 25 flip, *10000 125 invert','len'},
				
				if perframe(727,728) then
					local pos = beat - 0.5
					br_mod('*100000 '..(12.5*math.sin(pos*math.pi)+12.5)..' flip');
					br_mod('*100000 '..(62.5*math.sin(pos*math.pi)+62.5)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(746,748) then
					local pos = beat - 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50)..' flip');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				if perframe(620.5,625) then
					if perframe(620.5,621) or perframe(621.5,622) or perframe(622.5,623) or perframe(623.5,624) then
						if screen then
							screen:effectmagnitude(0,200,0);
						end
					else
						if screen then
							screen:effectmagnitude(0,0,0);
						end
					end
				end
				
				------------------------------
				--------SONG 3----------------
				------------------------------
				
				if perframe(856,868) then
					for pn=1,2 do
						if _G['P'..pn] then
							_G['P'..pn]:x(br_flyx:GetX()+SCREEN_CENTER_X)
							_G['P'..pn]:rotationz(br_flyrot:GetX());
						end
					end
				end
				
				if perframe(870,926) then
					if screen then
						screen:vibrate();
						screen:effectmagnitude(br_screenvibx:GetX(),br_screenviby:GetX(),0);
					end
				end
				
				if perframe(998,1026) then
					--local pos = beat+0.5
					local pos = beat+br_snack:GetX();
					br_mod('*100000 '..(50*math.tan((pos*math.pi*0.25)))..' invert');
				end
				
				if perframe(1030,1200) then
					
					if br_scrollspd<3.2 then
						br_scrollspd = br_scrollspd+0.01
					end
					
					for i=1,4 do
						_G['br_pos'..i]:addx(-br_scrollspd*e_aspect);
						
						_G['br_pos'..i]:diffusealpha(0);
						
						--_G['br_pos'..i]:x(-160+(240*i));
						if _G['br_pos'..i]:GetX() < -160*e_aspect then
							_G['br_pos'..i]:addx(960*e_aspect);
						end
						
					end
					
					local m = 1;
					for pn=1,2 do
						if pn == 2 and beat<1157.5 then m = -1 end
						if _G['P'..pn] then
							_G['P'..pn]:effectmagnitude(br_wagger3:GetX()*m,br_wagger3:GetY()*m,br_wagger3:GetZ()*m);
							_G['P'..pn]:rotationz(br_rotator:GetX()*m);
							--_G['P'..pn]:zoom(0.75+(br_skewer:GetX()*m*0.5));
							_G['P'..pn]:skewx(br_skewer:GetX()*1);
						end
					end
					
					if br_endfluct == 1 then
						if P1 then P1:x(br_pos1:GetX()); end
						if P2 then P2:x(br_pos2:GetX()); end
						br_endfluct = 2
					else
						if P1 then P1:x(br_pos3:GetX()); end
						if P2 then P2:x(br_pos4:GetX()); end
						br_endfluct = 1
					end
					
				end
				
				local br_should = true;
				
				if perframe(1061,1064) or perframe(1093,1096) or perframe(1125,1128) then
					br_should = false
				end
				
				if beat > br_spt+0.25 then
					br_spt = beat+0.25;
				end
				if beat > br_spt and beat < br_spt+0.25 and beat < 1156 and br_should then
					br_putsparkle(50+math.random(SCREEN_WIDTH-100),50+math.random(SCREEN_HEIGHT-100));
					br_putsparkle(50+math.random(SCREEN_WIDTH-100),50+math.random(SCREEN_HEIGHT-100));
					br_spt = br_spt+0.25;
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if beat >=v[1] then
								if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
									if table.getn(v) == 5 and v[5] then
										br_mod_internal(''..v[3],v[5]);
									else
										br_mod(''..v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = '';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')');
						end
					end
				end
				
				-----------------------------------------------------------------------------------------------------
				-- WinDEU's time-based len/end version of the #swag custom mod reader #teamproofofconcept (c) 2015 --
				-----------------------------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods2) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if mod_time >=v[1] then
								if (v[4] == 'len' and mod_time <=v[1]+v[2]) or (v[4] == 'end' and mod_time <=v[2]) then
									if table.getn(v) == 5 and v[5] then
										br_mod_internal(''..v[3],v[5]);
									else
										br_mod(''..v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = 'error';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in time-based table (line '..i..')');
						end
					end
				end
				
				----------
				-- more --
				----------
				
				if perframe(899,901) then
					local pos = beat + 0.5
					br_mod('*100000 '..(50*math.sin(pos*math.pi)+50+550)..' invert');
					br_mod('*100000 '..(br_spinny[1]*math.cos((pos*math.pi)+math.pi))..' reverse');
					br_mod('*100000 '..(br_spinny[2]*math.cos(pos*math.pi))..' split');
					br_mod('*100000 '..(br_spinny[3]*math.cos(pos*math.pi))..' alternate');
				end
				
				-----------------------
				-- SCREAMING GUMBALL --
				-----------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curmessage<=table.getn(messages) and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
						if not messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+1 then
							curmessage = curmessage+1;
						else
							MESSAGEMAN:Broadcast(messages[curmessage][2]);
							Trace(messages[curmessage][1]..': Broadcast '..messages[curmessage][2]);
							curmessage = curmessage+1;
						end
					end
				end
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
						if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
							if type(mod_actions[curaction][2]) == 'function' then
								mod_actions[curaction][2]()
							elseif type(mod_actions[curaction][2]) == 'string' then
								MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
							end
						end
						curaction = curaction+1;
					end
				end
				
			end

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
	
end

br_sptr = 1
br_sparkles = {}
Sparkles = Def.ActorFrame{}

for i=0,100 do
	Sparkles[#Sparkles+1] = LoadActor("sparkle.png")..{
		OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self) table.insert(br_sparkles,self) end,
		HideCommand=cmd(visible,false),
	}
end

return Def.ActorFrame{
	OnCommand= function(self)
							 br_init()
							 --self:SetUpdateFunction(br_update)
							 --self:SetUpdateRate(1)
							 
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
	
	Def.Quad{
		OnCommand=cmd(visible,false;queuecommand,"Update");
		UpdateCommand=function(self)
			br_update();
			self:sleep(0.02);
			self:queuecommand("Update");
		end
	},
	
	Sparkles,
	
	Def.Quad{
		InitCommand=function(self) self:visible(false); br_control = self end,
		br_spinnyLMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(1/3);
					_G['P'..pn]:rotationy(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationy(0);
				end
			end
		end,
		br_spinnyRMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(1/3);
					_G['P'..pn]:rotationy(-360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationy(0);
				end
			end
		end,
		br_spinnyZRMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		CenterBothMessageCommand=function(self)
			local mult = 1;
			for pn=1,2 do
				if pn == 2 then mult = -1 end;
				if _G['P'..pn] then
					_G['P'..pn]:accelerate(1/12);
					_G['P'..pn]:addx(SCREEN_CENTER_X*0.1*mult);
					_G['P'..pn]:rotationz(30*mult);
					_G['P'..pn]:decelerate(4/12);
					_G['P'..pn]:x(SCREEN_CENTER_X);
					_G['P'..pn]:rotationz(0);
					
					_G['jud'..pn]:decelerate(5/12);
					_G['jud'..pn]:addx(-180*mult);
					_G['com'..pn]:decelerate(5/12);
					_G['com'..pn]:addx(-180*mult);
				end
			end
		end,
		CenterBothQMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:finishtweening();
					_G['P'..pn]:x(SCREEN_CENTER_X);
				end
			end
		end,
		CenterBothQNFMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:x(SCREEN_CENTER_X);
				end
			end
		end,
		Rotate1LMessageCommand=function(self)
			if P1 then P1:decelerate(0.3); P1:rotationz(br_tiltamt); P1:rotationx(br_xtiltamt*br_xtiltalt); end
			br_updatetiltamt();
		end,
		Rotate2LMessageCommand=function(self)
			if P2 then P2:decelerate(0.3); P2:rotationz(br_tiltamt); P2:rotationx(br_xtiltamt*br_xtiltalt); end
			br_updatetiltamt();
		end,
		Rotate1RMessageCommand=function(self)
			if P1 then P1:decelerate(0.3); P1:rotationz(br_tiltamt*-1); P1:rotationx(br_xtiltamt*br_xtiltalt); end
			br_updatetiltamt();
		end,
		Rotate2RMessageCommand=function(self)
			if P2 then P2:decelerate(0.3); P2:rotationz(br_tiltamt*-1); P2:rotationx(br_xtiltamt*br_xtiltalt); end
			br_updatetiltamt();
		end,
		ChangeTiltModeMessageCommand=function(self)
			br_tiltamt = 3;
			br_tiltmax = 10;
			br_xtiltamt = 10;
			br_xtiltmax = 50;
			br_xtiltalt = 1;
			br_tiltsmooth = 15;
		end,
		UnCenterBothQNFMessageCommand=function(self)
			local m = 1;
			for pn=1,2 do
				if pn == 2 then m = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:rotationx(0);
					_G['P'..pn]:x(SCREEN_CENTER_X-(160*m));
				end
			end
		end,
		CenterBoth3BeatsMessageCommand=function(self)
			if P1 then
				P1:linear(180/190)
				P1:x(SCREEN_CENTER_X);
				jud1:linear(180/190)
				jud1:x(-192)
				com1:linear(180/190)
				com1:x(-192)
			end
			if P2 then
				P2:linear(180/190)
				P2:x(SCREEN_CENTER_X);
				jud2:linear(180/190)
				jud2:x(192)
				com2:linear(180/190)
				com2:x(192)
			end
		end,
		FlightMessageCommand=function(self)
			if br_flyx then
				br_flyx:accelerate(120/190);
				br_flyx:addx(80);
				br_flyx:decelerate(120/190);
				br_flyx:addx(80);
				br_flyx:accelerate(120/190);
				br_flyx:addx(-160);
				br_flyx:decelerate(120/190);
				br_flyx:addx(-160);
				br_flyx:accelerate(120/190);
				br_flyx:addx(80);
				br_flyx:decelerate(120/190);
				br_flyx:addx(80);
			end
			if br_flyrot then
				br_flyrot:accelerate(120/190 - 0.1);
				br_flyrot:addx(10);
				br_flyrot:decelerate(120/190 - 0.1);
				br_flyrot:addx(10);
				br_flyrot:linear(0.2);
				br_flyrot:addx(-20);
				
				br_flyrot:accelerate(120/190 - 0.1);
				br_flyrot:addx(-15);
				br_flyrot:decelerate(120/190 - 0.1);
				br_flyrot:addx(-15);
				br_flyrot:linear(0.2);
				br_flyrot:addx(30);
				
				br_flyrot:accelerate(60/190);
				br_flyrot:addx(10);
				br_flyrot:decelerate(60/190);
				br_flyrot:addx(10);
				br_flyrot:accelerate(60/190);
				br_flyrot:addx(-10);
				br_flyrot:decelerate(60/190);
				br_flyrot:addx(-10);
			end
		end,
		CenterJoinMessageCommand=function(self)
			if P1 then
				P1:rotationz(0);
				P1:decelerate(120/190)
				P1:x(SCREEN_CENTER_X-160-256);
				jud1:decelerate(120/190)
				jud1:x(192)
				com1:decelerate(120/190)
				com1:x(192)
			end
			if P2 then
				P2:rotationz(0);
				P2:decelerate(120/190)
				P2:x(SCREEN_CENTER_X+160+256);
				jud2:decelerate(120/190)
				jud2:x(-192)
				com2:decelerate(120/190)
				com2:x(-192)
			end
		end,
		
		SquashMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.08);
					_G['P'..pn]:zoomx(2);
					_G['P'..pn]:zoomy(0.1);
					_G['P'..pn]:addy(128);
					_G['P'..pn]:spring(0.16);
					_G['P'..pn]:zoom(1);
					_G['P'..pn]:addy(-128);
				end
			end
		end,
		
		ZoomVibL16MessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:accelerate(1*(60/190));
					_G['P'..pn]:zoom(1.15);
					_G['P'..pn]:rotationz(-10);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:zoom(1.3);
					_G['P'..pn]:rotationz(-20);
					_G['P'..pn]:accelerate(1*(60/190));
					_G['P'..pn]:zoom(1.15);
					_G['P'..pn]:rotationz(-10);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:zoom(1);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		ZoomVibR16MessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:accelerate(1*(60/190));
					_G['P'..pn]:zoom(1.15);
					_G['P'..pn]:rotationz(10);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:zoom(1.3);
					_G['P'..pn]:rotationz(20);
					_G['P'..pn]:accelerate(1*(60/190));
					_G['P'..pn]:zoom(1.15);
					_G['P'..pn]:rotationz(10);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:zoom(1);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		BWEAOW1MessageCommand=function(self)
			
			br_screenvibx:sleep(270/190);
			br_screenvibx:linear(60/190);
			br_screenvibx:x(150);
			br_screenvibx:linear(60/190);
			br_screenvibx:x(0);
			
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.5*(60/190));
					_G['P'..pn]:rotationy(270);
					_G['P'..pn]:rotationx(270);
					_G['P'..pn]:decelerate(1.5*(60/190));
					_G['P'..pn]:rotationy(360);
					_G['P'..pn]:rotationx(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationy(0);
					_G['P'..pn]:rotationx(0);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:rotationz(12);
					for i=1,9 do
						_G['P'..pn]:sleep(0.25*(60/190));
						_G['P'..pn]:rotationz(12-(12*(i/9)));
					end
				end
			end
		end,
		BWEAOW2MessageCommand=function(self)
			
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.5*(60/190));
					_G['P'..pn]:rotationy(-270);
					_G['P'..pn]:rotationx(270);
					_G['P'..pn]:decelerate(1.5*(60/190));
					_G['P'..pn]:rotationy(-360);
					_G['P'..pn]:rotationx(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationy(0);
					_G['P'..pn]:rotationx(0);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:rotationz(15);
					_G['P'..pn]:linear(0.5*(60/190));
					_G['P'..pn]:rotationz(-15);
					_G['P'..pn]:decelerate(0.5*(60/190));
					_G['P'..pn]:rotationz(0);
					local fluct = 1;
					for i=1,6 do
						_G['P'..pn]:linear(0.333*(60/190));
						_G['P'..pn]:rotationy(45*fluct);
						fluct = fluct*-1;
					end
					_G['P'..pn]:decelerate(2*(60/190));
					_G['P'..pn]:rotationy(0);
				end
			end
		end,
		BWEAOW3MessageCommand=function(self)
		
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.5*(60/190));
					_G['P'..pn]:rotationy(-270);
					_G['P'..pn]:rotationx(270);
					_G['P'..pn]:decelerate(1.5*(60/190));
					_G['P'..pn]:rotationy(-360);
					_G['P'..pn]:rotationx(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationy(0);
					_G['P'..pn]:rotationx(0);
					_G['P'..pn]:decelerate(1*(60/190));
					_G['P'..pn]:rotationz(12);
					_G['P'..pn]:linear(1*(60/190));
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		BWEAOW4MessageCommand=function(self)
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(1*(60/190));
					_G['P'..pn]:rotationy(-270);
					_G['P'..pn]:rotationx(270);
					_G['P'..pn]:decelerate(3*(60/190));
					_G['P'..pn]:rotationy(-360);
					_G['P'..pn]:rotationx(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationy(0);
					_G['P'..pn]:rotationx(0);
				end
			end
		end,
		DerDouDaMessageCommand=function(self)
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.75*(60/190));
					_G['P'..pn]:rotationz(20);
					_G['P'..pn]:linear(0.75*(60/190));
					_G['P'..pn]:rotationz(-20);
					_G['P'..pn]:linear(0.5*(60/190));
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		DerDouDa2MessageCommand=function(self)
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.75*(60/190));
					_G['P'..pn]:rotationz(20);
					_G['P'..pn]:linear(0.75*(60/190));
					_G['P'..pn]:rotationz(-20);
					_G['P'..pn]:decelerate(4*(60/190));
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		SphinxMessageCommand=function(self)
			local mult = 1
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(90);
					_G['P'..pn]:sleep(60/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(180);
					_G['P'..pn]:sleep(90/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(270);
					_G['P'..pn]:sleep(30/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationz(0);
					
					_G['jud'..pn]:x(0);
					_G['com'..pn]:x(0);
				end
			end
		end,
		Sphinx2MessageCommand=function(self)
			local pn = 1
			if _G['P'..pn] then
				_G['P'..pn]:linear(0.1);
				_G['P'..pn]:x(SCREEN_CENTER_X);
				_G['jud'..pn]:linear(0.1);
				_G['jud'..pn]:x(-180);
				_G['com'..pn]:linear(0.1);
				_G['com'..pn]:x(-180);
			end
			local pn = 2
			if _G['P'..pn] then
				_G['P'..pn]:sleep(30/190);
				_G['P'..pn]:linear(0.1);
				_G['P'..pn]:x(SCREEN_CENTER_X);
				_G['jud'..pn]:sleep(30/190);
				_G['jud'..pn]:linear(0.1);
				_G['jud'..pn]:x(180);
				_G['com'..pn]:sleep(30/190);
				_G['com'..pn]:linear(0.1);
				_G['com'..pn]:x(180);
			end
		end,
		Sphinx3MessageCommand=function(self)
			local mult = 1
			local d = 160
			if P1 then d = (SCREEN_CENTER_X-160)-P1:GetX() end
			if P2 then d = P2:GetX()-(SCREEN_CENTER_X-160) end
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(90);
					_G['P'..pn]:addx(d*-0.25*mult);
					_G['P'..pn]:sleep(60/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(180);
					_G['P'..pn]:addx(d*-0.25*mult);
					_G['P'..pn]:sleep(90/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(270);
					_G['P'..pn]:addx(d*-0.25*mult);
					_G['P'..pn]:sleep(30/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(360);
					_G['P'..pn]:addx(d*-0.25*mult);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationz(0);
					
					_G['jud'..pn]:linear(0.1)
					_G['jud'..pn]:x(0);
					_G['com'..pn]:linear(0.1)
					_G['com'..pn]:x(0);
					
				end
			end
		end,
		GetSmallerMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(30);
					_G['P'..pn]:zoom(0.85);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(-30);
					_G['P'..pn]:zoom(0.7);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(30);
					_G['P'..pn]:zoom(0.55);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(-30);
					_G['P'..pn]:zoom(0.4);
					_G['P'..pn]:decelerate(240/190);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:zoom(1);
				end
			end
		end,	
		
		SkewItMessageCommand=function(self)
			if P1 then
				P1:linear(120/190)
				P1:skewx(-1);
			end
			if P2 then
				P2:sleep(180/190)
				P2:linear(120/190)
				P2:skewx(-1);
			end
		end,
		SkewIt2MessageCommand=function(self)
			if P1 then
				P1:linear(120/190)
				P1:skewx(1);
			end
			if P2 then
				P2:sleep(180/190)
				P2:linear(120/190)
				P2:skewx(1);
			end
		end,
		
		UnSkewItMessageCommand=function(self)
			if P1 then
				P1:linear(120/190)
				P1:skewx(0);
			end
			if P2 then
				P2:sleep(180/190)
				P2:linear(120/190)
				P2:skewx(0);
			end
		end,
		
		SquishyXMessageCommand=function(self)
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:zoomx(0.95);
					_G['P'..pn]:sleep(60/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:zoomx(0.9);
					_G['P'..pn]:sleep(60/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:zoomx(0.85);
					_G['P'..pn]:sleep(60/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:zoomx(0.8);
					_G['P'..pn]:sleep(60/180 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:zoomx(0.75);
				end
			end
		end,
		
		TiltsMessageCommand=function(self)
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(35);
					_G['P'..pn]:sleep(45/190 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-35);
					_G['P'..pn]:sleep(45/190 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(35);
					_G['P'..pn]:sleep(45/190 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-35);
					_G['P'..pn]:sleep(45/190 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(35);
					_G['P'..pn]:sleep(60/190 - 0.1);
					
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-35);
					_G['P'..pn]:sleep(45/190 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(35);
					_G['P'..pn]:sleep(45/190 - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-35);
					_G['P'..pn]:sleep(45/190 - 0.1);
				end
			end
		end,
		
		OaoMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(90/180);
					_G['P'..pn]:skewx(0.7);
					_G['P'..pn]:linear(90/180);
					_G['P'..pn]:skewx(-0.7);
					_G['P'..pn]:linear(60/180);
					_G['P'..pn]:skewx(0);
				end
			end
		end,
		
		Diddlydid1MessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-10);
					_G['P'..pn]:sleep((30/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(20);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-30);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-50);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(10);
				end
			end
		end,
		
		Diddlydid3MessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:rotationx(-10);
					_G['P'..pn]:sleep((40/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationx(20);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationx(-30);
					_G['P'..pn]:sleep((30/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationx(40);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationx(-50);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-10);
				end
			end
		end,
		
		Diddlydid2MessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(10);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-20);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(30);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-40);
					_G['P'..pn]:sleep((45/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(50);
					_G['P'..pn]:sleep((30/180) - 0.1);
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(-10);
				end
			end
		end,
		
		StraightenZMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		
		StraightenXMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:linear(0.1);
					_G['P'..pn]:rotationx(0);
				end
			end
		end,
		
		UnSquishyXMessageCommand=function(self)
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:linear(120/190);
					_G['P'..pn]:zoomx(1);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		
		BeginTanFuckMessageCommand=function(self)
			local mult = 1;
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:accelerate(90/190);
					_G['P'..pn]:rotationx(0);
					_G['P'..pn]:rotationy(0);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:x(SCREEN_CENTER_X);
					_G['P'..pn]:decelerate(30/190);
					_G['P'..pn]:addx(160*mult);
					_G['P'..pn]:accelerate(30/190);
					_G['P'..pn]:addx(-160*mult);
					_G['P'..pn]:decelerate(30/190);
					_G['P'..pn]:addx(-160*mult);
					_G['P'..pn]:accelerate(30/190);
					_G['P'..pn]:addx(160*mult);
					_G['P'..pn]:decelerate(30/190);
					_G['P'..pn]:addx(160*mult);
					_G['P'..pn]:accelerate(30/190);
					_G['P'..pn]:addx(-160*mult);
				end
			end
		end,
		
		BeginSpinnyMessageCommand=function(self)
			local mult = 1;
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:accelerate(90/190);
					_G['P'..pn]:x(SCREEN_CENTER_X);
					_G['P'..pn]:decelerate(30/190);
					_G['P'..pn]:addx(160*mult);
					_G['P'..pn]:accelerate(30/190);
					_G['P'..pn]:addx(-160*mult);
					_G['P'..pn]:decelerate(30/190);
					_G['P'..pn]:addx(-160*mult);
					_G['P'..pn]:accelerate(30/190);
					_G['P'..pn]:addx(160*mult);
					_G['P'..pn]:decelerate(30/190);
					_G['P'..pn]:addx(160*mult);
					if pn == 2 then
						_G['P'..pn]:rotationz(90);
					end
					_G['P'..pn]:accelerate(30/190);
					_G['P'..pn]:addx(-160*mult);
					if pn == 2 then
						_G['P'..pn]:rotationz(180);
					end
				end
			end
		end,
		
		MainSpinnyMessageCommand=function(self)
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:spin();
					_G['P'..pn]:effectmagnitude(0,0,45);
					_G['P'..pn]:effectclock('bgm');
				end
			end
		end,
		
		StopSpinnyMessageCommand=function(self)
			for pn=1,2 do
				if pn == 2 then mult = -1 end
				if _G['P'..pn] then
					_G['P'..pn]:stopeffect();
					
					_G['P'..pn]:linear(240/190);
					_G['P'..pn]:rotationz(360);
					_G['P'..pn]:sleep(0);
					_G['P'..pn]:rotationz(0);
						
					--[[
					if pn == 2 then
						_G['P'..pn]:linear(240/190);
						_G['P'..pn]:rotationz(360);
						_G['P'..pn]:sleep(0);
						_G['P'..pn]:rotationz(0);
					end
					]]
				end
			end
		end,
		
		CenterScreenMessageCommand=function(self)
			screen:addx(SCREEN_CENTER_X);
			screen:addy(SCREEN_CENTER_Y);
			screen:sleep(0);
			if P1 then P1:addx(-SCREEN_CENTER_X) end
			if P1 then P1:addy(-SCREEN_CENTER_Y) end
			if P2 then P2:addx(-SCREEN_CENTER_X) end
			if P2 then P2:addy(-SCREEN_CENTER_Y) end
			SongBackground:addx(-SCREEN_CENTER_X);
			SongBackground:addy(-SCREEN_CENTER_Y);
			SongForeground:addx(-SCREEN_CENTER_X);
			SongForeground:addy(-SCREEN_CENTER_Y);
		end,
		RevertScreenMessageCommand=function(self)
			screen:addx(-SCREEN_CENTER_X);
			screen:addy(-SCREEN_CENTER_Y);
			if P1 then P1:addx(SCREEN_CENTER_X) end
			if P1 then P1:addy(SCREEN_CENTER_Y) end
			if P2 then P2:addx(SCREEN_CENTER_X) end
			if P2 then P2:addy(SCREEN_CENTER_Y) end
			SongBackground:addx(SCREEN_CENTER_X);
			SongBackground:addy(SCREEN_CENTER_Y);
			SongForeground:addx(SCREEN_CENTER_X);
			SongForeground:addy(SCREEN_CENTER_Y);
		end,
		
		RotateScreenMessageCommand=function(self)
			screen:sleep(0);
			screen:accelerate(90/190);
			screen:rotationz(-20);
			screen:decelerate(90/190);
			screen:rotationz(-40);
			screen:decelerate(30/190);
			screen:rotationz(0);
		end,
		
		MoveScreen1MessageCommand=function(self)
			screen:linear(0.1);
			screen:addx(-320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(320);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addx(320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(-320);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addx(-320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(320);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addx(320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(-320);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addx(-320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(320);
			screen:sleep(30/190 - 0.1);
			screen:linear(15/190);
			screen:addy(240);
			screen:linear(15/190);
			screen:addy(-480);
			screen:linear(15/190);
			screen:addy(240);
			
		end,
		
		MoveScreen2MessageCommand=function(self)
			screen:linear(0.1);
			screen:addx(-320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(320);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addx(320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addx(-320);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addx(-320);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);	
			screen:addx(320);
			screen:sleep(30/190 - 0.1);
			
			--zoom
			screen:linear(0.1);
			screen:zoom(2);
			screen:x(SCREEN_WIDTH);
			screen:sleep(60/190 - 0.1);
			screen:linear(0.1);
			screen:x(0);
			screen:sleep(60/190 - 0.1);
			screen:linear(0.1);
			screen:x(SCREEN_WIDTH);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:x(0);
			screen:sleep(30/190 - 0.1);
			screen:linear(60/190);
			screen:zoom(1);
			screen:x(SCREEN_CENTER_X);
			
		end,
		
		MoveScreen3MessageCommand=function(self)
			screen:vibrate();
			screen:effectmagnitude(0,0,0);
			
			screen:linear(0.1);
			screen:addy(-SCREEN_HEIGHT);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addy(SCREEN_HEIGHT);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addy(SCREEN_HEIGHT);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addy(-SCREEN_HEIGHT);
			
			screen:sleep(60/190 - 0.1);
			
			screen:linear(0.1);
			screen:addy(-SCREEN_HEIGHT);
			screen:sleep(30/190 - 0.1);
			screen:linear(0.1);
			screen:addy(SCREEN_HEIGHT);
			
			screen:sleep(60/190 - 0.1);
			
		end,
		
		CenterPlayersTempMessageCommand=function(self)
			--[[
			local d = {0,0}
			for pn=1,2 do
				if _G['P'..pn] then
					d[pn] = _G['P'..pn]:GetX();
					_G['P'..pn]:linear(90/190)
					_G['P'..pn]:x((SCREEN_CENTER_X-d[pn])*0.75)
					_G['P'..pn]:decelerate(90/190)
					_G['P'..pn]:x((SCREEN_CENTER_X-d[pn])*0.25)
					_G['P'..pn]:bounceend(60/190)
					_G['P'..pn]:x(d[pn]);
				end
			end
			]]
		end,
		
		KakaMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:rotationz(-40);
					_G['P'..pn]:spring(0.2);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:sleep((60/190)-0.2);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:spring(0.2);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:sleep((60/190)-0.2);
					_G['P'..pn]:rotationz(-40);
					_G['P'..pn]:spring(0.2);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:sleep((60/190)-0.2);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:spring(0.2);
					_G['P'..pn]:rotationz(0);
					_G['P'..pn]:sleep((60/190)-0.2);
				end
			end
		end,
		
		BootyShakeMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(-40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(-40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		
		BootyShake2MessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(-40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(40);
					_G['P'..pn]:decelerate(60/190);
					_G['P'..pn]:rotationz(0);
				end
			end
		end,
		
		SetupEndingMessageCommand=function(self)
			if br_wagger3 then
				br_wagger3:y(10);
				br_wagger3:linear(24*(60/190));
				br_wagger3:y(16*1.66*0.75);
			end
			for i=1,4 do
				_G['br_pos'..i]:visible(true);
				_G['br_pos'..i]:zoom(0.7);
				_G['br_pos'..i]:diffusealpha(0);
				_G['br_pos'..i]:x((-160+(240*i))*e_aspect);
				_G['br_pos'..i]:y(250);
			end
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:zoom(0.75);
					_G['P'..pn]:bob();
					_G['P'..pn]:effectmagnitude(0,0,0);
					_G['P'..pn]:effectperiod(4);
					_G['P'..pn]:effectclock('bgm');
				end
			end
		end,
		
		BeginSection2MessageCommand=function(self)
			if br_wagger3 then
				br_wagger3:decelerate(2*(60/190));
				br_wagger3:x(15);
				br_wagger3:y(15);
				br_wagger3:sleep(60/190);
				br_wagger3:linear(24*(60/190));
				br_wagger3:y(45);
			end
			
			local m = 1;
			if br_rotator then
				br_rotator:linear(30/190);
				br_rotator:x(270*m);
				br_rotator:decelerate(90/190);
				br_rotator:x(360*m);
				br_rotator:sleep(0);
				br_rotator:x(0);
			end
			
		end,
		
		Section2WagMessageCommand=function(self)
			for pn=1,2 do
				if _G['P'..pn] then
					_G['P'..pn]:wag();
					_G['P'..pn]:effectperiod(4);
					_G['P'..pn]:effectclock('bgm');
				end
			end
		end,
		
		BeginSection3MessageCommand=function(self)
			if br_wagger3 then
				br_wagger3:decelerate(2*(60/190));
				br_wagger3:x(5);
				br_wagger3:y(10);
				br_wagger3:z(10);
				br_wagger3:sleep(60/190);
				br_wagger3:linear(24*(60/190));
				br_wagger3:z(30);
			end
			
			local m = 1;
			if br_rotator then
				br_rotator:linear(30/190);
				br_rotator:x(270*m);
				br_rotator:decelerate(90/190);
				br_rotator:x(360*m);
				br_rotator:sleep(0);
				br_rotator:x(0);
			end
			
		end,
		
		BeginSection4MessageCommand=function(self)
			if br_wagger3 then
				br_wagger3:decelerate(2*(60/190));
				br_wagger3:z(5);
				br_wagger3:y(5);
				br_wagger3:x(15);
				br_wagger3:sleep(60/190);
				br_wagger3:linear(24*(60/190));
				br_wagger3:x(60);
			end
			
			local m = 1;
			if br_rotator then
				br_rotator:linear(30/190);
				br_rotator:x(270*m);
				br_rotator:decelerate(90/190);
				br_rotator:x(360*m);
				br_rotator:sleep(0);
				br_rotator:x(0);
			end
			
		end,
		
		WawawawaMessageCommand=function(self)
			if br_skewer then
				br_skewer:linear(30/190);
				br_skewer:x(0.2);
				br_skewer:linear(30/190);
				br_skewer:x(-0.2);
				br_skewer:linear(30/190);
				br_skewer:x(0.2);
				br_skewer:linear(30/190);
				br_skewer:x(0);
			end
		end,
		
		FinalEndingMessageCommand=function(self)
			if br_wagger3 then
				br_wagger3:finishtweening();
				br_wagger3:x(36);
				br_wagger3:y(0);
				br_wagger3:z(0);
			end
			
			for pn=1,2 do
				if _G['P'..pn] then
					if pn==2 then
						_G['P'..pn]:rotationx(180);
					end
					_G['P'..pn]:spin();
					_G['P'..pn]:effectclock('bgm');
				end
			end
			
		end,
		
	},
	
	Def.Quad{ OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;diffuse,1,1,1,0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;),
	WhiteFlashMessageCommand=cmd(diffuse,1,1,1,1;linear,0.4;diffusealpha,0;),
	WhiteFlashQMessageCommand=cmd(diffuse,1,1,1,0.8;linear,0.3;diffusealpha,0;),
	RedFlashMessageCommand=cmd(diffuse,1,0,0,1;linear,0.4;diffusealpha,0;),
	RedFlashQMessageCommand=cmd(diffuse,1,0,0,0.8;linear,0.3;diffusealpha,0;),
	},
	
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); br_pos1 = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); br_pos2 = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); br_pos3 = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); self:basezoomx(256); self:basezoomy(384); br_pos4 = self; end,	},
	
	Def.Quad{ InitCommand=function(self) self:visible(false); br_wagger = self; end,	},
	Def.Quad{ InitCommand=function(self) self:visible(false); br_wagger2 = self; end, },
	
	Def.Quad{ InitCommand=function(self) self:visible(false); br_wagger3 = self; end, },
	
	Def.Quad{ InitCommand=function(self) self:visible(false); br_rotator = self; end, },
	Def.Quad{ InitCommand=function(self) self:visible(false); br_skewer = self; end, },
	
	Def.Quad{ InitCommand=function(self) self:visible(false); br_flyx = self; end, },
	Def.Quad{ InitCommand=function(self) self:visible(false); br_flyrot = self; end, },
	
	Def.Quad{ InitCommand=function(self) self:visible(false); br_screenvibx = self; end, },
	Def.Quad{ InitCommand=function(self) self:visible(false); br_screenviby = self; end, },
	
	Def.Quad{ InitCommand=function(self) self:visible(false); jud1 = self; end, },
	Def.Quad{ InitCommand=function(self) self:visible(false); jud2 = self; end, },
	Def.Quad{ InitCommand=function(self) self:visible(false); com1 = self; end, },
	Def.Quad{ InitCommand=function(self) self:visible(false); com2 = self; end, },
	
	Def.Quad{ InitCommand=function(self) self:visible(false); self:x(2) br_snack = self; end,
	SnackMessageCommand=cmd(linear,240/190;x,0.5;), },
	
	Def.Sprite{
	Texture="_sheet fire 5x1.png",
	Frame0000=0,
	Delay0000=0.05,
	Frame0001=1,
	Delay0001=0.05,
	Frame0002=2,
	Delay0002=0.05,
	Frame0003=3,
	Delay0003=0.05,
	Frame0004=2,
	Delay0004=0.05,
	Frame0005=1,
	Delay0005=0.05,
	OnCommand=cmd(vertalign,top;diffusealpha,0;y,SCREEN_BOTTOM;x,SCREEN_CENTER_X),
	TagFireMessageCommand=cmd(blend,1;diffusealpha,0.6;vertalign,bottom;x,SCREEN_CENTER_X;y,SCREEN_BOTTOM+80;zoomtowidth,SCREEN_WIDTH;
	croptop,0.1;fadetop,0.75;zoomy,1;linear,3;addy,-80;zoomy,2;linear,9.3;zoomy,3;accelerate,1;addy,400;decelerate,0.5;zoomy,0),
	},
	
	Def.Sprite{
	Texture="_bolt 4x2.png",
	Frame0000=0,
	Delay0000=0.05,
	Frame0001=1,
	Delay0001=0.05,
	Frame0002=2,
	Delay0002=0.05,
	Frame0003=3,
	Delay0003=0.05,
	Frame0004=4,
	Delay0004=0.05,
	Frame0005=5,
	Delay0005=0.05,
	OnCommand=cmd(visible,false;zoom,1.5;x,SCREEN_CENTER_X;blend,1;rotationz,90;y,SCREEN_HEIGHT/2;bob;diffusealpha,0;
	effectmagnitude,0,250,0;effectclock,'bgm';effectperiod,8;effectoffset,0), TagThunderMessageCommand=cmd(visible,true;linear,0.4;diffusealpha,0.7;),
	TagThunderOffMessageCommand=cmd(linear,0.5;diffusealpha,0;queuecommand,"Hide"), HideCommand=cmd(visible,false), },
	Def.Sprite{
	Texture="_bolt 4x2.png",
	Frame0000=0,
	Delay0000=0.05,
	Frame0001=1,
	Delay0001=0.05,
	Frame0002=2,
	Delay0002=0.05,
	Frame0003=3,
	Delay0003=0.05,
	Frame0004=4,
	Delay0004=0.05,
	Frame0005=5,
	Delay0005=0.05,
	OnCommand=cmd(visible,false;zoom,1.5;x,SCREEN_CENTER_X;blend,1;rotationz,90;y,SCREEN_HEIGHT/2;bob;diffusealpha,0;
	effectmagnitude,0,250,0;effectclock,'bgm';effectperiod,8;effectoffset,2), TagThunderMessageCommand=cmd(visible,true;linear,0.4;diffusealpha,0.7;),
	TagThunderOffMessageCommand=cmd(linear,0.5;diffusealpha,0;queuecommand,"Hide"), HideCommand=cmd(visible,false), },
	Def.Sprite{
	Texture="_bolt 4x2.png",
	Frame0000=0,
	Delay0000=0.05,
	Frame0001=1,
	Delay0001=0.05,
	Frame0002=2,
	Delay0002=0.05,
	Frame0003=3,
	Delay0003=0.05,
	Frame0004=4,
	Delay0004=0.05,
	Frame0005=5,
	Delay0005=0.05,
	OnCommand=cmd(visible,false;zoom,1.5;x,SCREEN_CENTER_X;blend,1;rotationz,90;y,SCREEN_HEIGHT/2;bob;diffusealpha,0;
	effectmagnitude,0,250,0;effectclock,'bgm';effectperiod,8;effectoffset,4), TagThunderMessageCommand=cmd(visible,true;linear,0.4;diffusealpha,0.7;),
	TagThunderOffMessageCommand=cmd(linear,0.5;diffusealpha,0;queuecommand,"Hide"), HideCommand=cmd(visible,false), },
	Def.Sprite{
	Texture="_bolt 4x2.png",
	Frame0000=0,
	Delay0000=0.05,
	Frame0001=1,
	Delay0001=0.05,
	Frame0002=2,
	Delay0002=0.05,
	Frame0003=3,
	Delay0003=0.05,
	Frame0004=4,
	Delay0004=0.05,
	Frame0005=5,
	Delay0005=0.05,
	OnCommand=cmd(visible,false;zoom,1.5;x,SCREEN_CENTER_X;blend,1;rotationz,90;y,SCREEN_HEIGHT/2;bob;diffusealpha,0;
	effectmagnitude,0,250,0;effectclock,'bgm';effectperiod,8;effectoffset,6), TagThunderMessageCommand=cmd(visible,true;linear,0.4;diffusealpha,0.7;),
	TagThunderOffMessageCommand=cmd(linear,0.5;diffusealpha,0;queuecommand,"Hide"), HideCommand=cmd(visible,false), },
	
	--This is for the time based mod reader
	Def.BitmapText{
		Font="Common Normal",
		Text="test",
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'bgm';playcommand,"SetTime";visible,false);
		SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); mod_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
	}
}