char_muffet_deathtime = 4
			
char_muffet_pptr = 1;
char_muffet_particles = {}
function char_muffet_spawnparticle()
	local a = char_muffet_particles[char_muffet_pptr]
	
	if a then
		a.xspd = math.random(8)-4
		a.yspd = -(math.random(20)/10)
		a.active = true
		a.timer=0.7
		a.actor:visible(true);
		a.actor:x((math.random(90)-45))
		a.actor:y(char_muffet_spos:GetY())
		a.actor:zoom(3)
	end
	
	char_muffet_pptr = char_muffet_pptr+1
	if char_muffet_pptr > table.getn(char_muffet_particles) then
		char_muffet_pptr = 1
	end
end
				
MParticles = Def.ActorFrame{}

for i=1,100 do
	MParticles[#MParticles+1] = Def.Quad{
		OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self) table.insert(char_muffet_particles,{actor=self,xspd=0,yspd=0,timer=0,active=false}) end,
	}
end

local t = Def.ActorFrame{
	InitCommand=function(self) char_muffet=self; self:zoomx(3); self:zoomy(0); end,
	HideQCommand=cmd(zoomy,0;zoomx,3;),
	SpawnQZCommand=cmd(z,1;zoom,1;),
	HideCommand=cmd(bouncebegin,0.2;zoomy,0;zoomx,3;),
	SpawnCommand=cmd(z,0;bounceend,0.3;zoom,1;),
	SpawnQCommand=cmd(z,0;zoom,1;),
}

	t[#t+1] = Def.ActorFrame{
		OnCommand=cmd(zoom,1),
		KillCommand=cmd(visible,false),
		LoadActor("muffet/leg")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
			OnCommand=cmd(x,-9;y,74),
		},
		LoadActor("muffet/leg")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
			OnCommand=cmd(x,9;y,74;zoomx,-1),
		},
		
		Def.ActorFrame{
			OnCommand=cmd(wag;effectperiod,8;effectclock,"bgm";effectmagnitude,0,0,5),
			Def.ActorFrame{
				OnCommand=cmd(x,1;bob;effectperiod,4;effectclock,"bgm";effectmagnitude,0,-4,0), 
				Def.ActorFrame{
					OnCommand=cmd(x,-36;y,-85;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-30;),
					LoadActor("muffet/hair")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(x,-11;y,-1),
					},
				},
				Def.ActorFrame{
					OnCommand=cmd(x,36;y,-85;zoomx,-1;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,30;),
					LoadActor("muffet/hair")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(x,-11;y,-1),
					},
				},
				LoadActor("muffet/head")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(x,-1;y,-56),
				},
				LoadActor("muffet/eye1")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(animate,0;x,-16;y,-58;queuecommand,"SetMe"),
					SetMeCommand=function(self) table.insert(muffet_eyes,self) end,
				},
				LoadActor("muffet/eye2")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(animate,0;x,-11;y,-72;queuecommand,"SetMe"),
					SetMeCommand=function(self) table.insert(muffet_eyes,self) end,
				},
				LoadActor("muffet/eye3")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(animate,0;y,-77;queuecommand,"SetMe"),
					SetMeCommand=function(self) table.insert(muffet_eyes,self) end,
				},
				LoadActor("muffet/eye2")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(animate,0;x,11;y,-72;zoomx,-1;queuecommand,"SetMe"),
					SetMeCommand=function(self) table.insert(muffet_eyes,self) end,
				},
				LoadActor("muffet/eye1")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(animate,0;x,16;y,-58;zoomx,-1;queuecommand,"SetMe"),
					SetMeCommand=function(self) table.insert(muffet_eyes,self) end,
				},
			},
			
			Def.ActorFrame{
				OnCommand=cmd(y,-1;bob;effectperiod,4;effectclock,"bgm";effectmagnitude,0,-2,0;effectoffset,1),
				LoadActor("muffet/arm2a")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(x,-25;y,17;),
				},
				Def.ActorFrame{
					OnCommand=cmd(x,-36;y,25;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,4;),
					LoadActor("muffet/arm2b")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(x,-12;y,-11;),
					},
					Def.ActorFrame{
						OnCommand=cmd(x,-24;y,-22;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-25;),
						LoadActor("muffet/hand2")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
							OnCommand=cmd(x,-21;y,-1;),
						},
					},
				},
				LoadActor("muffet/arm2a")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(x,25;y,17;zoomx,-1;),
				},
				Def.ActorFrame{
					OnCommand=cmd(x,36;y,25;zoomx,-1;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-4;),
					LoadActor("muffet/arm2b")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(x,-12;y,-11;),
					},
					Def.ActorFrame{
						OnCommand=cmd(x,-24;y,-22;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,25;),
						LoadActor("muffet/hand2")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
							OnCommand=cmd(x,-21;y,-1;),
						},
					},
				},
			},
			
			Def.ActorFrame{ OnCommand=cmd(bob;effectperiod,4;effectclock,"bgm";effectmagnitude,0,-1,0;effectoffset,1),
				LoadActor("muffet/arm1a")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(x,-18;y,-5;),
				},
				Def.ActorFrame{
					OnCommand=cmd(x,-32;y,6;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-6;),
					LoadActor("muffet/arm1b")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(x,-10;y,-15;),
					},
					Def.ActorFrame{
						OnCommand=cmd(x,-19;y,-33;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-4;),
						LoadActor("muffet/hand1")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
							OnCommand=cmd(x,-14;),
						},
					},
				},
				LoadActor("muffet/arm1a")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(x,18;y,-5;zoomx,-1;),
				},
				Def.ActorFrame{
					OnCommand=cmd(x,32;y,6;zoomx,-1;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-6;),
					LoadActor("muffet/arm1b")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(x,-10;y,-15;),
					},
					Def.ActorFrame{
						OnCommand=cmd(x,-19;y,-33;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-4;),
						LoadActor("muffet/hand1")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
							OnCommand=cmd(x,-14;),
						},
					},
				},
			},
		},
		
		Def.ActorFrame{ OnCommand=cmd(wag;effectperiod,8;effectclock,"bgm";effectmagnitude,0,0,-3),
			Def.ActorFrame{ OnCommand=cmd(bob;effectperiod,4;effectclock,"bgm";effectmagnitude,0,-1,0),
				Def.ActorFrame{ OnCommand=cmd(x,-19;y,20;zoomx,1;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,5;),
					LoadActor("muffet/arm3 2x1")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(animate,0;x,-9;y,29;queuecommand,"Anim0"),
						Anim0Command=cmd(setstate,1;sleep,m_bl*2-0.05;queuecommand,"Anim2"),
						Anim1Command=cmd(setstate,1;sleep,m_bl*2;queuecommand,"Anim2"),
						Anim2Command=cmd(setstate,0;sleep,m_bl*2;queuecommand,"Anim1"),
					},
				},
				Def.ActorFrame{ OnCommand=cmd(x,19;y,20;zoomx,-1;wag;effectperiod,4;effectclock,"bgm";effectmagnitude,0,0,-5;),
					LoadActor("muffet/arm3 2x1")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
						OnCommand=cmd(animate,0;x,-9;y,29;queuecommand,"Anim0"),
						Anim0Command=cmd(setstate,1;sleep,m_bl*2-0.05;queuecommand,"Anim2"),
						Anim1Command=cmd(setstate,1;sleep,m_bl*2;queuecommand,"Anim2"),
						Anim2Command=cmd(setstate,0;sleep,m_bl*2;queuecommand,"Anim1"),
					},
				},
			},
			LoadActor("muffet/pants")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
				OnCommand=cmd(y,30;bob;effectperiod,4;effectclock,"bgm";effectmagnitude,0,-1,0),
			},
		},
		
		LoadActor("muffet/bow")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
			OnCommand=cmd(x,-1;bob;effectperiod,4;effectclock,"bgm";effectmagnitude,0,-2,0),
		},
	
	}
		
	t[#t+1] = LoadActor("muffet/kill")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
		InitCommand=function(self) self:SetTextureFiltering(false); end,
		OnCommand=cmd(visible,false;),
		KillCommand=cmd(finishtweening;visible,true;diffusealpha,1;
		sleep,0.08;x,-20;sleep,0.08;x,20;sleep,0.08;x,-20;sleep,0.08;x,20;
		sleep,0.08;x,-10;sleep,0.08;x,10;sleep,0.08;x,-10;sleep,0.08;x,10;
		sleep,0.08;x,-5;sleep,0.08;x,5;sleep,0.08;x,-5;sleep,0.08;x,5;
		sleep,0.08;x,-3;sleep,0.08;x,3;sleep,0.08;x,-3;sleep,0.08;x,3;
		sleep,0.08;x,0;),
		DieCommand=cmd(finishtweening;croptop,-0.1;fadetop,0.1;diffusealpha,1;linear,1.5;croptop,1.1),
	}
	
	t[#t+1] = Def.Quad{
		InitCommand=function(self) self:y(-110); char_muffet_spos = self end,
		OnCommand=cmd(visible,false),
		DieCommand=cmd(finishtweening;y,-110;linear,1.5;y,110+30),
	}
	
	t[#t+1] = Def.Quad{
		DieCommand=function(self) char_muffet_updates = char_muffet_deathtime; self:queuecommand('Update') end,
		UpdateCommand=function(self)
			
			for i=1,table.getn(char_muffet_particles) do
				local a = char_muffet_particles[i]
				if a then
					if a.active then
						a.actor:addx(a.xspd)
						a.actor:addy(a.yspd)
						a.actor:diffusealpha(a.timer*1.5);
						a.yspd = a.yspd-0.02
						
						a.timer = a.timer-0.02;
						if a.timer<0 then
							a.active = false
						end
					else
						a.actor:visible(false)
					end
				end
			end
			
			if char_muffet_updates>char_muffet_deathtime-1.3 then
				for i=1,4 do
					char_muffet_spawnparticle()
				end
			end
			
			if char_muffet_updates>0 then
				char_muffet_updates = char_muffet_updates - 0.02
				self:sleep(0.02)
				self:queuecommand('Update')
			end
		end,
		OnCommand=cmd(visible,false),
	}
	
	t[#t+1] = MParticles

return t